#ifndef _SF_
#define _SF_
#define NBIN 500
#define MAXL 512

typedef struct 
{
    float a;
    float b;
    float c;
    float alpha;
    float beta;
    float gamma;
    char sym[20];
    int nsym;
}CRYST;


void check_input_error(int argc,char **argv,char *out,
                       char *init_ID,char *ref_ID);
void write_refl_imgcif(FILE *fout, int argc, char **argv);
void read_imgCIF_header(FILE *fout, char *infile);
void cifparse(char *iFile);
void usage();
void merge_I_F(int argc, char **argv);
void cryst_infor(FILE *fout, char *blockid);
int  cif_or_mmcif(char *inpfile);
void sf_header(FILE *fout, int status,int F, int I, int IP );
void write_sf_header(FILE *fout, char *prog,char *blockid, int format);
void sf_data_header(FILE *fout, int I_F_type, int status );


// sf_refine
void write_refl_refine(FILE *fout,int argc,char **argv);
void write_sf_mmcif(FILE *fout, char *infile, char *blockid);
void cns2mmcif(FILE *fout,  char *inpfile);
void shelx2mmcif(FILE *fout,  char *inpfile, char *type);
void tnt2mmcif(FILE *fout,  char *inpfile);
void epmr2mmcif(FILE *fout,  char *inpfile,char *type);
void cif2mmcif(FILE *fout, char *inpfile) ;
void write_new_mmcif(FILE *fout, int n, char **item, int *index, char **line);
void get_item_index(int n, char **item, int index[]);
void shelx_cif2mmcif(FILE *fout, char *infile); //disabled at the moment
void mtz2mmcif(FILE *fout, char *filename) ;
void print_labin(FILE *finp,char *sffile);
void reformat_mtz_output(char *inpfile);
void write_loop(FILE *ftmp, FILE *fout);


// sf_initial 

void write_refl_initial(FILE *fout, int argc, char **argv);
void write_data(FILE *fout, int ncryst, int nwave, int scale,
                char *filename, char *prog, char *I_F_type, int format);
int  data_format(char *filename, char *prog);
void write_hkl(FILE *fout, char *filename,
               int crystal, int wave, int scale, int format);
void write_dtrek(FILE *fout, char *filename,
               int crystal, int wave, int scale, int format);
void write_xscale(FILE *fout, char *filename,
              int crystal, int wave,int scale, int format);
void write_saint(FILE *fout, char *filename,
               int crystal, int wave, int scale, int format);
void write_other(FILE *fout,char *filename,int ncryst, int nwave, int scale);

// 


#endif

