/*
FILE:     ccp4.C
*/
/*
VERSION:  3.004
*/
/*
DATE:     9/11/2007
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2007 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/*  a program to extract information form the CCP4 program */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "structure.h"
#include "harv.h"
#include "nrutil.h"
#include "util.h"


int detect_if_new_or_old(char **lines, int nline);
void rewrite_new_refmac_cif(FILE *fout, char *inpfile);
void rewrite_old_refmac_cif(FILE *fout, char *inpfile);
void rewrite_refmac_cif(FILE *fout,char **lines, int nline);
void get_loop(FILE *fout, char **line, int nline, const char **category, int nc);
void extract_refmac_log(FILE *fout, char *inpfile);
void convert_restr_refmac5_cif(char *str);
void write_tls(FILE *fout);
void extract_refmac_log_tls(char *infile);


extern int  NTLS, NTLS_GROUP;


//PHASING_MIR  phasing_mir ;
extern  CELL cell ;
extern SYMMETRY symmetry;

extern REFINE refine;


extern PDBX_REFINE_TLS pdbx_refine_tls_single;
extern PDBX_REFINE_TLS_GROUP pdbx_refine_tls_group_single;
extern PDBX_REFINE_TLS_GROUP pdbx_refine_tls_group[500];
extern PDBX_REFINE_TLS pdbx_refine_tls[100];




void CCP4_ref_refmac5(FILE *fout, char *inpfile, char *file_format,char *method)
/* assign the files (from refinement) to different subroutines */
{
    char  **lines;
    int  nline=0;
    
 
    if(strstr(file_format, "PDB")) {
       pdb_2_cif(fout, inpfile);
    }else if (strstr(file_format, "CIF")) {
        if(is_cif(inpfile)< 5) {
            printf("The input file (%s) for refmac5 is not in mmCIF format",inpfile);
            return;
        }
        
        lines = get_lines_from_file(inpfile, &nline);
        
        rewrite_refmac_cif(fout,lines, nline);
        if(nline>0)free_memory_2d(lines, nline);
        
/*        
        id= detect_if_new_or_old(lines,nline);
        if(id==0) {
            rewrite_old_refmac_cif(fout,inpfile);
        }else if(id==1) { 
            rewrite_new_refmac_cif(fout,inpfile);
        }else{
            write_cif(fout,  inpfile, method); 
        }
       
*/
    }else if(strstr(file_format, "LOG")) {
        extract_refmac_log(fout,inpfile);
//        extract_refmac_log_tls(inpfile);
        if(NTLS>0) write_tls(fout);
        
    }
}


void extract_refmac_log_tls(char *infile)
// some problem
{
    char **line, tls_detail[512], tmp[256],ch1[80],seg1[80], ch2[80],seg2[80], id[80];
    int  ntls=0, nline=0, i, j,k, key=0, group=0,ncomp=0;
    char **component=NULL;


    line=get_lines_from_file(infile, &nline);
    for(i=0; i<nline-4; i++){
        if(strstr(line[i+0], "RANGE ") && strstr(line[i+1], "ORIGIN ") &&
           strstr(line[i+2], "T ") && strstr(line[i+3], "L ") &&
           strstr(line[i+4], "S ")){
            key=1;
            break;
        }
    }
    if(key==0){
        printf("Warnning, I can not find the pattern RANGE ORIGIN T L S\n");
        if(nline)free_memory_2d(line, nline);
        return;
    }
    group=0;
    ntls=0;
    for(i=0; i<nline-4; i++){
        if(strstr(line[i+0], "TLS ") &&
           pattern5(line[i+1], "RANGE ", "'", "'", "'",  "'")){//check further
            
            key=0;
            strcpy(tmp, line[i+2]);
            
            if(pattern5(line[i+2], "RANGE ", "'", "'", "'",  "'") || 
               pattern5(tmp, "ORIGIN ", ".", ".", ".", "") ){
                key=1;
            }
            
            
            if(key!=1) continue; // Not a TLS pattern
                
            ncomp = 0;
            component=new char *[50];
            for(j=i; j<nline-4; j++){
                if(strstr(line[j], "TLS ")){
                    strcpy(tmp, strstr(line[j],"TLS ")+4 );
                    rid_of_front_end_space(tmp);
                    strcpy(tls_detail, tmp);
                    
                }else if(pattern5(line[j], "RANGE ", "'", "'", "'",  "'")){
                    
                    component[ncomp] = new char [81];
                    strcpy(component[ncomp], line[j]);
                    ncomp++;
                }else if(strstr(line[j+0], "ORIGIN ") && strstr(line[j+1], "T ")
                         && strstr(line[j+2], "L ") && strstr(line[j+3], "S ")){
                    
//                    printf("line=%s%s%s%s\n", line[j+0],line[j+1],line[j+2],line[j+3]);
                    
                    strcpy(tmp, strstr_case(line[j+0],"ORIGIN ")+7 );
                    if(sscanf(tmp, "%f%f%f",
                                  &pdbx_refine_tls_single.origin_x, 
                                  &pdbx_refine_tls_single.origin_y, 
                                  &pdbx_refine_tls_single.origin_z) !=3 ) continue;
                        
                    strcpy(tmp, strstr(line[j+1],"T  ")+3 );
                    if(sscanf(tmp, "%f%f%f%f%f%f",
                              &pdbx_refine_tls_single.T11,
                              &pdbx_refine_tls_single.T22,
                              &pdbx_refine_tls_single.T33,
                              &pdbx_refine_tls_single.T12,
                              &pdbx_refine_tls_single.T13,
                              &pdbx_refine_tls_single.T23)!=6 ) continue;

                    strcpy(tmp, strstr(line[j+2],"L  ")+3 );
                    if(sscanf(tmp, "%f%f%f%f%f%f",
                              &pdbx_refine_tls_single.L11,
                              &pdbx_refine_tls_single.L22,
                              &pdbx_refine_tls_single.L33,
                              &pdbx_refine_tls_single.L12,
                              &pdbx_refine_tls_single.L13,
                              &pdbx_refine_tls_single.L23)!=6 ) continue;
                   
                    strcpy(tmp, strstr(line[j+3],"S  ")+3 );
                    if(sscanf(tmp, "%f%f%f%f%f%f%f%f",
                              &pdbx_refine_tls_single.S22_S11,
                              &pdbx_refine_tls_single.S11_S33,
                              &pdbx_refine_tls_single.S12,
                              &pdbx_refine_tls_single.S13,
                              &pdbx_refine_tls_single.S23,
                              &pdbx_refine_tls_single.S21,
                              &pdbx_refine_tls_single.S31,
                              &pdbx_refine_tls_single.S32)==8 ){
                        pdbx_refine_tls_single.S11=(pdbx_refine_tls_single.S11_S33-pdbx_refine_tls_single.S22_S11)/3.0;
                        pdbx_refine_tls_single.S22=(2*pdbx_refine_tls_single.S22_S11+pdbx_refine_tls_single.S11_S33)/3.0;
                        pdbx_refine_tls_single.S33=-(pdbx_refine_tls_single.S22_S11+2*pdbx_refine_tls_single.S11_S33)/3.0;
                    }else
                        continue;

                    for(k=0; k<ncomp; k++){
                        group++;
                        strcpy(tmp, strstr(component[k], "RANGE ")+6);
                        rid_of_char(tmp, '\'');
                        
                        if(sscanf(tmp, "%s%s%s%s%s", ch1,seg1, ch2,seg2,id)!=5) continue;
                    
                        strcpy(pdbx_refine_tls_group_single.beg_label_asym_id, ch1);
                        strcpy(pdbx_refine_tls_group_single.beg_label_seq_id, seg1);
                        strcpy(pdbx_refine_tls_group_single.end_label_asym_id, ch2);
                        strcpy(pdbx_refine_tls_group_single.end_label_seq_id, seg2);
//                        strcpy(pdbx_refine_tls_group_single.selection, id);
                    
                        sprintf(pdbx_refine_tls_group_single.id,"%d", group);
                        sprintf(pdbx_refine_tls_group_single.refine_tls_id,"%d", ntls+1);

                        pdbx_refine_tls_group[group-1] = pdbx_refine_tls_group_single;

                    }

                    sprintf(pdbx_refine_tls_single.id, "%d", ntls+1);                    
                    strcpy(pdbx_refine_tls_single.details, tls_detail);
                    strcpy(pdbx_refine_tls_single.method, "refined");
                    
                    pdbx_refine_tls[ntls] = pdbx_refine_tls_single;
                    ntls++;

                    if(group>=500 || ntls>=100){
                        printf("Error! There are too many TLS groups\n");
                        return;
                    }
                    if(ncomp && component) free_memory_2d(component, ncomp);
                    
                    i=j+3;
                    break;
                }
            }
// next group
        }
    }
    
    printf("NTLS=%d, GROUP=%d, \n", ntls, group);
    NTLS=ntls;
    NTLS_GROUP=group;
    if(nline)free_memory_2d(line, nline);
    
}

 
void extract_refmac_log(FILE *fout, char *inpfile)
// correct way to extract
{
    
    char **line,tls_detail[256], str1[80],str2[80],str3[80],str4[80],str5[80],str6[80];
    int i,j, nline, ntls=0,group=0;

    line = get_lines_from_file(inpfile, &nline);
    
    strcpy(pdbx_refine_tls_single.details, "?");
    if(nline<5){
        return;
    }

    strcpy(tls_detail,"?");
    
    group=0;
    ntls=0;
    for(i=0;  i<nline-1; i++){

        if(group>=400 || ntls>=100){
            printf("Error! There are too many TLS groups\n");
            NTLS=0;
            NTLS_GROUP=0;
            return;
        }
            
        sscanf(line[i+0], "%s", str1);
        sscanf(line[i+1], "%s", str2);
        if(!strcmp_case(str1, "TLS") && !strcmp_case(str2, "RANGE")){
            get_data_set_id(line[i], "TLS", "\n", pdbx_refine_tls_single.details);
            
            for(j=i+1;  j<nline-3; j++){
                
                sscanf(line[j  ], "%s", str3);
                sscanf(line[j+1], "%s", str4);
                sscanf(line[j+2], "%s", str5);
                sscanf(line[j+3], "%s", str6);
                if(!strcmp_case(str3, "ORIGIN") && !strcmp_case(str4, "T") &&
                   !strcmp_case(str5, "L") && !strcmp_case(str6, "S")){ //extract T, L,S
                        
                
                    //  ORIGIN
                    pdbx_refine_tls_single.origin_x = get_float_by_length(line[j+0], 8,14);
                    pdbx_refine_tls_single.origin_y = get_float_by_length(line[j+0], 15,22);
                    pdbx_refine_tls_single.origin_z = get_float_by_length(line[j+0], 23,30);
                
                    //T
                    pdbx_refine_tls_single.T11=get_float_by_length(line[j+1], 4,11);
                    pdbx_refine_tls_single.T22=get_float_by_length(line[j+1], 12,19);
                    pdbx_refine_tls_single.T33=get_float_by_length(line[j+1], 20,27);
                    pdbx_refine_tls_single.T12=get_float_by_length(line[j+1], 28,35);
                    pdbx_refine_tls_single.T13=get_float_by_length(line[j+1], 36,43);
                    pdbx_refine_tls_single.T23=get_float_by_length(line[j+1], 44,51);
                
                    //L
                    pdbx_refine_tls_single.L11=get_float_by_length(line[j+2], 4,11);
                    pdbx_refine_tls_single.L22=get_float_by_length(line[j+2], 12,19);
                    pdbx_refine_tls_single.L33=get_float_by_length(line[j+2], 20,27);
                    pdbx_refine_tls_single.L12=get_float_by_length(line[j+2], 28,35);
                    pdbx_refine_tls_single.L13=get_float_by_length(line[j+2], 36,43);
                    pdbx_refine_tls_single.L23=get_float_by_length(line[j+2], 44,51);

                
                    //S
                    pdbx_refine_tls_single.S22_S11=get_float_by_length(line[j+3],  4,11);
                    pdbx_refine_tls_single.S11_S33=get_float_by_length(line[j+3], 12,19);
                    pdbx_refine_tls_single.S12=get_float_by_length(line[j+3], 20,27);
                    pdbx_refine_tls_single.S13=get_float_by_length(line[j+3], 28,35);
                    pdbx_refine_tls_single.S23=get_float_by_length(line[j+3], 36,43);
                    pdbx_refine_tls_single.S21=get_float_by_length(line[j+3], 44,51);
                    pdbx_refine_tls_single.S31=get_float_by_length(line[j+3], 52,59);
                    pdbx_refine_tls_single.S32=get_float_by_length(line[j+3], 60,67);


                        //get S11 S22 S33
                    pdbx_refine_tls_single.S11=(pdbx_refine_tls_single.S11_S33-pdbx_refine_tls_single.S22_S11)/3.0;
                    pdbx_refine_tls_single.S22=(2*pdbx_refine_tls_single.S22_S11+pdbx_refine_tls_single.S11_S33)/3.0;
                    pdbx_refine_tls_single.S33=-(pdbx_refine_tls_single.S22_S11+2*pdbx_refine_tls_single.S11_S33)/3.0;

                    j=j+4;

//                    printf("line= %2d %2d %s,::  %s,%s,%s,%s, ", j,ntls, line[j], str3,  str4,str5,str6);
                    
                    sprintf(pdbx_refine_tls_single.id, "%d", ntls+1);                    
                    strcpy(pdbx_refine_tls_single.details, tls_detail);
                    strcpy(pdbx_refine_tls_single.method, "refined");
                    pdbx_refine_tls[ntls] = pdbx_refine_tls_single;
                    ntls++;
                    break;
                    
                }else if(!strcmp_case(str3, "RANGE")){    // range: tls_group               
                    get_string(line[j], 8,9, pdbx_refine_tls_group_single.beg_label_asym_id);
                    get_string(line[j], 9,12,pdbx_refine_tls_group_single.beg_label_seq_id);
                    get_string(line[j], 17,18,pdbx_refine_tls_group_single.end_label_asym_id);
                    get_string(line[j], 18,21,pdbx_refine_tls_group_single.end_label_seq_id);

                    sprintf(pdbx_refine_tls_group_single.id,"%d", group+1);
                    sprintf(pdbx_refine_tls_group_single.refine_tls_id,"%d", ntls+1);

                    pdbx_refine_tls_group[group] = pdbx_refine_tls_group_single;
                    group++;
                   
                }else{
                    j=j-1;
                    break;
                }
            }
        }
    }
    
//    printf("Number of TLS=%d :: number of group=%d\n", ntls,group);
    
    if(ntls>0){
        NTLS=ntls;
        NTLS_GROUP=group;
        write_tls(fout);
    }
    

}
 

void rewrite_refmac_cif(FILE *fout,char **line, int nline)
{

    
    const char *categories[3]={
        "_refine_ls_shell",
        "_atom_type",
        "_atom_site"
    };

    get_loop(fout, line, nline, categories, 3);
    
}

void get_loop(FILE *fout, char **line, int nline, const char **category, int nc)
{

    int i, j,k, n, loop=0 ,c;
    char cate[80], item[80];
    FILE *ftmp=NULL;
    
    ftmp=tmpfile();
    

    for(i=0;  i<nline; i++){
        rid_of_front_space(line[i]);
        n=sscanf(line[i],"%s%s", cate, item);
        if(n==2){
            if(!strcmp(cate, "_refine.ls_matrix_type")){
                if(strchr(line[i], '"')){
                    refine.ls_matrix_type=get_substr(line[i], ":", "\"");
                }else
                    refine.ls_matrix_type=get_substr(line[i], ":", "'");
                
            }else if (!strcmp_case(cate, "_refine.B_iso_mean")){
                refine.B_iso_mean=atof(item);
            }else if (!strcmp_case(cate, "_refine.aniso_B[1][1]")){
                refine.aniso_B11=atof(item);
            }else if (!strcmp_case(cate, "_refine.aniso_B[2][2]")){
                refine.aniso_B22=atof(item);
            }else if (!strcmp_case(cate, "_refine.aniso_B[3][3]")){
                refine.aniso_B33=atof(item);
            }else if (!strcmp_case(cate, "_refine.aniso_B[1][2]")){
                refine.aniso_B12 =atof(item);
            }else if (!strcmp_case(cate, "_refine.aniso_B[1][3]")){
                refine.aniso_B13 =atof(item);
            }else if (!strcmp_case(cate, "_refine.aniso_B[2][3]")){
                refine.aniso_B23=atof(item);
            }else if (!strcmp_case(cate, "_refine.solvent_model_method") ){
                refine.solvent_model_details=get_substr(line[i], "\"", "\"");
            }else if (!strcmp_case(cate, "_refine.solvent_model_details") ){
                refine.solvent_model_details=get_substr(line[i], "'", "'");
                
            }else if (!strcmp_case(cate, "_refine.solvent_vdw_probe_radii")){
                refine.pdbx_solvent_vdw_probe_radii=atof(item);
            }else if (!strcmp_case(cate, "_refine.solvent_ion_probe_radii")){
                refine.pdbx_solvent_ion_probe_radii=atof(item);
            }else if (!strcmp_case(cate, "_refine.solvent_shrinkage_radii")){
                refine.pdbx_solvent_shrinkage_radii=atof(item);
            }else if (!strcmp_case(cate, "_refine.ls_d_res_high")){
                refine.ls_d_res_high=atof(item);
            }else if (!strcmp_case(cate, "_refine.ls_d_res_low")){
                refine.ls_d_res_low=atof(item);
            }else if (!strcmp_case(cate, "_refine.ls_number_reflns_R_work")){
                refine.ls_number_reflns_R_work=atoi(item);
            }else if (!strcmp_case(cate, "_refine.ls_number_reflns_R_free")){
                refine.ls_number_reflns_R_free=atoi(item);
            }else if (!strcmp_case(cate, "_refine.ls_R_factor_R_work")){
                refine.ls_R_factor_R_work=atof(item);
            }else if (!strcmp_case(cate, "_refine.ls_R_factor_R_free")){
                refine.ls_R_factor_R_free=atof(item);
            }else if (!strcmp_case(cate, "_refine.ls_R_factor_R_all")){
                refine.ls_R_factor_obs=atof(item);
            }else if (!strcmp_case(cate, "_refine.ls_wR_factor_R_work")){
                refine.ls_wR_factor_R_work=atof(item);
            }else if (!strcmp_case(cate, "_refine.ls_wR_factor_R_free")){
                refine.ls_wR_factor_R_free=atof(item);
            }else if (!strcmp_case(cate, "_refine.ls_percent_reflns_R_free")){
                refine.ls_percent_reflns_R_free=atof(item);
            }else if (!strcmp_case(cate, "_refine.ls_percent_reflns_obs")){
                refine.ls_percent_reflns_obs=atof(item);
            }else if (!strcmp_case(cate, "_refine.ls_Correlation_coeff_Fo_to_Fc")||
                      !strcmp_case(cate, "_refine.correlation_coeff_Fo_to_Fc")){
                refine.correlation_coeff_Fo_to_Fc=atof(item);
            }else if (strstr(cate, "_refine.ls_Correlation_coeff_Fo_to_Fc_Free") ||
                      strstr(cate, "_refine.correlation_coeff_Fo_to_Fc_free")){
                refine.correlation_coeff_Fo_to_Fc_free=atof(item);
            }else if (!strcmp_case(cate, "_refine.ls_Overall_ESU_R_Cruickshanks_DPI")||
                      !strcmp_case(cate, "_refine.pdbx_overall_ESU_R")){
                refine.pdbx_overall_ESU_R=atof(item);
            }else if (!strcmp_case(cate, "_refine.ls_Overall_ESU_Rfree") ||
                      !strcmp_case(cate, "_refine.pdbx_overall_ESU_R_Free")){
                refine.pdbx_overall_ESU_R_Free=atof(item);
            }else if (!strcmp_case(cate, "_refine.ls_Overall_ESU_ML")||
                      !strcmp_case(cate, "_refine.overall_SU_ML")||
                      !strcmp_case(cate, "_refine.pdbx_overall_ESU_ML")){
                refine.overall_SU_ML=atof(item);
            }else if (!strcmp_case(cate, "_refine.ls_Overall_ESU_B")||
                      !strcmp_case(cate, "_refine.pdbx_overall_ESU_B")){
                refine.overall_SU_B=atof(item);
            }
            
        }
    }
    
    for(i=0;  i<nline-1; i++){
        if(!strncmp_case(line[i], "loop_", 5) &&
           check_category(line[i+1], cate, item)>0){
            loop=0;
            for(k=0; k<nc; k++){
                if(!strcmp_case(cate, category[k])){
                    fprintf(ftmp,"loop_\n");
                    fprintf(ftmp,"%s", line[i+1]);
                
                    for(j=i+2;  j<nline-1; j++){
                        if(!strncmp_case(line[j], "loop_", 5)) {
                            i=j-1;
                            loop=1;
                            break;
                        }
                        
                        n=check_category(line[j], cate, item);
                        if(n>0 && strcmp(cate, category[k])) {
                            i=j-1;
                            loop=1;
                            break;
                        }
                        fprintf(ftmp,"%s", line[j]);
                    }
                    if(loop==1) break;
                }
            }
        } 
    }
    rewind(ftmp);
    while((c=getc(ftmp))!=EOF){
        fprintf(fout,"%c", c);
    }
    fclose(ftmp);
    
}

    

int detect_if_new_or_old(char **lines, int nline)
//=0 the old; =1 the new.
{
    int i=0,j=0, n1=-1, n2=-1, n3=-1;
    
    for(i=0; i<nline-1; i++){
        rid_of_front_space(lines[i]);
        if(!strncmp(lines[i], "_refine.", 8)){
            n1=1;
            j=i+1;
            break;
            
        }
    }
    
    for(i=j; i<nline-1; i++){
        rid_of_front_space(lines[i]);
        if(!strncmp(lines[i+1], "_cell", 5) || !strncmp(lines[i+1], "_atom_type.", 11)){
            n2=1;
            j=i+1;
            break;
            
        }
    }
    
    for(i=j; i<nline-1; i++){
        rid_of_front_space(lines[i]);
        if(!strncmp(lines[i], "_refine.", 8)){
            n3=1;
            break;
            
        }
    }

    if(n1>0 && n2>0 && n3>0) {
        return 0;
    }else
        return 1;
}

    
void rewrite_new_refmac_cif(FILE *fout, char *inpfile)
{
    char str[512],tmp[512], category[100],item[100];
    int k=0;
    FILE *fp;
    
    if((fp = fopen(inpfile, "r"))==NULL) 
        open_file_error(inpfile,"rewrite_new_refmac_cif");
        
    k=0;
    while (fgets(str, sizeof str, fp) != NULL) {
            
        rid_of_front_space(str);
        if(str[0] !='#') k++;
        if(k==1 && !strncmp_case(str,"data_",5)) continue;
            
        check_category(str, category, item);
        if(strlen(category)>0 && strlen(item)>0 ){
            if(!strcmp_case(category, "_entry") ||
               !strcmp_case(category, "_diffrn") ||
               !strcmp_case(category, "_audit") ||
               !strcmp_case(category, "_software") ||
               !strcmp_case(category, "_computing") ) {
                continue; 
            }else if(!strcmp_case(category,"_refine") &&
                    !strcmp_case(item,"ls_R_factor_R_all") ){
                replace_first_str(str,"ls_R_factor_R_all", "ls_R_factor_obs",  tmp);
                strcpy(str, tmp);

                
            }else if(!strcmp_case(category,"_refine") && !strcmp_case(item,"pdbx_overall_ESU_ML")){
                replace_first_str(str,"pdbx_overall_ESU_ML", "overall_SU_ML",  tmp);
                strcpy(str, tmp);
            }else if(!strcmp_case(category,"_refine") && !strcmp_case(item,"pdbx_overall_ESU_B")){
                replace_first_str(str,"pdbx_overall_ESU_B", "overall_SU_B",  tmp);
                strcpy(str, tmp);

                
                    
            }else if(!strcmp_case(category,"_refine_ls_shell") &&
                    !strcmp_case(item,"R_factor_R_all") ){
                replace_first_str(str,"R_factor_R_all", "R_factor_all",  tmp);
                strcpy(str, tmp);
                    
            }else if(strstr(category,"ccp4") || strstr(item,"ccp4")){
                replace_first_str(str,"ccp4", "pdbx",  tmp);
                strcpy(str, tmp);
                
            }
        }
        strstr(str,"\n") ?  fprintf(fout,"%s", str ) : fprintf(fout,"%s\n", str );
    }
    fclose(fp);
    
}

    
void rewrite_old_refmac_cif(FILE *fout, char *inpfile)
{
    char str[512],tmp[512], category[100],item[100];
    int k=0;
    
    FILE *fp;
    
    if((fp = fopen(inpfile, "r"))==NULL) 
        open_file_error(inpfile,"rewrite_old_refmac_cif");
        
    k=0;
    while (fgets(str, sizeof str, fp) != NULL) {
            
        rid_of_front_space(str);
        if(str[0] !='#') k++;
        
        if(k==1 && !strncmp_case(str,"data_",5)) continue;
            
        check_category(str, category, item);

        if(strlen(category)>0 && strlen(item)>0 ){
            if(!strcmp_case(category, "_entry") ||
               !strcmp_case(category, "_refine") ||
               !strcmp_case(category, "_diffrn") ||
               !strcmp_case(category, "_audit") ||
               !strcmp_case(category, "_software") ||
               !strcmp_case(category, "_computing") ) {
                continue;
                    
            }else if(!strcmp_case(category,"_refine_ls_shell") &&
                    !strcmp_case(item,"R_factor_R_all") ){
                replace_first_str(str,"R_factor_R_all", "R_factor_all",  tmp);
                strcpy(str, tmp);
                    
            }else if(strstr(category,"ccp4") || strstr(item,"ccp4")){
                replace_first_str(str,"ccp4", "pdbx",  tmp);
                strcpy(str, tmp);
                
            }
        }
        if(strstr_space(str,"\"Bond distances: refined atoms  \"")) {
            replace_first_str(str,"Bond distances: refined atoms  ", "r_bond_refined_d",  tmp);
            strcpy(str, tmp);
            
        }else if(strstr_space(str,"\"Bond angles  : refined atoms  \"")) {
            replace_first_str(str,"Bond angles  : refined atoms ", "r_angle_refined_deg",  tmp);
            strcpy(str, tmp);
            
        }else if(strstr_space(str,"\"Torsion angles, period  1. refined \"")) {
            replace_first_str(str,"Torsion angles, period  1. refined ", "r_dihedral_angle_1_deg",  tmp);
            strcpy(str, tmp);

        }else if(strstr_space(str,"\"Torsion angles, period  2. refined \"")) {
            replace_first_str(str,"Torsion angles, period  2. refined ", "r_dihedral_angle_2_deg",  tmp);
            strcpy(str, tmp);

        }else if(strstr_space(str,"\"Torsion angles, period  3. refined \"")) {
            replace_first_str(str,"Torsion angles, period  3. refined ", "r_dihedral_angle_3_deg",  tmp);
            strcpy(str, tmp);

        }else if(strstr_space(str,"\"Torsion angles, period  4. refined \"")) {
            replace_first_str(str,"Torsion angles, period  4. refined ", "r_dihedral_angle_4_deg",  tmp);
            strcpy(str, tmp);

        }else if(strstr_space(str,"\"Chiral centres: refined atoms \"")) {
            replace_first_str(str,"Chiral centres: refined atoms ", "r_chiral_restr",  tmp);
            strcpy(str, tmp);
            
        }else if(strstr_space(str,"\"Planar groups: refined atoms \"")) {
            replace_first_str(str,"Planar groups: refined atoms ", "r_gen_planes_refined",  tmp);
            strcpy(str, tmp);

        }else if(strstr_space(str,"\"VDW repulsions: refined atoms       \"")) {
            replace_first_str(str,"VDW repulsions: refined atoms ", "r_nbd_refined",  tmp);
            strcpy(str, tmp);
            
        }else if(strstr_space(str,"\"VDW; torsion: refined atoms      \"")) {
            replace_first_str(str,"VDW; torsion: refined atoms ", "r_nbtor_refined",  tmp);
            strcpy(str, tmp);
            
        }else if(strstr_space(str,"\"HBOND: refined atoms                 \"")) {
            replace_first_str(str,"HBOND: refined atoms ", "r_xyhbond_nbd_refined",  tmp);
            strcpy(str, tmp);
            
        }else if(strstr_space(str,"\"VDW repulsions; symmetry: refined atoms \"")) {
            replace_first_str(str,"VDW repulsions; symmetry: refined atoms", "r_symmetry_vdw_refined",  tmp);
            strcpy(str, tmp);
            
        }else if(strstr_space(str,"\"HBOND; symmetry: refined atoms       \"")) {
            replace_first_str(str,"HBOND; symmetry: refined atoms ", "r_symmetry_hbond_refined",  tmp);
            strcpy(str, tmp);


        }else if(strstr_space(str,"\"M. chain bond B values: refined atoms   \"")) {
            replace_first_str(str,"M. chain bond B values: refined atoms  ", "r_mcbond_it",  tmp);
            strcpy(str, tmp);
            
        }else if(strstr_space(str,"\"M. chain angle B values: refined atoms \"")) {
            replace_first_str(str,"M. chain angle B values: refined atoms ", "r_mcangle_it",  tmp);
            strcpy(str, tmp);

        }else if(strstr_space(str,"\"S. chain bond B values: refined atoms  \"")) {
            replace_first_str(str,"S. chain bond B values: refined atoms ", "r_scbond_it",  tmp);
            strcpy(str, tmp);
            
        }else if(strstr_space(str,"\"S. chain angle B values: refined atoms \"")) {
            replace_first_str(str,"S. chain angle B values: refined atoms ", "r_scangle_it",  tmp);
            strcpy(str, tmp);
        }
        
        strstr(str,"\n") ?  fprintf(fout,"%s", str ) : fprintf(fout,"%s\n", str );
    }

    fprintf(fout,"\n#\n");
    rewind(fp);

    while (fgets(str, sizeof str, fp) != NULL) { //only _refine.
        check_category(str, category, item);
        if(!strcmp_case(category,"_refine")&& strlen(item)>0  ){
            
            if( !strcmp_case(item,"ls_R_factor_R_all") ){
                replace_first_str(str,"ls_R_factor_R_all", "ls_R_factor_obs",  tmp);
                strcpy(str, tmp);
                
            }else if(!strcmp_case(item,"ls_Overall_ESU_R_Cruickshanks_DPI")){
                replace_first_str(str,"ls_Overall_ESU_R_Cruickshanks_DPI", "pdbx_overall_ESU_R",  tmp);
                strcpy(str, tmp);
                
            }else if(!strcmp_case(item,"ls_Overall_ESU_Rfree")){
                replace_first_str(str,"ls_Overall_ESU_Rfree", "pdbx_overall_ESU_R_Free",  tmp);
                strcpy(str, tmp);
                
            }else if(!strcmp_case(item,"ls_Overall_ESU_ML")){
                replace_first_str(str,"ls_Overall_ESU_ML", "overall_SU_ML",  tmp);
                strcpy(str, tmp);
                
            }else if(!strcmp_case(item,"ls_Overall_ESU_B")){
                replace_first_str(str,"ls_Overall_ESU_B", "overall_SU_B",  tmp);
                strcpy(str, tmp);
               
                
            }else if(!strcmp_case(item,"ls_Correlation_coeff_Fo_to_Fc")){
                replace_first_str(str,"ls_Correlation_coeff_Fo_to_Fc", "correlation_coeff_Fo_to_Fc",  tmp);
                strcpy(str, tmp);
                
                
            }else if(!strcmp_case(item,"ls_Correlation_coeff_Fo_to_Fc_Free")){
                replace_first_str(str,"ls_Correlation_coeff_Fo_to_Fc_Free", "correlation_coeff_Fo_to_Fc_free",  tmp);
                strcpy(str, tmp);
                
                
            }
            strstr(str,"\n") ?  fprintf(fout,"%s", str ) : fprintf(fout,"%s\n", str );
            
        }
    
    }
    fclose(fp);  
}

void convert_restr_refmac5_cif(char *str)
{
    char *param, stand[40], tmp[60], *str_old=NULL;
    int i;
    
    static const char *refmac_cif_33[] = {

            "r_bond_refined_d           ,BOND LENGTHS REFINED ATOMS        (A),,",
            "r_bond_other_d             ,BOND LENGTHS OTHERS               (A),,", 
            "r_angle_refined_deg        ,BOND ANGLES REFINED ATOMS   (DEGREES),,", 
            "r_angle_other_deg          ,BOND ANGLES OTHERS          (DEGREES),,", 
            "r_dihedral_angle_1_deg     ,TORSION ANGLES, PERIOD 1    (DEGREES),,", 
            "r_dihedral_angle_2_deg     ,TORSION ANGLES, PERIOD 2    (DEGREES),,", 
            "r_dihedral_angle_3_deg     ,TORSION ANGLES, PERIOD 3    (DEGREES),,", 
            "r_dihedral_angle_4_deg     ,TORSION ANGLES, PERIOD 4    (DEGREES),,", 
            "r_chiral_restr             ,CHIRAL-CENTER RESTRAINTS       (A**3),,", 
            "r_gen_planes_refined       ,GENERAL PLANES REFINED ATOMS      (A),,", 
            "r_gen_planes_other         ,GENERAL PLANES OTHERS             (A),,", 
            "r_nbd_refined              ,NON-BONDED CONTACTS REFINED ATOMS (A),,", 
            "r_nbd_other                ,NON-BONDED CONTACTS OTHERS        (A),,", 
            "r_nbtor_refined            ,NON-BONDED TORSION REFINED ATOMS  (A),,", 
            "r_nbtor_other              ,NON-BONDED TORSION OTHERS         (A),,", 
            "r_xyhbond_nbd_refined      ,H-BOND (X...Y) REFINED ATOMS      (A),,", 
            "r_xyhbond_nbd_other        ,H-BOND (X...Y) OTHERS             (A),,", 
            "r_metal_ion_refined        ,POTENTIAL METAL-ION REFINED ATOMS (A),,", 
            "r_metal_ion_other          ,POTENTIAL METAL-ION OTHERS        (A),,",  
            "r_symmetry_vdw_refined     ,SYMMETRY VDW REFINED ATOMS        (A),,", 
            "r_symmetry_vdw_other       ,SYMMETRY VDW OTHERS               (A),,", 
            "r_symmetry_hbond_refined   ,SYMMETRY H-BOND REFINED ATOMS     (A),,", 
            "r_symmetry_hbond_other     ,SYMMETRY H-BOND OTHERS            (A),,", 
            "r_symmetry_metal_ion_refined ,SYMMETRY METAL-ION REFINED ATOMS  (A),,", 
            "r_symmetry_metal_ion_other ,SYMMETRY METAL-ION OTHERS         (A),,", 
            "r_mcbond_it                ,MAIN-CHAIN BOND REFINED ATOMS  (A**2),,", 
            "r_mcangle_it               ,MAIN-CHAIN ANGLE REFINED ATOMS (A**2),,", 
            "r_mcbond_other             ,MAIN-CHAIN BOND OTHER ATOMS    (A**2),,", 
            "r_scbond_it                ,SIDE-CHAIN BOND REFINED ATOMS  (A**2),,", 
            "r_scangle_it               ,SIDE-CHAIN ANGLE REFINED ATOMS (A**2),,", 
            "r_rigid_bond_restr         ,RIGID-BOND RESTRAINTS          (A**2),,", 
            "r_sphericity_free          ,SPHERICITY; FREE ATOMS         (A**2),,",   
            "r_sphericity_bonded        ,SPHERICITY; BONDED ATOMS       (A**2) "

    };
    
    str_old=str;
    for(i=0;i<33;i++){
        if(sscanf(refmac_cif_33[i], "%s", stand) != 1 ) continue;
        strcpy(tmp , refmac_cif_33[i] + strlen(stand)+1);
        param = get_substr(tmp, ",", ",,");
        rid_of_front_end_space(param);

        if(strstr_case(str, param)){
            replace_first_str(str_old, param, stand, str);
            break;
        }
    }
 
}
void CCP4_ref_restrain(FILE *fout, char inpfile[], char *file_format,
                          char method[])
/* assign the files (from refinement) to different subroutines */
{
    char str[512], tmp[512];
    int k;
    
    FILE *fp;
    
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (routine:CCP4_ref_restrain)\n",inpfile);
        return;
    }

    if(strstr(file_format, "PDB")){
        pdb_2_cif(fout,  inpfile);
    
    }else if (strstr(file_format, "CIF")) {
        if( is_cif(inpfile)< 5) {
            printf("The input file (%s) for restrain is not in mmCIF format",inpfile);
            return;
        }
        
        k=0;
        while (fgets(str, sizeof str, fp) != NULL) {  
            strcpy(tmp, str);
            rid_of_front_space(tmp);
            if(tmp[0] !='#') k++;
            if(k==1 && !strncmp_case(tmp,"data_",5)) continue;
            fprintf(fout,"%s", str );
        }
    }else if(strstr(file_format, "LOG")) {
        printf("RESTRAIN produce a CIF file containing statistics. Please\n");
        printf("give the file name (use option -iCIF file_name).\n");
        return;
    }
    fclose(fp);
    
}
/*
void CCP4_ref_restrain_log(FILE *fout, char inpfile[], char method[])
{

}
*/


