/*
FILE:     cns.C
*/
/*
VERSION:  3.004
*/
/*
DATE:     9/11/2007
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2007 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/*  a program to extract information form the CNS program */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "TableFile.h"
#include "CifFile.h"
#include "CifParserBase.h"
#include "structure.h"
#include "harv.h"
#include "util.h"

# define MAXL 512

extern REFINE_LS_SHELL refine_ls_shell;
extern REFINE refine;
extern PDBX_TWIN pdbx_twin;

extern STRUCT_NCS_DOM struct_ncs_dom[20];
extern STRUCT_NCS_DOM_LIM struct_ncs_dom_lim[500];
extern REFINE_LS_RESTR_NCS refine_ls_restr_ncs[500];
extern REFLNS reflns;

extern int NCS, NLIM, NNCS;
void clean_str(char *str);
void phenix_log_ncs(FILE *fout, int start, char **line, int nline);
void get_cns_ncs(FILE *fout, char **line, int nline);

void write_ncs_tls_head(FILE *fout, const char *cate)
{
    if(!strcmp(cate,"_struct_ncs_oper")){
        fprintf(fout,"loop_ \n"); 
        fprintf(fout,"%s.id  \n",cate); 
        fprintf(fout,"%s.matrix[1][1]  \n",cate);
        fprintf(fout,"%s.matrix[1][2]  \n",cate);
        fprintf(fout,"%s.matrix[1][3]  \n",cate);
        fprintf(fout,"%s.matrix[2][1]  \n",cate);
        fprintf(fout,"%s.matrix[2][2]  \n",cate);
        fprintf(fout,"%s.matrix[2][3]  \n",cate);
        fprintf(fout,"%s.matrix[3][1]  \n",cate);
        fprintf(fout,"%s.matrix[3][2]  \n",cate);
        fprintf(fout,"%s.matrix[3][3]  \n",cate);
        fprintf(fout,"%s.vector[1]     \n",cate);
        fprintf(fout,"%s.vector[2]     \n",cate); 
        fprintf(fout,"%s.vector[3]     \n",cate);
        
    }else if(!strcmp(cate,"_refine_ls_restr_ncs")){
        fprintf(fout,"loop_ \n"); 
        fprintf(fout,"%s.dom_id  \n",cate); 
        fprintf(fout,"%s.pdbx_type  \n",cate); 
        fprintf(fout,"%s.pdbx_asym_id  \n",cate); 
        fprintf(fout,"%s.pdbx_number  \n",cate); 
        fprintf(fout,"%s.pdbx_rms  \n",cate); 
        fprintf(fout,"%s.pdbx_weight  \n",cate);
        
    }else if(!strcmp(cate,"_struct_ncs_dom")){
        fprintf(fout,"loop_ \n"); 
        fprintf(fout,"%s.id  \n",cate); 
        fprintf(fout,"%s.details  \n",cate);
        
    }else if(!strcmp(cate,"_struct_ncs_dom_lim")){
        fprintf(fout,"loop_ \n"); 
        fprintf(fout,"%s.dom_id\n",cate);
        fprintf(fout,"%s.pdbx_component\n",cate);
        
        fprintf(fout,"%s.beg_label_asym_id\n",cate);
        fprintf(fout,"%s.beg_label_seq_id\n",cate);
        fprintf(fout,"%s.end_label_asym_id\n",cate);
        fprintf(fout,"%s.end_label_seq_id\n",cate);
        fprintf(fout,"%s.pdbx_refine_code\n",cate);
        
        fprintf(fout,"%s.beg_label_alt_id\n",cate);
        fprintf(fout,"%s.end_label_alt_id\n",cate);
        fprintf(fout,"%s.beg_label_comp_id\n",cate);
        fprintf(fout,"%s.end_label_comp_id\n",cate);
        
        fprintf(fout,"%s.beg_auth_asym_id\n",cate);
        fprintf(fout,"%s.beg_auth_seq_id\n",cate);
        fprintf(fout,"%s.end_auth_asym_id\n",cate);
        fprintf(fout,"%s.end_auth_seq_id\n",cate);
        
    }else if(!strcmp(cate,"_pdbx_refine_tls_group")){
        fprintf(fout,"#\n");
        fprintf(fout,"loop_\n");
        fprintf(fout,"_pdbx_refine_tls_group.id\n");
        fprintf(fout,"_pdbx_refine_tls_group.refine_tls_id\n");
        fprintf(fout,"_pdbx_refine_tls_group.beg_label_asym_id\n");
        fprintf(fout,"_pdbx_refine_tls_group.beg_label_seq_id\n");
        fprintf(fout,"_pdbx_refine_tls_group.end_label_asym_id\n");
        fprintf(fout,"_pdbx_refine_tls_group.end_label_seq_id\n");
        fprintf(fout,"_pdbx_refine_tls_group.selection\n");
        
    }else if(!strcmp(cate,"_pdbx_refine_tls")){
        fprintf(fout,"#\n");
        fprintf(fout,"loop_\n");
        fprintf(fout,"_pdbx_refine_tls.id\n");
        fprintf(fout,"_pdbx_refine_tls.details\n");
        fprintf(fout,"_pdbx_refine_tls.method\n");
        fprintf(fout,"_pdbx_refine_tls.origin_x\n");
        fprintf(fout,"_pdbx_refine_tls.origin_y\n");
        fprintf(fout,"_pdbx_refine_tls.origin_z\n");
        fprintf(fout,"_pdbx_refine_tls.T[1][1]\n");
        fprintf(fout,"_pdbx_refine_tls.T[2][2]\n");
        fprintf(fout,"_pdbx_refine_tls.T[3][3]\n");
        fprintf(fout,"_pdbx_refine_tls.T[1][2]\n");
        fprintf(fout,"_pdbx_refine_tls.T[1][3]\n");
        fprintf(fout,"_pdbx_refine_tls.T[2][3]\n");
        fprintf(fout,"_pdbx_refine_tls.L[1][1]\n");
        fprintf(fout,"_pdbx_refine_tls.L[2][2]\n");
        fprintf(fout,"_pdbx_refine_tls.L[3][3]\n");
        fprintf(fout,"_pdbx_refine_tls.L[1][2]\n");
        fprintf(fout,"_pdbx_refine_tls.L[1][3]\n");
        fprintf(fout,"_pdbx_refine_tls.L[2][3]\n");
        fprintf(fout,"_pdbx_refine_tls.S[1][1]\n");
        fprintf(fout,"_pdbx_refine_tls.S[2][2]\n");
        fprintf(fout,"_pdbx_refine_tls.S[3][3]\n");
        fprintf(fout,"_pdbx_refine_tls.S[1][2]\n");
        fprintf(fout,"_pdbx_refine_tls.S[1][3]\n");
        fprintf(fout,"_pdbx_refine_tls.S[2][3]\n");
        fprintf(fout,"_pdbx_refine_tls.S[2][1]\n");
        fprintf(fout,"_pdbx_refine_tls.S[3][1]\n");
        fprintf(fout,"_pdbx_refine_tls.S[3][2]\n");
        fprintf(fout,"_pdbx_refine_tls.S22-S11\n");
        fprintf(fout,"_pdbx_refine_tls.S11-S33\n");    
    }
    
}


    
void CNS_final_struct_log(FILE *fout, char *inpfile)
{
    char **line, tmp[215];
    int i,nline=0, n1, k1=0,k2=0,j,n, ncs=0;
    float a1,a2,a3;
    
    
    printf("Extracting statistics from CNS log file=%s\n", inpfile);
    line=get_lines_from_file(inpfile, &nline);

    for(i=0; i<nline-4; i++){
        if(strstr(line[i],"R-value by resolution for test set") &&
           strstr(line[i+2],"#bin | resolution range | #refl |")){
            k1=0;
            for(j=i+3; j<nline-4; j++){
                n=sscanf(line[j], "%*s %f%f%d%f", &a1,&a2, &n1,&a3);
                if(k1>1 && strstr(line[j], "#bin | resolution range | #refl |")){
                    n=sscanf(line[j+1], "%*s %f%f%d%f", &a1,&a2, &n1,&a3);
                    refine.ls_d_res_high = a1;
                    refine.ls_d_res_low = a2;
                    refine.ls_number_reflns_R_free =n1;
                    refine.ls_R_factor_R_free =a3;
                    i=j+1;
                    break;
                }
                
                if(n==4){
                    refine_ls_shell.d_res_high[k1] =a1;
                    refine_ls_shell.d_res_low[k1] = a2;
                    refine_ls_shell.number_reflns_R_free[k1] =n1;
                    refine_ls_shell.R_factor_R_free[k1] = a3;               
                    k1++;
                }
            }
        }else if(strstr(line[i],"R-value by resolution for working set") &&
           strstr(line[i+2],"#bin | resolution range | #refl |")){
            k2=0;
            for(j=i+3; j<nline-4; j++){
                n=sscanf(line[j], "%*s %f%f%d%f", &a1,&a2, &n1,&a3);

                if(k2>1 && strstr(line[j], "#bin | resolution range | #refl |")){
                    n=sscanf(line[j+1], "%*s %f%f%d%f", &a1,&a2, &n1,&a3);
                    refine.ls_d_res_high = a1;
                    refine.ls_d_res_low = a2;
                    refine.ls_number_reflns_R_work =n1;
                    refine.ls_R_factor_R_work =a3;
                    i=j+1;
                    break;
                }

                
                if(n==4){
                    refine_ls_shell.d_res_high[k2] =a1;
                    refine_ls_shell.d_res_low[k2] = a2;
                    refine_ls_shell.number_reflns_R_work[k2] =n1;
                    refine_ls_shell.R_factor_R_work[k2] = a3;               
                    k2++;
                }
            }
        }else if(strstr(line[i],"Overall mean FOM is")){
            a1=get_float_after_id(line[i], "FOM is");
            refine.overall_FOM_work_R_set=a1;
 // NCS operators            
        }else if(pattern5(line[i],"DEFINE>","{===>}", "ncs_infile=", "\"", "\"")){
            get_data_set_id(line[i],"\"", "\"", tmp);
            rid_of_space(tmp);
            if(strlen(tmp)>0) ncs=1;
        }
    }
    
    if(ncs==1){
        get_cns_ncs(fout, line,  nline);
    }
    
            
    if(k1==k2 && k1>0){
        refine_ls_shell.nbin=k1;
        for(i=0; i<k1; i++){
            refine_ls_shell.pdbx_total_number_of_bins_used[i]=k1;
        }
    }
    
    if(nline>0) free_memory_2d(line, nline);
}



void get_cns_ncs(FILE *fout, char **line, int nline)
//get parameters for NCS refinement
{
    char *str,**tok, ncs_type[80], item[215], tmp[80];
    char res1[10],res2[10], segid[4], chain[60][80],chain_comp[60][60];
    int i,j,k,n1=0,n2=0,n3=0,n4=0, ncs=0, nc=0, ncp=0,start=0, nstr;
    int comp[60], nn1=0,nn2=0, nnc,  m;
    float a11, a12,a13,a21,a22,a23,a31,a32,a33,t1,t2,t3, weight[60], rms[60][60];
            
    for(i=0; i<60; i++){
        strcpy(chain[i],"");
    }
    
    for(i=0; i<nline; i++){
        if(pattern5(line[i],"DEFINE>{===>}", "ncs_type", "=", "\"", "\"")){
            get_data_set_id(line[i],"\"", "\"", ncs_type);
            
        }else if (pattern5(line[i],"{===>}", " ncs_op_", "=", "", "")){ // NCS oper        
            get_data_set_id(line[i]," ncs_op_", ";", tmp);
            if(strchr(tmp,'=')) strcpy(item, strchr(tmp,'=')+1);
            rid_of_space(item);
            if(!strcmp_case(item, "true") && strstr(ncs_type, "strict")){
                nc++;
                 
                for(j=i; j<nline; j++){
                    if(pattern5(line[j],"{===>}", "ncs_matrix_", "=", "(", ")")){
                        get_data_set_id(line[j],"(", ")", tmp);
                        sscanf(tmp, "%f%f%f", &a11,&a12, &a13);
                        get_data_set_id(line[j+1],"(", ")", tmp);
                        sscanf(tmp, "%f%f%f", &a21,&a22, &a23);
                        get_data_set_id(line[j+2],"(", ")", tmp);
                        sscanf(tmp, "%f%f%f", &a31,&a32, &a33);
                        j=j+2;
                            
                    }else if(pattern5(line[j],"{===>}", "ncs_vector_", "=", "(", ")")){
                        get_data_set_id(line[j],"(", ")", tmp);
                            
                        sscanf(tmp, "%f%f%f", &t1,&t2, &t3);
                        if(nc==1)write_ncs_tls_head(fout, "_struct_ncs_oper");
                        fprintf(fout, " %d %.4f %.4f %.4f %.4f %.4f %.4f %.4f %.4f  %.4f %.4f %.4f %.4f \n",
                                nc, a11, a12,a13,a21,a22,a23,a31,a32,a33,t1,t2,t3);
                        i=j+1;
                        break;
                    }
                }
            }
            
        }else if (pattern5(line[i],"{===>} group.", ".weight=", ";", "", "")){
            n1=get_int(line[i], "group.", ".weight=");
            a11=get_float(line[i],".weight=", ";");
        }else if (pattern5(line[i],"{===>} group.", ".sigb=", ";", "", "")){
            n2=get_int(line[i], "group.", ".sigb=");
            a22=get_float(line[i],".sigb=", ";");
        }else if (pattern5(line[i],"{===>} group.", ".equiv.", "=", "(", "")){
            n3=get_int(line[i], "group.", ".equiv.");
            n4=get_int(line[i], ".equiv.", "=");
            if(n4>=60 || n4<=0) continue;
            
            str=get_string_patt(i, nline, line, "(", ")", &start);
            i=start+1;
            if(n1==n2 && n2==n3 && n1>0 && pattern5(str,"segid", "", "","", "")){
                if(n4==1){
                    ncs++;
                }
                sscanf(strstr(str, "segid")+5, "%s", segid);
                chain_comp[ncs][n4]=segid[0];
                strcat(chain[ncs], segid);
                strcat(chain[ncs], ",");
                weight[ncs]=a11;
                comp[ncs]=n4;
//            printf("str==n1,n2,n3,n4 = %d %d %d %d %d %d %s :%s\n",n1,n2,n3,n4 ,ncs ,comp[ncs], chain[ncs],str);
                
                if(n1==1 && n4==1) write_ncs_tls_head(fout, "_struct_ncs_dom_lim");

                replace_char(str,'=', ' ');
                tok=string_token(str," ", &nstr);
                ncp=0;
                for(k=0; k<nstr; k++){
                    if(strchr(tok[k], ':')){
                        ncp++;
                        replace_char(tok[k],':', ' ');
                        sscanf(tok[k],"%s %s",res1, res2);
                        fprintf(fout,"%2d %2d %s %s %s %s ? ? ? ? ? %s %s %s %s\n",
                                n1, ncp, segid, res1, segid, res2,
                                segid, res1, segid, res2);
                    }
                }
                if(tok && nstr) free_memory_2d(tok, nstr);
                        
            }
            
        }else if(pattern5(line[i],"NCS group ", "has", "sets of equivalent atoms:", "", "")){
            nn1=get_int(line[i], "group", "has");
            nn2=get_int(line[i], "has", "sets");
            for(m=1; m<=ncs; m++){
                if(m==nn1 && comp[m] ==nn2){
                    nnc=1;
                    for(k=i; k<nline; k++){
                        
                        if(strstr(line[k], "R.m.s. diff. between molecule and reference for selected atoms")){
                            nnc++;
                            rms[m][nnc]=get_float_after_id(line[k],"=");
                            if(nnc==nn2) break; 
                        } 
                    }
                }
            }
        }
        
        
    }
    for(k=1; k<=ncs; k++){
//        printf("str=%d  %d  %6.2f %s\n", ncs,comp[k],weight[k], chain[k] );
    }
    if(ncs>=1){
        write_ncs_tls_head(fout, "_struct_ncs_dom");
        for(k=1; k<=ncs; k++){
            fprintf(fout,"%d  'chain %s using %s'\n", k, chain[k] , ncs_type);
//            printf("%d  '%s using %s'\n", k, chain[k] , ncs_type);
        }
        write_ncs_tls_head(fout, "_refine_ls_restr_ncs");
        for(k=1; k<=ncs; k++){
            for(m=2; m<=comp[k]; m++){
            fprintf(fout,"%d  '%s' %c ? %.3f %.3f \n",
                    k, ncs_type ,chain_comp[k][m], rms[k][m], weight[k]);
            }
        }
        
        
    }
    
        
        
        
}
    
void CNS_final_struct_ref(FILE *fout, char *inpfile, char *id, char *method)
/* only reformat the coordinates of the final structure */
{

    string diags;
    string blockId;
    char  **line=NULL;
    char **atom_id=NULL;
    char **atom_type_symbol=NULL;
    char **type_symbol=NULL;
    char **label_atom_id=NULL;
    char **label_comp_id=NULL;
    char **label_seq_id=NULL;
    char **label_asym_id=NULL;
    char **auth_seq_id=NULL;
    char **label_alt_id=NULL;
    char **Cartn_x=NULL;
    char **Cartn_y=NULL;
    char **Cartn_z=NULL;
    char **occupancy=NULL;
    char **B_iso_or_equiv=NULL;
    char tmp1[256], tmp2[256];
    const char *chain="ABCDEFGHIJKLMNOPQRSTUVWXYZ012345689";
    const char *chain_cns="123456890ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    

    long n1=0, n2=0, n3=0, n4=0, n5=0, n6=0, n7=0, n8=0, n9=0;
    long  n10=0, n11=0, n12=0,n13=0,n14=0;
    int  i,j, nline=0, key=0;
    
        
    if (!strcmp_case(id, "CIF")){
        if(is_cif(inpfile)<50) {
            printf("Warning! File (%s) is not the mmCIF file for coordinates\n", inpfile);
            return;
        }
    }
    
    CifFile* fobjR = NULL;
    CifParser* cifParserR = NULL;

    fobjR = new CifFile(true);

    cifParserR = new CifParser(fobjR, fobjR->GetVerbose());

    cifParserR->Parse(inpfile, diags);

    delete(cifParserR);

    if (!diags.empty()) fprintf(stderr, "Diags for file %s: %s\n",inpfile,diags.c_str());

    blockId = fobjR->GetFirstBlockName();


    atom_id = get_attribute_values(fobjR, blockId.c_str(),"atom_site", "id", &n1);
    atom_type_symbol = get_attribute_values(fobjR, blockId.c_str(),"atom_site", "atom_type_symbol", &n2);
    type_symbol = get_attribute_values(fobjR, blockId.c_str(),"atom_site", "type_symbol", &n14);
    label_atom_id = get_attribute_values(fobjR, blockId.c_str(),"atom_site", "label_atom_id", &n3);
    label_comp_id = get_attribute_values(fobjR, blockId.c_str(),"atom_site", "label_comp_id", &n4);
    label_seq_id = get_attribute_values(fobjR, blockId.c_str(),"atom_site", "label_seq_id", &n5);
    label_asym_id = get_attribute_values(fobjR, blockId.c_str(),"atom_site", "label_asym_id", &n6);
    auth_seq_id = get_attribute_values(fobjR, blockId.c_str(),"atom_site", "auth_seq_id", &n7);
    label_alt_id = get_attribute_values(fobjR, blockId.c_str(),"atom_site", "label_alt_id", &n8);
    Cartn_x = get_attribute_values(fobjR, blockId.c_str(),"atom_site", "Cartn_x", &n9);
    Cartn_y = get_attribute_values(fobjR, blockId.c_str(),"atom_site", "Cartn_y", &n10);
    Cartn_z = get_attribute_values(fobjR, blockId.c_str(),"atom_site", "Cartn_z", &n11);
    occupancy = get_attribute_values(fobjR, blockId.c_str(),"atom_site", "occupancy", &n12);
    B_iso_or_equiv = get_attribute_values(fobjR, blockId.c_str(),"atom_site", "B_iso_or_equiv", &n13);
    
   
    if(n10>50 ){
        fprintf(fout,"%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n",
                "loop_",
                "_atom_site.id",
                "_atom_site.type_symbol",
                "_atom_site.auth_atom_id",
                "_atom_site.label_atom_id",
                "_atom_site.label_comp_id",
                "_atom_site.label_seq_id",
                "_atom_site.label_asym_id",
                "_atom_site.auth_asym_id",
                "_atom_site.auth_seq_id",
                "_atom_site.label_alt_id",
                "_atom_site.Cartn_x",
                "_atom_site.Cartn_y",
                "_atom_site.Cartn_z",
                "_atom_site.occupancy",
                "_atom_site.B_iso_or_equiv");
        for(i=0; i<n10; i++){

            (atom_id) ? fprintf(fout," '%s' ",atom_id[i]) : fprintf(fout, " . ");
                
            if (atom_type_symbol) {
                fprintf(fout," '%s' ",atom_type_symbol[i]) ;
            }else if (type_symbol) {
                fprintf(fout," '%s' ",type_symbol[i]) ;
            }else
                fprintf(fout, " . ");
            
            if(label_atom_id) {
                fprintf(fout," '%s' ",label_atom_id[i]);
                
                replace_char(label_atom_id[i], '\'', '*');
                
                fprintf(fout," '%s' ",label_atom_id[i]) ;
                
            }else
                fprintf(fout, " .  .");
            
            (label_comp_id) ? fprintf(fout," '%s' ",label_comp_id[i]) : fprintf(fout, " . ");
            (label_seq_id) ? fprintf(fout," '%s' ",label_seq_id[i]) : fprintf(fout, " . ");
            if(label_asym_id) {
                fprintf(fout," '%s' ",label_asym_id[i]) ;
                key=0;
                for(j=0; j<32; j++){
                    if(label_asym_id[i][0]==chain_cns[j]) {
                        fprintf(fout," %c ",chain[j]) ;
                        key=1;
                        break;
                    }
                }
                if(key==0)fprintf(fout," '%s' ",label_asym_id[i]) ;
                    
            }else{
                fprintf(fout, " . ");
            }
                
            (auth_seq_id) ? fprintf(fout," '%s' ",auth_seq_id[i]) : fprintf(fout, " . ");
            (label_alt_id) ? fprintf(fout," '%s' ",label_alt_id[i]) : fprintf(fout, " . ");
            (Cartn_x) ? fprintf(fout," '%s' ",Cartn_x[i]) : fprintf(fout, " . ");
            (Cartn_y) ? fprintf(fout," '%s' ",Cartn_y[i]) : fprintf(fout, " . ");
            (Cartn_z) ? fprintf(fout," '%s' ",Cartn_z[i]) : fprintf(fout, " . ");
            (occupancy) ? fprintf(fout," '%s' ",occupancy[i]) : fprintf(fout, " . ");
            (B_iso_or_equiv) ? fprintf(fout," '%s' ",B_iso_or_equiv[i]) : fprintf(fout, " . ");
            
//            printf("hello=%s %d %ld %s\n", type_symbol[i], i, n10, Cartn_x[i]);

            
            fprintf(fout,"\n");
        }
    }
    if(atom_id)  free_memory_2d(atom_id, n1);
    if(atom_type_symbol) free_memory_2d(atom_type_symbol, n2);
    if(type_symbol) free_memory_2d(type_symbol, n14);
    if(label_atom_id) free_memory_2d(label_atom_id, n3);
    if(label_comp_id) free_memory_2d(label_comp_id, n4);
    if(label_seq_id) free_memory_2d(label_seq_id, n5);
    if(label_asym_id) free_memory_2d(label_asym_id, n6);

            
    if(auth_seq_id) free_memory_2d(auth_seq_id, n7);
    if(label_alt_id) free_memory_2d(label_alt_id, n8);
    if(Cartn_x) free_memory_2d(Cartn_x, n9);
    if(Cartn_y) free_memory_2d(Cartn_y, n10);
    if(Cartn_z) free_memory_2d(Cartn_z, n11);
    if(occupancy) free_memory_2d(occupancy, n12);
    if(B_iso_or_equiv) free_memory_2d(B_iso_or_equiv, n13);


// for all other statistics
       
    line = get_lines_from_file(inpfile, &nline);
    if(nline<=0) return;

    for(i=0; i<nline-1; i++){
        sscanf(line[i],"%s", tmp1);
        sscanf(line[i+1],"%s", tmp2);
        
        if(!strncmp(tmp1, "_cell.", 6) && !strncmp(tmp2, "_cell.", 6)){
            
            rewrite_cns_category(fout, line , i, nline,  "_cell.");
            
        }else if(!strncmp(tmp1, "_symmetry.", 10) && !strncmp(tmp2, "_symmetry.", 10)){
            
            rewrite_cns_category(fout, line , i, nline,  "_symmetry.");


        }else if(!strncmp(tmp1, "_atom_sites.", 12) && !strncmp(tmp2, "_atom_sites.", 12)){
            
            rewrite_cns_category(fout, line , i, nline,  "_atom_sites.");
            
     
        }else if(!strncmp(tmp1, "_reflns.", 8) && !strncmp(tmp2, "_reflns.", 8)){
            
            rewrite_cns_category(fout, line , i, nline,  "_reflns.");

        }else if(!strncmp(tmp1, "_refine.", 8) && !strncmp(tmp2, "_refine.", 8)){
            
            rewrite_cns_category(fout, line , i, nline,  "_refine.");
            

        }else if(!strncmp(tmp1, "_refine_analyze.", 16) && !strncmp(tmp2, "_refine_analyze.", 16)){
            
            rewrite_cns_category(fout, line , i, nline,  "_refine_analyze.");

        }else if(!strncmp(tmp1, "loop_", 5) && !strncmp(tmp2, "_refine_ls_shell.", 17)){
            
            rewrite_cns_category(fout, line , i, nline,  "loop_");

        }else if(!strncmp(tmp1, "loop_", 5) && !strncmp(tmp2, "_refine_ls_restr.", 17)){
            
            rewrite_cns_category(fout, line , i, nline,  "loop_");
            
        }
    }
     if(line) free_memory_2d(line, nline);
    delete_file( "cns_mmcif_tmp1");
    
}

void rewrite_cns_category(FILE *fout, char **line, long i, long nline,  const char *id)
{
    long j;
    char entry[256], tmp[512];

    if(!strcmp(id,"loop_")){
        for(j=i; j<nline; j++){
            strcpy(tmp, line[j]);
            if(tmp[0] == '#' || !strncmp(tmp,"%ESDERR-WRN:", 12)) break;
                
            if(strstr(tmp, "loop_"))
                fprintf(fout,"loop_\n");
            else
                fprintf(fout,"%s",tmp);
        }
        
    }else{
        
        strcpy(entry,"");
        strcat(entry,id);
        strcat(entry,"entry_id");
    

        for(j=i; j<nline; j++){
//            if(!strcmp(id, "_refine_analyze.")){
//                printf("hello=%4ld %4ld %s\n",j, nline,line[j]);
//            }
            
            strcpy(tmp, line[j]);
            if(tmp[0] == '#' ||  !strncmp(tmp,"%ESDERR-WRN:", 12)) break;
                
            if(strstr(tmp, entry)){
                fprintf(fout,"%s  '%s'\n",entry,DATA_BLOCK);
            }else
                fprintf(fout,"%s",tmp);

        }
        
    }
    
}

    
void delete_prime(char *str)
/* delete the prime and convert it to  * if it is double prime */
{
    int len, i;
    char temp[256];
    

    len = strlen(str);
    for(i=0; i<len; i++){
        temp[i]=str[i];

        if(str[i] == '\'' && str[i+1] != '\''){
            temp[i]=' ';
        }else if(str[i] == '\'' && str[i+1] == '\''){            
            temp[i]='*';
        }

        if(i>5){
            if(str[i-3]==' ' && toupper(str[i-2])=='A'&&toupper(str[i-1])=='D'&&
               toupper(str[i])=='E' && str[i+1]==' '){
                temp[i-2]=' ';
                temp[i-1]=' ';
                temp[i]='A';
            }else if (str[i-3]==' ' && toupper(str[i-2])=='G'&&toupper(str[i-1])=='U'&&
                      toupper(str[i])=='A' && str[i+1]==' '){      
                temp[i-2]=' ';
                temp[i-1]=' ';
                temp[i]='G';
            }else if (str[i-3]==' ' && toupper(str[i-2])=='C'&&toupper(str[i-1])=='Y'&&
                      toupper(str[i])=='T' && str[i+1]==' '){      
                temp[i-2]=' ';
                temp[i-1]=' ';
                temp[i]='C';
            }else if (str[i-3]==' ' && toupper(str[i-2])=='T'&&toupper(str[i-1])=='H'&&
                      toupper(str[i])=='Y' && str[i+1]==' '){      
                temp[i-2]=' ';
                temp[i-1]=' ';
                temp[i]='T';
            }else if (str[i-3]==' ' && toupper(str[i-2])=='U'&&toupper(str[i-1])=='R'&&
                      toupper(str[i])=='A' && str[i+1]==' '){      
                temp[i-2]=' ';
                temp[i-1]=' ';
                temp[i]='U';

            }
        }
                
            
    }
    temp[len] =  '\0';
    
    strcpy(str, temp);
    
}

        
    
void  ndb_convert(char *str)
{
    int n=0, i;
    char tmp[512];

    strcpy(tmp, str);
    upperstr(tmp);
    if(!strstr(tmp, " ADE ") && !strstr(tmp, " GUA ") &&
       !strstr(tmp, " CYT ") && !strstr(tmp, " THY ") &&
       !strstr(tmp, " URI ") ) return;
    

    n=strlen(str);

    for(i=0;i<n-5;i++){
        if(str[i]==' ' && toupper(str[i+1])=='A' && toupper(str[i+2])=='D'
           && toupper(str[i+3])=='E' && str[i+4]==' '){
            str[i] = ' ';
            str[i+1] = 'A';
            str[i+2] = ' '; str[i+3] = ' '; str[i+4] = ' ';
            i=i+4;
        }else if (str[i]==' ' && toupper(str[i+1])=='G' && toupper(str[i+2])=='U'
                  && toupper(str[i+3])=='A' && str[i+4]==' '){
            str[i] = ' ';
            str[i+1] = 'G';
            str[i+2] = ' '; str[i+3] = ' '; str[i+4] = ' ';
            i=i+4;

        }else if (str[i]==' ' && toupper(str[i+1])=='C' && toupper(str[i+2])=='Y'
                  && toupper(str[i+3])=='T' && str[i+4]==' '){
            str[i] = ' ';
            str[i+1] = 'C';
            str[i+2] = ' '; str[i+3] = ' '; str[i+4] = ' ';
            i=i+4;
        }else if (str[i]==' ' && toupper(str[i+1])=='T' && toupper(str[i+2])=='H'
                  && toupper(str[i+3])=='Y' && str[i+4]==' '){
            str[i] = ' ';
            str[i+1] = 'T';
            str[i+2] = ' '; str[i+3] = ' '; str[i+4] = ' ';
            i=i+4;
        
        }else if (str[i]==' ' && toupper(str[i+1])=='U' && toupper(str[i+2])=='R'
                  && toupper(str[i+3])=='A' && str[i+4]==' '){
            str[i] = ' ';
            str[i+1] = 'U';
            str[i+2] = ' '; str[i+3] = ' '; str[i+4] = ' ';
            i=i+4;
        }
        
    }
    
    
}

    
void PHENIX_final_struct_log(FILE *fout, char *inpfile)
{
    char **line,  **str, *tmp;
    int n, i,nline=0, nstr=0, j, k1=0, n1,n2,n3 ;
    float a1,a2,a3,a4;
    
    printf("Extracting statistics from PHENIX log file=%s\n", inpfile);
    line=get_lines_from_file(inpfile, &nline);

    for(i=0; i<nline-4; i++){
        
        if(pattern5(line[i],"| scale (work) =", "scale (free) =","ksol =", "Bsol =", "")){
            refine.solvent_model_param_ksol = get_float_after_id(line[i], "ksol =");
            refine.solvent_model_param_bsol = get_float_after_id(line[i], "bsol =");
            
        }else if(strstr(line[i],"Refinement target            :")){
//            refine.pdbx_stereochemistry_target_values=get_substr(line[i],":", "\n");
            
        }else if(strstr_space(line[i],"Number of geometry restraints:")){
            refine.ls_number_restraints = get_int_after_id(line[i],":");
            
        }else if(strstr_space(line[i],"Wilson B = ")){
            reflns.B_iso_Wilson_estimate =  get_float_after_id(line[i], "Wilson B =");       
            
        }else if(pattern5(line[i],"| (B11,B22,B33,B12,B13,B23)= (", ",",",", ",", ")")){

            tmp=get_substr(line[i],")= (", ")");
            
            str=string_token(tmp,",", &nstr);
            
            refine.aniso_B11 = atof(str[0]);
            refine.aniso_B22 = atof(str[1]); 
            refine.aniso_B33 = atof(str[2]);
            refine.aniso_B12 = atof(str[3]);   
            refine.aniso_B13 = atof(str[4]);  
            refine.aniso_B23 = atof(str[5]);
//            printf("B11..B23 =%6s %6s %6s %6s %6s %6s\n", str[0],str[1],str[2],str[3],str[4],str[5]);
            delete [] tmp;
            
            
            if(nstr>0) free_memory_2d(str, nstr);
        }else if(strstr_space(line[i], "===== NCS restraints at end of refinement ====")){
            phenix_log_ncs(fout, i, line, nline);
             
        }else if(strstr_space(line[i], "--------------------  R values -----------------")){
            for(j=i; j<nline-4; j++){
                if(strstr_space(line[j+1],"twin law      :") &&
                   strstr_space(line[j+2],"twin fraction :")){
                    tmp=get_substr(line[j+1],":", "\n");
                    rid_of_space(tmp);
                    (strlen(tmp)>2)?strcpy(pdbx_twin.operators, tmp):strcpy(pdbx_twin.operators,"?");
                    pdbx_twin.fraction = get_float_after_id(line[j+2], ":");
                    strcpy(pdbx_twin.type, "?");
                    i=j+2;
                    delete [] tmp;
                }else{
                    i=j;
                    break;
                }   
            }
            
        }else if(strstr_space(line[i], "| bin | d_max | d_min | n_work | r_work | n_free | r_free |")){
            k1=0;
            for(j=i+1; j<nline-4; j++){
                if(pattern5(line[j], "|","|","|", "|","|")){
                    replace_char(line[j],'|', ' ');
                    n=sscanf(line[j],"%d %f%f %d %f  %d %f", &n1,&a1,&a2,&n2,&a3,&n3,&a4);
                    if(n==7){
                        refine_ls_shell.d_res_high[k1] =a1;
                        refine_ls_shell.d_res_low[k1] = a2;
                        refine_ls_shell.number_reflns_R_work[k1] =n2;
                        refine_ls_shell.R_factor_R_work[k1] = a3;
                        refine_ls_shell.number_reflns_R_free[k1] =n3;
                        refine_ls_shell.R_factor_R_free[k1] = a4;
                        
                        k1++;
                    }else if(k1>0 && n!=7){
                        
                        i=j;
                        break;
                    }
                }
            }
        }
        
            
            
    }

    if( k1>0 && k1<100){
        refine_ls_shell.nbin=k1;
        for(i=0; i<k1; i++){
            refine_ls_shell.pdbx_total_number_of_bins_used[i]=k1;
        }
    }
                
 }
void clean_str(char *str)
{
    replace_char(str, '{', ' ');
    replace_char(str, ',', ' ');
    replace_char(str, '}', ' ');
}

void phenix_log_ncs(FILE *fout, int start, char **line, int nline)
{
    char tmp[120], ch1[80][5], ch2[80][5], ch[5];
    int nop,i ,j,  ncs=0;
    int ref_seq1[80],ref_seq2[80], oth_seq1[80], oth_seq2[80];
    float a11, a12,a13,a21,a22,a23,a31,a32,a33,t1,t2,t3, rms_pair[80];

    
    nop=0;
    for(i=start; i<nline-4; i++){ //or operators
        if(strstr(line[i], "CPU time actual") || strstr(line[i],"=== Exporting results ==")) break;
        
        if(pattern5(line[i],"Rotation={", ",",  ",",  "}", "")){
            strcpy(tmp, line[i]);
            clean_str(tmp);
            sscanf(tmp, "%*s %f%f%f", &a11,&a12, &a13);
            
            strcpy(tmp, line[i+1]);
            clean_str(tmp);
            sscanf(tmp, "%f%f%f", &a21,&a22, &a23);
            
            strcpy(tmp, line[i+2]);
            clean_str(tmp);
            sscanf(tmp, "%f%f%f", &a31,&a32, &a33);
            
            strcpy(tmp, line[i+3]);
            clean_str(tmp);
            sscanf(tmp, "%*s%f%f%f", &t1,&t2, &t3);
            
            nop++;
            if(nop==1){
                write_ncs_tls_head(fout, "_struct_ncs_oper");
            }
            fprintf(fout, "%2d %.6f %.6f %.6f %.6f %.6f %.6f %.6f %.6f %.6f %.6f %.6f %.6f\n",
                    nop, a11, a12,a13,a21,a22,a23,a31,a32,a33,t1,t2,t3);
        }  
    }
    
                        
    ncs=0;
    for(i=start; i<nline-4; i++){
        if(strstr(line[i], "CPU time")||strstr(line[i],"======== Exporting")) break;
        
        if(strstr(line[i],"NCS operator ")){
            if(ncs>=79){
                ncs=0;
                break;
            }
            
            for(j=i+1; j<nline-4; j++){
                if(pattern5(line[j],"Reference selection:", "chain" , "and", "resseq", ":")){
                    get_data_set_id(line[j],"chain", "and", ch);
                    strcpy(ch1[ncs], ch);
                    get_data_set_id(line[j],"(", ")", tmp);
                    ref_seq1[ncs]=get_int_after_id(tmp,"resseq");
                    ref_seq2[ncs]=get_int_after_id(tmp,":");
                    
                }else if(pattern5(line[j],"Other selection:", "chain" , "and", "resseq", ":")){
                    get_data_set_id(line[j],"chain", "and", ch);
                    strcpy(ch2[ncs], ch);
                    get_data_set_id(line[j],"(", ")", tmp);
                    oth_seq1[ncs]=get_int_after_id(tmp,"resseq");
                    oth_seq2[ncs]=get_int_after_id(tmp,":");
                    
//                }else if(strstr(line[j], "Number of atom pairs:")){
//                    atom_pair[ncs]=get_int_after_id(line[j],":");
                    
                }else if(strstr(line[j], "RMS difference with respect to the reference:")){
                    rms_pair[ncs]=get_float_after_id(line[j],":");
                    i=j;
                    break;
                }
            }
            ncs++;
            
        }
    }
    if(ncs>0){
        fprintf(fout,"#\n");
        fprintf(fout,"loop_\n");
        fprintf(fout,"_struct_ncs_dom.id\n");
        fprintf(fout,"_struct_ncs_dom.details\n");
        
        for(i=0; i<ncs; i++){
            fprintf(fout,"%d 'chain %s & %s'\n", i+1, ch1[i],ch2[i]);
        }

        fprintf(fout,"#\n");
        fprintf(fout,"loop_\n");
        fprintf(fout,"_struct_ncs_dom_lim.dom_id\n");
        fprintf(fout,"_struct_ncs_dom_lim.pdbx_component\n");
        fprintf(fout,"_struct_ncs_dom_lim.beg_label_asym_id\n");
        fprintf(fout,"_struct_ncs_dom_lim.beg_label_seq_id\n");
        fprintf(fout,"_struct_ncs_dom_lim.end_label_asym_id\n");
        fprintf(fout,"_struct_ncs_dom_lim.end_label_seq_id\n");
        fprintf(fout,"_struct_ncs_dom_lim.pdbx_refine_code\n");
        
        fprintf(fout,"_struct_ncs_dom_lim.beg_label_alt_id\n");
        fprintf(fout,"_struct_ncs_dom_lim.end_label_alt_id\n");
        fprintf(fout,"_struct_ncs_dom_lim.beg_label_comp_id\n");
        fprintf(fout,"_struct_ncs_dom_lim.end_label_comp_id\n");
        
        fprintf(fout,"_struct_ncs_dom_lim.beg_auth_asym_id\n");
        fprintf(fout,"_struct_ncs_dom_lim.beg_auth_seq_id\n");
        fprintf(fout,"_struct_ncs_dom_lim.end_auth_asym_id\n");
        fprintf(fout,"_struct_ncs_dom_lim.end_auth_seq_id\n");
        
        for(i=0; i<ncs; i++){ //component alway 1 for phenix
            fprintf(fout,"%d  1  %s %4d  %s %4d ? . . . .  %s %4d  %s %4d \n",
                    i+1, ch1[i], ref_seq1[i],  ch1[i], ref_seq2[i],
                    ch1[i],ref_seq1[i],  ch1[i],ref_seq2[i]);
            fprintf(fout,"%d  1  %s %4d  %s %4d ? . . . .  %s %4d  %s %4d \n",
                    i+1, ch2[i],oth_seq1[i],  ch2[i],oth_seq2[i],
                    ch2[i],oth_seq1[i],  ch2[i],oth_seq2[i]);
        }
        
        
        fprintf(fout,"#\n");
        fprintf(fout,"loop_\n");
        fprintf(fout,"_refine_ls_restr_ncs.dom_id\n");
        fprintf(fout,"_refine_ls_restr_ncs.ncs_model_details\n");
        fprintf(fout,"_refine_ls_restr_ncs.rms_dev_position\n");
        for(i=0; i<ncs; i++){
            fprintf(fout,"%d 'chain %s & %s' %.3f\n", i+1, ch1[i],ch2[i], rms_pair[i]);
        }
        
    }
}
