#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "structure.h"
#include "harv.h"
#include "util.h"

#define LEN 100
# define MAXL 512
PDBX_PHASING_DM_SHELL  pdbx_phasing_dm_shell;
extern PDBX_PHASING_DM  pdbx_phasing_dm;



    
void CNS_phasing_DM(FILE *fout, char *inpfile, char *format,char *method)
/*extract information from the log file of density_modification.list file */
{

    char str[MAXL], *tmp=NULL;
    int num, nbin=0, n, i, t3, refln[NBIN], nref;
    float a, res_H[NBIN], res_L[NBIN], fom[NBIN], dphi[NBIN], t1,t2,t4, t5;
    FILE *fp;


    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (routine:CNS_phasing_DM)\n",inpfile);
        return;
    }
    
    if(!strcmp_case(format, "CIF") || !strcmp_case(format, "PDB")){
        write_cif_or_pdb(fout,  inpfile, format,method);
        return;
    }

    
    while (fgets(str, sizeof str, fp) != NULL) {
        upperstr(str);
        
        if(pattern5(str, ">", "solvent modification method=", "", "", "" )){
            tmp = new char[strlen(str)];
            n =  sscanf(strstr(str,"=")+1,"%s", tmp);
            strcpy(pdbx_phasing_dm.method, tmp);
            delete [] tmp;
            
        }else if(pattern5(str, ">", "solvent mask type=", "", "", "") ){
            tmp = new char[strlen(str)];
            n =  sscanf(strstr(str,"=")+1,"%s", tmp);
            strcpy(pdbx_phasing_dm.mask_type,tmp);
            delete [] tmp;
            
        }else if(pattern5(str, "current high resolution limit=", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.d_res_high =a;
            
        }else if(pattern5(str, "number of reflections phased= ", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%d", &nref);
            if (n==1)pdbx_phasing_dm.reflns =nref;
            
        }else if(pattern5(str, "solvent mask volume (%)=", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.solvent_percent_sol =a;
            
        }else if(pattern5(str, "mask radius=", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.mask_radius =a;
            
        }else if(pattern5(str, "new solvent density=", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.solvent_mean_density =a;
/*            
        }else if(pattern5(str, "RMS solvent density=", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.solvent_mean_density_esd =a;

        }else if(pattern5(str, "average macromolecular density=", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.protein_mean_density =a;

        }else if(pattern5(str, " RMS macromolecular density=", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.protein_mean_density_esd =a;
*/            
        }else if(strstr_space(str,  " mean FOM=") >0 ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.fom =a;
            
        }else if(strstr_space(str, "delta phi(initial)(degrees)=") >0 ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.delta_phi_initial =a;
            
        }else if(strstr_space(str, "delta phi(last)(degrees)=") >0 ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.delta_phi_final =a;
        }
        
    }


    rewind(fp);
    while (fgets(str, sizeof str, fp) != NULL) {
        if (pattern5(str, "bin", "|", "RESOLUTION RANGE", "refl", "|") >0 ){
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                num=sscanf(str,"%*s %f %f %d %f  %f",&t1, &t2, &t3, &t4, &t5);
                if(num == 5){
                    res_H[n] = t1;
                    res_L[n] = t2;
                    refln[n] = t3;
                    fom[n] = t4;
                    dphi[n] = t5;
                    n++;
                    if(n>=NBIN-1){
                        printf("The LOG file (%s) may not be checked\n", inpfile);
                        return;
                    }
                }
                if(num!=5 && n !=0 ) {
                    nbin = n;
                    n=0;
                    break;
                }
            }
        }
               
    }
    fclose(fp);
    
    pdbx_phasing_dm_shell.number_bin = nbin;
    
    for(i=0; i<nbin; i++){
        pdbx_phasing_dm_shell.d_res_high[i] = res_H[i];
        pdbx_phasing_dm_shell.d_res_low[i] = res_L[i];
        pdbx_phasing_dm_shell.reflns[i] = refln[i];
        pdbx_phasing_dm_shell.fom[i] = fom[i];
        pdbx_phasing_dm_shell.delta_phi_final[i] = dphi[i];
    }
   
}



void SHARP_phasing_DM(FILE *fout, char *inpfile, char *format,char *method)
/* extract the information .
   FOM after density modification. The same as DM
*/
{
    FILE *fp;

    int i=0, n=0,nref=0;
    char str[512], fom[NBIN][LEN], juck[LEN];
    char resol_L[LEN], resol_H[LEN],  fm[LEN], phi[LEN];
    float nf;
    
    
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (:SHARP_phasing_DM)\n",inpfile);
        return;
    }
    
    if(!strcmp_case(format, "CIF") || !strcmp_case(format, "PDB")){
        write_cif_or_pdb(fout,  inpfile, format,method);
        return;
    }
   
    while (fgets(str, sizeof str, fp) != NULL) {
        upperstr(str);
        if (strstr_space(str, " RMIN  - RMAX")>0 &&
            strstr_space(str, " MEAN FOM  MEAN FOM  MEAN FOM")>0){
            
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                upperstr(str);
                if(strstr(str, "------") ||strstr(str, "CYCLE") )break;
                if(strlen(str)<20||strstr(str, "(") || strstr(str, "CLAC"))continue;
                if(sscanf(str, "%s %s %s %f   %s %s %s %s %s %s %s",
                          resol_L, resol_H, juck, &nf , juck, juck,juck,
                          fm, juck,juck,phi)==11){
                    nref=(int) nf;
                    sprintf(fom[n], "%s %s %d %s %s", resol_L, resol_H, nref, fm, phi);
                    n++;
                }
            }
        }
    }
        
    if(n>1){
        fprintf(fout,"\n\n##### Density modification #####\n");
        fprintf(fout,"loop_\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.d_res_low\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.d_res_high\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.reflns\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.fom\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.delta_phi_final\n");
        for(i=0; i<n; i++)
            fprintf(fout, "%s\n", fom[i]);
            
    }
     fclose(fp);  
    
}

void CCP4_phasing_DM(FILE *fout, char *inpfile,char *format,char *method)
/* extract the information.   FOM after density modification. 
*/
{
    FILE *fp;

    int  n=0, nref=0, m=0;
    char str[256], juck[80];
    float resol_L, resol_H,  fm, phi;
    char *method1=NULL, *method2=NULL,meth[256], *tmp=NULL;
    float nf, a1,a2,a3,a4,a5;
    
    
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s(routine:CCP4_phasing_DM)\n",inpfile);
        return;
    }
    
    if(!strcmp_case(format, "CIF") || !strcmp_case(format, "PDB")){
        write_cif_or_pdb(fout,  inpfile, format,method);
        return;
    }
   
    while (fgets(str, sizeof str, fp) != NULL) {
        upperstr(str);
        if(strstr_case(str, "<li> Solvent flattening")){
            method1 = (char *)"Solvent flattening ";
            
        }else if(strstr_case(str, "<li> Histogram matching")){
            method2 = (char *)"Histogram matching";
            
        }else if(strstr_case(str, "Number of reflections included in phase recombination =")){
            pdbx_phasing_dm.reflns = get_int(str,"= ", "\n");

        }else if(strstr_case(str, "Auto Wang-radius")){
            pdbx_phasing_dm.mask_radius = get_int(str,"Wang-radius", "\n");
            
        }else if(pattern5(str, "Effective resolution:"," A", "","","")){
            pdbx_phasing_dm.d_res_high = get_float(str,":", "A");
            
            
        }else if(strstr_case(str, "% of cell   Min Rho   Max Rho   Mean Rho   Std.Dev.")){
            
            while (fgets(str, sizeof str, fp) != NULL){
                if(strstr_case(str,"Protein:")){
                    tmp= strstr(str,":")+1;
                    
                    m=sscanf(tmp, "%f%f%f%f%f\n", &a1,  &a2,  &a3,  &a4,  &a5);
                    if(m==5){
                        pdbx_phasing_dm.protein_percent_sol = a1;
                        pdbx_phasing_dm.protein_min_density = a2;
                        pdbx_phasing_dm.protein_max_density = a3;
                        pdbx_phasing_dm.protein_mean_density = a4;
                        pdbx_phasing_dm.protein_mean_density_esd = a5;
                    }
                } else if(strstr_case(str,"Solvent:")){
                    tmp= strstr(str,":")+1;
                    
                    m=sscanf(tmp, "%f%f%f%f%f\n", &a1,  &a2,  &a3,  &a4,  &a5);
                    if(m==5){
                        pdbx_phasing_dm.solvent_percent_sol = a1;
                        pdbx_phasing_dm.solvent_min_density = a2;
                        pdbx_phasing_dm.solvent_max_density = a3;
                        pdbx_phasing_dm.solvent_mean_density = a4;
                        pdbx_phasing_dm.solvent_mean_density_esd = a5;
                    }
                }else
                    break;               
            }
            
        }else if (strstr_space(str,"RMIN - RMAX  S^2  NREFLS  SIGMAA MEAN FOM")>0){
            
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                upperstr(str);
                if(!is_space_line(str))continue;
                if(strstr(str, "------") || strstr(str, "CYCLE") || strlen(str)<20 )break;
                if(strstr_space(str, "(calc) (comb)") >0 ) continue;
                if(sscanf(str, "%f %f %s %f   %s %s %s %f %f  %s %s",
                          &resol_L, &resol_H, juck, &nf , juck, juck,juck,
                          &fm,&phi, juck,juck)==11){
                    nref=(int) nf;
                    pdbx_phasing_dm_shell.d_res_low[n] = resol_L;
                    pdbx_phasing_dm_shell.d_res_high[n] = resol_H;
                    pdbx_phasing_dm_shell.reflns[n] = nref;
                    pdbx_phasing_dm_shell.fom[n] = fm;
                    pdbx_phasing_dm_shell.delta_phi_final[n] = phi;
                    
                    n++;
                    if(n>=NBIN-1){
                        printf("Warning! No DM statistics will be written\n");
                        n=0;
                        break;
                    }
                    
                }
            }
        }
    }
    pdbx_phasing_dm_shell.number_bin = n;
    
    if(method1 && method2){
        strcpy(meth,method1);
        strcat(meth, " and ");
        strcat(meth, method2);
        strcpy(pdbx_phasing_dm.method , meth);
    }else if(method1 && !method2){
        strcpy(pdbx_phasing_dm.method , method1);
    }else if(!method1 && method2){
        strcpy(pdbx_phasing_dm.method , method2);
    }

    fclose(fp);  
    
}

void CCP4_phasing_SOLOMON(FILE *fout, char *inpfile,  char *format,char *method)
/* extract the information.   FOM after density modification. */
{
    FILE *fp;

    int i, j=0, nc=0, nline=0, nb1,nb2,refl_c[NBIN], refl_a[NBIN], nref, m, n, ncol=0;
    char str[512],charact, **fomlines, tmp[80];
    float resL_c[NBIN],resH_c[NBIN],fom_c[NBIN],resL_a[NBIN],resH_a[NBIN],fom_a[NBIN];
    float fom, a;
    

    fomlines = set_memory_2d(500,300);
    
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s(routine:CCP4_phasing_SOLOMON)\n",inpfile);
        return;
    }
    
    if(!strcmp_case(format, "CIF") || !strcmp_case(format, "PDB")){
        write_cif_or_pdb(fout,  inpfile, format,method);
        return;
    }

    
    while (fgets(str, sizeof str, fp) != NULL) {
        upperstr(str);
        nc=0;        
        if (strstr_space(str, "Reflections with Combined Phase Information")>0){
            
            while (fgets(str, sizeof str, fp) != NULL){
                upperstr(str);
                strcpy(fomlines[nc], str);
                nc++;
                ncol = nc;
                
                if(nc>=500){
                    printf("Warning! The log file for SOLOMON  may be wrong!!\n");
                    return;
                }
                if(strstr_space(str, "Mean Variation of Information")>0){
                    nline=nc;
                    break;
                }
                
            }
            
        }else if(strstr_space(str,"Overall Figures of Merit")){
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                if(n++>10 || strstr_case(str, "HEADER INFORMATION") ||
                  strstr_case(str,"Title") )break;
                
                m=sscanf(str, "%s%d%f",tmp, &nref, &fom);
                if(m==3){
                    if(!strcmp_case(tmp, "CENTRIC")){
                        pdbx_phasing_dm.reflns_centric = nref;
                        pdbx_phasing_dm.fom_centric = fom;
                       
                    }else if(!strcmp_case(tmp, "NON-CENTRIC")){
                        pdbx_phasing_dm.reflns_acentric = nref;
                        pdbx_phasing_dm.fom_acentric = fom;
                        
                    }else if(!strcmp_case(tmp, "TOTAL")){
                        pdbx_phasing_dm.reflns = nref;
                        pdbx_phasing_dm.fom = fom;
                        break;
                        
                    }
                }
            }
                       
        }else if(strstr_space(str,"new solvdens:")){
            n=sscanf(strstr_case(str, ":") +1 ,"%f", &a);
            if(n==1)pdbx_phasing_dm.solvent_mean_density = a;
            
        }else if(strstr_space(str,"mean density of protein:")){
            n=sscanf(strstr_case(str, ":") +1 ,"%f", &a);
            if(n==1)pdbx_phasing_dm.protein_mean_density = a;
            
        }else if(strstr_space(str,"sd of protein:")){
            n=sscanf(strstr_case(str, ":") +1 ,"%f", &a);
            if(n==1)pdbx_phasing_dm.protein_mean_density_esd = a;
            
        }
        
    }
    
    charact='-';
    nb1=0;
    for(i=0; i<nline; i++){/* for Centric DATA */
        strcpy(str,fomlines[i]);
        
        if(strstr(str, "--")){
            char2space(str, charact); /*subsitute charact by space*/
            if(sscanf(str, "%f %f %d %f",
                   &resL_c[nb1],&resH_c[nb1], &refl_c[nb1], &fom_c[nb1]) != 4)
                continue;
            nb1++;
            if(nb1>=NBIN-1){
                printf("Warning! The log file for SOLOMON  may be wrong!!\n");
                return;
            }
            
        }
        if(strstr(str, "NON-CENTRIC")){
            j=i;
            break;
        }
    }
    
    nb2=0;
    for(i=j; i<nline; i++){/* for Non-Centric DATA */
        strcpy(str,fomlines[i]);
        if(strstr(str, "--")){
            char2space(str, charact); 
            if(sscanf(str, "%f %f %d %f",
                   &resL_a[nb2],&resH_a[nb2], &refl_a[nb2], &fom_a[nb2]) !=4 )
                continue;
            nb2++;
            if(nb2>=NBIN-1){
                printf("Warning! The log file for SOLOMON  may be wrong!!\n");
                return;
            }
        }
    }

    if(fomlines) free_memory_2d(fomlines, ncol);
    
    if(nb1==nb2 && nb1>0){
        pdbx_phasing_dm_shell.number_bin=nb1;
        for(i=0; i<nb1; i++){
            pdbx_phasing_dm_shell.d_res_low[i] = resL_c[i];
            pdbx_phasing_dm_shell.d_res_high[i]=resH_c[i];
            pdbx_phasing_dm_shell.reflns_centric[i]=refl_c[i];
            pdbx_phasing_dm_shell.fom_centric[i]= fom_c[i];
            pdbx_phasing_dm_shell.reflns_acentric[i]=refl_a[i];
            pdbx_phasing_dm_shell.fom_acentric[i]=fom_a[i];
        } 
    }
    fclose(fp);
}

