/*
FILE:     mr.C
*/
/*
VERSION:  3.004
*/
/*
DATE:     9/11/2007
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2007 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/*  a program to extract MR information form the programs */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "structure.h"
#include "harv.h"
#include "util.h"

extern PDBX_PHASING_MR pdbx_phasing_MR;
extern  CELL cell ;
extern SYMMETRY symmetry;

void put_data(float *dat, const char *id);

void CNS_mr(FILE *fout, char *filename, char *format, char *method)
{
    char str[512], substr[80];
    int n;
    float resL, resH, cc, pack,a1,a2,a3,a4,a5,a6;
    FILE *fp;

    if((fp=fopen(filename, "r"))==NULL){
        printf("Can not open the file %s (routine:CNS_mr)\n",filename);
        return;
    }
    
    while(fgets(str, sizeof str, fp) != NULL){
        if (pattern5(str, "!", "rotation search:", "", "", "")){
            get_data_set_id(str, "!", "rotation", substr);           
            rid_of_front_end_space(substr);
            strcpy(pdbx_phasing_MR.method_rotation, substr);
            
            while(fgets(str, sizeof str, fp) != NULL){
                if (pattern5(str, "! at resolution:", " -", " A", "", "")){
                    resH = get_float(str," -", " A");
                    resL = get_float(str,":", " -");

                    pdbx_phasing_MR.d_res_high_rotation = resH;
                    pdbx_phasing_MR.d_res_low_rotation = resL;
                    
                }else if(pattern5(str, "! reflections with |Fobs|/sigma_F <", " rejected", "", "", "")){
                    pdbx_phasing_MR.sigma_F_rotation = get_float(str," <", " rejected");
                    
                }else if(pattern5(str, "! total number of reflections used:","(", " %", ")", "")){
                    pdbx_phasing_MR.reflns_percent_rotation = get_float(str,"("," %");
                    
                    break;
                }
            }
            break;
        }else if (pattern5(str, "!", "translation", "search", "", "")){
            
            while(fgets(str, sizeof str, fp) != NULL){
                if (pattern5(str, "! method= ", "", "", "", "")){
                    get_data_set_id(str, "= ", "\n", substr);
                    rid_of_front_end_space(substr);
                    strcpy(pdbx_phasing_MR.method_translation, substr);
                    
                }else if (pattern5(str, "! at resolution:", " A", "", "", "")){
                    pdbx_phasing_MR.d_res_high_translation = get_float(str," -", " A");
                    pdbx_phasing_MR.d_res_low_translation = get_float(str,"resolution:", "-");
                    
                }else if(pattern5(str, "! reflections with |Fobs|/sigma_F <", " rejected", "", "", "")){
                    pdbx_phasing_MR.sigma_F_translation = get_float(str," <", " rejected");

                }else if(pattern5(str, "! total number of reflections used:", "(", " %", ")", "")){
                    pdbx_phasing_MR.reflns_percent_translation = get_float(str,"(", " %");
                    
                }else if(strstr_space(str,"=== best solution ===")){
                   while(fgets(str, sizeof str, fp) != NULL){
                       if(strstr(str,"R# ")){
                           n=sscanf(str,"%*s%*s  %f%f%f%f %f%f%f%f",&a1,&a2,&a3,&a4,&a5,&a6, &cc, &pack);
                           if(n==8){
                               pdbx_phasing_MR.correlation_coeff_Fo_to_Fc = cc;
                               pdbx_phasing_MR.packing = pack;
                               pdbx_phasing_MR.angle_alpha = a1;
                               pdbx_phasing_MR.angle_beta = a2;
                               pdbx_phasing_MR.angle_gamma = a3;
                               pdbx_phasing_MR.Cartn_x = a4;
                               pdbx_phasing_MR.Cartn_y = a5;
                               pdbx_phasing_MR.Cartn_z = a6;
                               break;
                           }
                           
                       }
                   }
                }
                
            }
            break;
            
        }
    }
}

                
void EPMR_mr(FILE *fout, char *filename, char *format, char *method)
/* get items from EPMR */
{
    char str[512], substr[256], tmp[256];
    float  resH, resL, a1, a2, a3;
    int n=0;
    FILE *fp;

    if((fp=fopen(filename, "r"))==NULL){
        printf("Can not open the file %s (routine:EPMR_mr)\n",filename);
        return;
    }
    while(fgets(str, sizeof str, fp) != NULL){
        
                       
        if(pattern5(str,"Resolution range:", " -", " Angstroms", "", "")){
            
            strcpy(substr, strstr_case(str,":")+1);
            n=sscanf(substr,"%f%s%f",&resL,tmp, &resH);
            if(n==3){
                pdbx_phasing_MR.d_res_high_translation  = resH;
                pdbx_phasing_MR.d_res_low_translation = resL;
            }
        }else if(pattern5(str, "Soln", "Rot=", "Trn=", "CC=", "R=")){
            
            get_data_set_id(str, "Rot=", "Trn=", substr);
            n = sscanf(substr, "%f%f%f", &a1, &a2,  &a3);
            if(n==3){
                pdbx_phasing_MR.angle_alpha = a1;
                pdbx_phasing_MR.angle_beta = a2;
                pdbx_phasing_MR.angle_gamma = a3;
            }
            
            get_data_set_id(str,  "Trn=","CC=", substr);
            n = sscanf(substr, "%f%f%f", &a1, &a2,  &a3);
            if(n==3){

                pdbx_phasing_MR.Cartn_x = a1;
                pdbx_phasing_MR.Cartn_y = a2;
                pdbx_phasing_MR.Cartn_z = a3;
            }
            
            get_data_set_id(str,  "CC=","R=", substr);
            n = sscanf(substr, "%f", &a1);
            if(n==1){
                pdbx_phasing_MR.correlation_coeff_Fo_to_Fc = a1;
            }

            get_data_set_id(str,  "R=", "\n",substr);
            n = sscanf(substr, "%f", &a1);
            if(n==1){
                pdbx_phasing_MR.R_factor = a1;
            }

            break;
            
        }
    }
    
}
                
void COMO_mr(FILE *fout, char *filename, char *format, char *method)
/* get items from EPMR */
{
    char **line, str[512], tmp[256];
    float  resH, resL, a1, a2, a3;
    int n=0, i, nline;

    line=get_lines_from_file(filename, &nline);

    for(i=0; i<nline; i++){
        strcpy(str,line[i]);
                       
        if(pattern5(str,"RFINPT>", "resolution", ".", ".", "")){
            
            strcpy(tmp, strstr_case(str,"tion")+4);
            n=sscanf(tmp,"%f%f",&resL, &resH);
            if(n==2){
                pdbx_phasing_MR.d_res_high_rotation  = resH;
                pdbx_phasing_MR.d_res_low_rotation = resL;
            }
            
        }else if(pattern5(str,"TFINPT>", "resolution", ".", ".", "")){
            
            strcpy(tmp, strstr_case(str,"tion")+4);
            n=sscanf(tmp,"%f%f",&resL, &resH);
            if(n==2){
                pdbx_phasing_MR.d_res_high_translation  = resH;
                pdbx_phasing_MR.d_res_low_translation = resL;
            }
            
        }else if(pattern5(str, "SOLSEL>", "Rotation", " = ", ".", ".")){
            
            strcpy(tmp, strstr_case(str," = ")+3);
            n=sscanf(tmp,"%f%f%f",&a1, &a2, &a3);
            if(n==3){
                pdbx_phasing_MR.angle_alpha = a1;
                pdbx_phasing_MR.angle_beta = a2;
                pdbx_phasing_MR.angle_gamma = a3;
            }

         }else if(pattern5(str, "SOLSEL>", "Translation", " = ", ".", ".")){
            
            strcpy(tmp, strstr_case(str," = ")+3);
            n=sscanf(tmp,"%f%f%f",&a1, &a2, &a3);
            if(n==3){

                pdbx_phasing_MR.fract_x = a1;
                pdbx_phasing_MR.fract_y = a2;
                pdbx_phasing_MR.fract_z = a3;

            }
            
         }else if(pattern5(str, "RGCALC>", "Correlation ", "refinement", ".", ".")){
             
            strcpy(tmp, strstr_case(str,"refinement")+10);
            n=sscanf(tmp,"%f%f",&a1, &a2);
            if(n==2){
                pdbx_phasing_MR.correlation_coeff_Fo_to_Fc = a2;
            }
            
         }else if(pattern5(str,"TFPOPC>", "No  th1    th2    th3","","","")){
             a1=0;
             sscanf(line[i+1]+60, "%f",&a1);
             if(a1>0.001 && a1<70)pdbx_phasing_MR.R_factor = a1;   
        }
    }
    
}

                       
void CCP4_amore(FILE *fout, char *inpfile,char *format, char *method)
        /* extract things from Amore */
{
    char str[512], tmp[256];
    int n=0, m=0;
    float dat[6],cc_F, r_fact, cc_I, cc_F_tmp, r_fact_tmp, cc_I_tmp,resL,resH;
    
    FILE *fp;
    
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s(routine:CCP4_amore)\n",inpfile);
        return;
    }
    
    while (fgets(str, sizeof str, fp) != NULL) {
        if(strstr_space(str, "** ROTATION FUNCTION REQUESTED **")){
            while (fgets(str, sizeof str, fp) != NULL) {
                if(strstr_space(str,"Resolution limits are:")){
                    strcpy(tmp,strstr(str,"are:")+4);
                    n=sscanf(tmp,"%f%f", &resL,&resH);
                    if(n==2){
                        pdbx_phasing_MR.d_res_high_rotation = resH;
                        pdbx_phasing_MR.d_res_low_rotation = resL;
                    }
                    break;
                }
            }
           
        }else if(strstr_space(str, "** TRANSLATION FUNCTION REQUESTED **")){
            
            cc_F=0;
            r_fact=0;
            cc_I=0;

            while (fgets(str, sizeof str, fp) != NULL) {
                if(strstr_space(str,"Resolution limits are:")){
                    strcpy(tmp,strstr_case(str,"are:")+4);
                    n=sscanf(tmp,"%f%f", &resL,&resH);
                    if(n==2){
                        pdbx_phasing_MR.d_res_high_translation = resH;
                        pdbx_phasing_MR.d_res_low_translation = resL;
                    }
                }else if(strstr_space(str," TABLE   Alpha    Beta   Gamma    Tx      Ty      Tz Corr_F Rfac Corr_I Pkcount  Dmin")){
                   
                    while (fgets(str, sizeof str, fp) != NULL) {
                        if (is_space_line(str) ==0) continue;
                        if(pattern5(str, "SOLUTIONTF", ".", ".", ".", ".")){
                           n=sscanf(str,"%*s%d %f%f%f %f%f%f %f%f%f", &m,
                                    &dat[0], &dat[1], &dat[2], &dat[3], &dat[4], &dat[5],
                                    &cc_F_tmp, &r_fact_tmp, &cc_I_tmp);
                           if(n==10 && m>0){
                               if(cc_F_tmp>cc_F) {
                                   put_data(dat,"mr_angle_frac");
                                   
                                   cc_I = cc_I_tmp;
                                   cc_F = cc_F_tmp;
                                   r_fact = r_fact_tmp;
                                   
                                   if(cc_F>0)pdbx_phasing_MR.correlation_coeff_Fo_to_Fc = 0.01*cc_F;
                                   if(cc_I>0)pdbx_phasing_MR.correlation_coeff_Io_to_Ic = 0.01*cc_I;  
                                   if(r_fact>0)pdbx_phasing_MR.R_factor = 0.01*r_fact;
                               }
                           }
                           break;
                       }
                    }
                } 
                        
            }
            
        }else if(strstr_space(str, "** RIGID BODY FITTING FUNCTION REQUESTED **")){
            cc_F=0;
            r_fact=0;
            cc_I=0;
            
            while (fgets(str, sizeof str, fp) != NULL) {
                if(strstr_space(str,"Resolution limits are:")){
                    strcpy(tmp,strstr_case(str,"are:")+4);
                    n=sscanf(tmp,"%f%f", &resL,&resH);
                    if(n==2){
                        pdbx_phasing_MR.d_res_high_fit = resH;
                        pdbx_phasing_MR.d_res_low_fit = resL;
                    }
                }else if(strstr_space(str," TABLE   Alpha    Beta   Gamma    Tx      Ty      Tz Corr_F Rfac Corr_I Pkcount")){
                   
                    while (fgets(str, sizeof str, fp) != NULL) {
                        if (is_space_line(str) ==0) continue;
                        if(pattern5(str, "SOLUTIONF", ".", ".", ".", ".")){
                           n=sscanf(str,"%*s%d %f%f%f %f%f%f %f%f%f", &m,
                                    &dat[0], &dat[1], &dat[2], &dat[3], &dat[4], &dat[5],
                                    &cc_F_tmp, &r_fact_tmp, &cc_I_tmp);
                           if(n==10 && m>0){
                               if(cc_F_tmp>cc_F) {
                                   put_data(dat,"mr_angle_frac");
                                   
                                   cc_I = cc_I_tmp;
                                   cc_F = cc_F_tmp;
                                   r_fact = r_fact_tmp;
                                   
                                   if(cc_F>0)pdbx_phasing_MR.correlation_coeff_Fo_to_Fc =0.01*cc_F;
                                   if(cc_I>0)pdbx_phasing_MR.correlation_coeff_Io_to_Ic =0.01*cc_I;  
                                   if(r_fact>0)pdbx_phasing_MR.R_rigid_body = 0.01*r_fact;
                               } 
                           }
                           break;
                        }
                    }
                    
                } 
                        
            }
        }
        
    }
    fclose(fp);
}


void CCP4_phaser_mr(FILE *fout, char *inpfile,char *format, char *method)
/* extract things from phaser */
{
    char str[256], tmp[256],tmp1[256], **lines;
    int n=0,j, i=0, nline=0;
    float a1,a2,resL,resH, dat[6];

    lines=get_lines_from_file(inpfile, &nline);

    for(i=0; i<nline; i++){// other LOG file
        if(strlen(lines[i])>250)continue;
        strcpy(str,lines[i]);
        if(strstr_space(str,"Space-Group Name (Number):")){
            get_data_set_id(str, ":", "(", tmp);
            if(strlen(tmp)>1) strcpy(symmetry.space_group_name_H_M, tmp);
            strcpy(tmp,strstr(str,"(Number):")+9);
            n=get_int_after_id(tmp, "(");
            if(n>0)symmetry.Int_Tables_number=n;
            
        }else if(!strncmp(str,"MODE ", 5)){
            n=sscanf(str,"%*s %s %s", tmp, tmp1);
            if(n==1){
                sprintf(pdbx_phasing_MR.model_details, "Phaser MODE: %s", tmp);
            }
            
        }else if(strstr_space(str,"Unit Cell:")){
            if(sscanf(strchr(str,':')+1,"%f%f%f%f%f%f",
                      &dat[0],&dat[1],&dat[2],&dat[3],&dat[4],&dat[5])==6)
                    
                put_data(dat, "cell");
        
        }else if(strstr_space(str,"FAST ROTATION FUNCTION")){
            for(j=i; j<nline; j++){
                if(strlen(lines[j])>250)continue;
                strcpy(str,lines[j]);
                
                if(strstr_space(str,"Resolution of Selected Data (Number):")){
                    strcpy(tmp,strstr(str,"(Number):")+9);
                    n=sscanf(tmp,"%f%f", &resH,&resL);
                    if(n==2){
                        pdbx_phasing_MR.d_res_high_rotation = resH ;
                        pdbx_phasing_MR.d_res_low_rotation = resL ;
                    }
                    break;
                }
            }
            
        }else if(strstr_space(str,"FAST TRANSLATION FUNCTION")){
            for(j=i; j<nline; j++){
                if(strlen(lines[j])>250)continue;
                strcpy(str,lines[j]);
                
                if(strstr_space(str,"Resolution of Selected Data (Number):")){
                    strcpy(tmp,strstr(str,"(Number):")+9);
                    n=sscanf(tmp,"%f%f", &a1,&a2);
                    if(n==2){
                        pdbx_phasing_MR.d_res_high_translation = a1 ;
                        pdbx_phasing_MR.d_res_low_translation = a2 ;
                    }
                    break;
                }
            }
            
        }
    }

    for(i=0; i<nline; i++){
        if(strlen(lines[i])>250)continue;
        if(nline>100)break; //must be *.sol file
        
        strcpy(str,lines[i]);
        rid_of_front_space(str);
        
// v1.3.1 --2.0       
        if(!strncmp(str,"SOLU SET",8) && pattern5(lines[i], "RF=", "TF=", "","","")){ 
            pdbx_phasing_MR.LL_gain_rotation = get_int_after_id(lines[i],"RF=");
            pdbx_phasing_MR.LL_gain_translation = get_int_after_id(lines[i],"TF=");
                
        }else if(!strncmp(str,"SOLU SET",8) && pattern5(lines[i], "RFZ=","TFZ=","PAK=",  "LLG=","LLG=")){
            pdbx_phasing_MR.zscore_rotation = get_float_after_id(str, "RFZ=");
            pdbx_phasing_MR.zscore_translation = get_float_after_id(str, "TFZ=");
            pdbx_phasing_MR.LL_gain_rotation = get_float_after_id(str, "LLG=");
            pdbx_phasing_MR.packing = get_float_after_id(str, "PAK=");
            strcpy(tmp, strstr(str,"LLG=")+4);
            pdbx_phasing_MR.LL_gain_translation = get_float_after_id(tmp, "LLG=");
                
        }else if(!strncmp(str,"SOLU SET",8) && pattern5(lines[i],"", "RFZ=", "TFZ=", "","")){ //tran
            pdbx_phasing_MR.zscore_rotation = get_float_after_id(str, "RFZ=");
            pdbx_phasing_MR.zscore_translation = get_float_after_id(str, "TFZ=");
                
        }else if (!strncmp(str,"SOLU 6DIM",9) && pattern5(lines[i],"", "EULER", ".", "FRAC",".")){
            strcpy(tmp,strstr(str,"EULER")+5);
            n=sscanf(tmp, "%f%f%f", &dat[0],&dat[1],&dat[2]);
            if(n==3) put_data(dat, "mr_angle");
               
            strcpy(tmp,strstr(str,"FRAC")+5);
            n=sscanf(tmp, "%f%f%f", &dat[0],&dat[1],&dat[2]);
            if(n==3) put_data(dat, "mr_frac");
            break;
        }
        
    }

    if(nline>0 && lines)free_memory_2d(lines, nline);
}

void CCP4_molrep(FILE *fout, char *inpfile,char *format, char *method)
 /* extract things from Amore */
{
    char str[512], tmp[256];
    int n=0;
    float cc_F=0, r_fact=0,cc_F_tmp=0, r_fact_tmp=0,resL=0,resH=0,dat[6];
    
    FILE *fp;
    
    if((fp = fopen(inpfile, "r"))==NULL) 
        open_file_error(inpfile, "CCP4_molrep");
        
    while (fgets(str, sizeof str, fp) != NULL) {
        if(strstr_space(str,"Sol_--- Rotation function ---")){
            while (fgets(str, sizeof str, fp) != NULL) {
                if(pattern5(str, "Sol_ Resmin,Resmax           :" ,"","", "","")){
                    strcpy(tmp,strstr(str,":")+1);
                    n=sscanf(tmp,"%f%f", &resL,&resH);
                    if(n==2){
                        pdbx_phasing_MR.d_res_high_rotation = resH ;
                        pdbx_phasing_MR.d_res_low_rotation = resL ;
                    }
                    break;
                }
            
            }
        }else if(strstr_space(str,"Sol_--- Translation function ---")){
            
            while (fgets(str, sizeof str, fp) != NULL) {
                if(pattern5(str, "sol_", "Resmin", "Resmax", ":", "")){
                    strcpy(tmp,strstr(str,":")+1);
                    n=sscanf(tmp,"%f%f", &resL,&resH);
                    if(n==2){
                        pdbx_phasing_MR.d_res_high_translation = resH;
                        pdbx_phasing_MR.d_res_low_translation = resL;
                    }
                    break;
                }
            
            }
        }else if(pattern5(str, "sol_", "_Rf_", "_Tf_", "", "") ||
                 pattern5(str, "sol_Mon_", "_Rf",  "_Tf"," ", "") ){
            n=sscanf(str,"%*s %f%f%f %f%f%f %f%f", 
                      &dat[0],&dat[1],&dat[2],&dat[3],&dat[4],&dat[5], &r_fact_tmp, &cc_F_tmp);
             
            if(n==8){
                if(cc_F_tmp>cc_F) {
                    cc_F = cc_F_tmp;
                    r_fact = r_fact_tmp;
                    pdbx_phasing_MR.correlation_coeff_Fo_to_Fc = cc_F;
                    pdbx_phasing_MR.R_factor = r_fact;
                    
                    put_data(dat,"mr_angle_frac");
                    
                }
                
            }
        }else if(strstr_space(str,"S_ Nmon RF TF   theta    phi    chi     tx     ty     tz    TFcnt   Rfac  Corr")){
            fgets(str, sizeof str, fp);
            
            n=sscanf(str+14,"%f%f%f %f%f%f %*s %f%f", 
                     &dat[0],&dat[1],&dat[2],&dat[3],&dat[4],&dat[5], &r_fact_tmp, &cc_F_tmp);
           
            if(n==8){
                if(cc_F_tmp>cc_F) {
                    cc_F = cc_F_tmp;
                    r_fact = r_fact_tmp;
                    pdbx_phasing_MR.correlation_coeff_Fo_to_Fc = cc_F;
                    pdbx_phasing_MR.R_factor = r_fact;

                    put_data(dat,"mr_angle_frac");
                    
                }
              
            }
            
        }else if(strstr_space(str,"Sol_ Cell: ")){
            n=sscanf(str+11,"%f%f%f %f%f%f",
                     &dat[0],&dat[1],&dat[2],&dat[3],&dat[4],&dat[5]);
            if(n==6) put_data(dat,"cell");
            
        }else if(strstr_space(str,"Sol_ Space group :")){
            get_data_set_id(str,":", "\n", tmp);
            if(strlen(tmp)>0) strcpy(symmetry.space_group_name_H_M, tmp);
        }
        
    }
    fclose(fp);
}


void CCP4_beast(FILE *fout, char *inpfile,char *format, char *method)
//       extract things from Beast 
{
    char  tmp[512], **lines;
    int n=0, i=0, nline=0;
    float a1,a2,a3;

    lines=get_lines_from_file(inpfile, &nline);

    for(i=0; i<nline-5; i++){//name.sol file
        
        if(pattern5(lines[i],"For", "trials", "best LLG=", " with mean=","and rms=")&&
           pattern5(lines[i+1],"Signal to noise=", "", "", "","") &&
           pattern5(lines[i+2],"Euler angles:", ".", ".", ".","") &&
           pattern5(lines[i+3],"Translation:", ".", ".", ".","") 
           ){
            pdbx_phasing_MR.LL_gain_translation = get_float_after_id(lines[i], "LLG=");
            
            strcpy(tmp,strstr(lines[i+2],"angles:")+7);
            n=sscanf(tmp, "%f%f%f", &a1,&a2,&a3);
            if(n==3){
                pdbx_phasing_MR.angle_alpha = a1;
                pdbx_phasing_MR.angle_beta = a2;
                pdbx_phasing_MR.angle_gamma = a3;
            }
            strcpy(tmp,strstr(lines[i+3],"lation:")+7);
            n=sscanf(tmp, "%f%f%f", &a1,&a2,&a3);
            if(n==3){
                pdbx_phasing_MR.fract_x = a1;
                pdbx_phasing_MR.fract_y = a2;
                pdbx_phasing_MR.fract_z = a3;                   
            }
            break;
            
        }
    }
    if(nline>0 && lines)free_memory_2d(lines, nline);
}

void put_data(float *dat, const char *id)
{
    if(!strcmp(id,"cell")){
        cell.length_a = dat[0];
        cell.length_b = dat[1];
        cell.length_c = dat[2];
        cell.angle_alpha = dat[3];
        cell.angle_beta = dat[4];
        cell.angle_gamma = dat[5];
        
    }else if(!strcmp(id,"mr_angle")){
        pdbx_phasing_MR.angle_alpha = dat[0];
        pdbx_phasing_MR.angle_beta = dat[1];
        pdbx_phasing_MR.angle_gamma = dat[2];
        
    }else if(!strcmp(id,"mr_frac")){
        pdbx_phasing_MR.fract_x = dat[0];
        pdbx_phasing_MR.fract_y = dat[1];
        pdbx_phasing_MR.fract_z = dat[2];
        
    }else if(!strcmp(id,"mr_angle_frac")){
        pdbx_phasing_MR.angle_alpha = dat[0];
        pdbx_phasing_MR.angle_beta = dat[1];
        pdbx_phasing_MR.angle_gamma = dat[2];
        
        pdbx_phasing_MR.fract_x = dat[3];
        pdbx_phasing_MR.fract_y = dat[4];
        pdbx_phasing_MR.fract_z = dat[5];
        
    }
}

