/*
FILE:     pdb_extract.C
*/
/*
VERSION:  3.004
*/
/*
DATE:     9/11/2007
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2007 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/* program to extract information from crystallographic softwares */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <unistd.h>

#include "TableFile.h"
#include "CifFile.h"
#include "CifParserBase.h"
#include "structure.h"  
#include "structure-ini.h"  
#include "harv.h"
#include "util.h"
#include "version.h"

char EXPERIMENT[10];  //X-RAY or NMR
extern COMPUTING computing;
struct cif_items cif;
extern REFINE refine;
extern EXPTL exptl;
extern PDBLINE p;

//int NPDB=0;



int main(int argc, char **argv)
{
    char outfile[512],method[80]; 
    int  i,nline=0;    
    FILE *fout=NULL;

    
    strcpy(outfile,"");
    for(i=0; i<argc; i++){
        if(!strcmp_case(argv[i], "-NMR")){
            strcpy(EXPERIMENT,"NMR");
        }else if(i<argc-1 && !strcmp_case(argv[i], "-O")){
            strcpy(outfile,argv[i+1]);
        }else if(!strcmp_case(argv[i], "-fix_error")){
            fix_old_pdb_extract_error(argc, argv);
        }else if(!strcmp_case(argv[i], "-version")){
            check_version();
            exit(0);
        }
        
    }
    
    if(strlen(outfile) <= 0) strcpy(outfile, "pdb_extract.mmcif");  
    extract_seq (argc, argv);
    
    printf("==============================================================\n");
    printf("|           pdb_extract (version-%s ; %s)      |\n",
          PDB_EXTRACT_VERSION,PDB_EXTRACT_DATE );
    printf("==============================================================\n");
    printf("|You can use the option 'pdb_extract -version' to check if    |\n");
    printf("|the version that you are using is our latest release.        |\n");
    printf("==============================================================\n");

    
    if(!strcmp_case(EXPERIMENT, "NMR")){
        proc_nmr_structure(outfile, argc, argv);
        exit(0); 
    }
    
    strcpy( exptl.method, "X-RAY DIFFRACTION");
    
    printf("\nExtracting information about X-RAY structure\n\n");
    
    check_input_error(argc, argv); 
    
    fout = fopen(outfile,"w");
    write_block_method(fout, argc, argv,method);
    
    get_software_info(fout, argc, argv);

    if(!strcmp_case(method,"SIR") || strstr_case(method,"MIR"))
        strcpy(method,"MIR");
    else
        strcpy(method,"MAD");

    
    read_entity_poly(fout, argc, argv, method);
//    NPDB=pdb2cif_maxit(argc,argv,pdb_cif);
    
    extraction_new(fout, argc, argv);
    extraction(fout, argc, argv, method, "-P",  "PHS");
    extraction(fout, argc, argv, method, "-D",  "DM");
    extraction(fout, argc, argv, method, "-M",  "MR");
    extraction(fout, argc, argv, method, "-R",  "REF");
    
    write_mmCIF(fout, argc, argv);
    
    fclose(fout);
    
//    if(NPDB==1) merge_files(outfile,pdb_cif);
    
    make_cif_item_standard(outfile) ;
    
    cifparse(outfile, outfile,250);
    
    reorder_shell(argc, argv, outfile);
    cifparse(outfile, outfile,100);
    nline = num_of_line(outfile);
//    test_cif(outfile); //only for test, 
   
    printf("\nOutput file=  %s (%d lines)\n\n", outfile, nline);
    return 0;   
}

int pdb2cif_maxit(int argc, char **argv, char *pdb2ciffile)
// Maxit is used only for some restricted PDB.
{
    char command[256], pdbfile[256],output[256], **lines;
    char *t1, *t2, *t3, category[256], item[40], str[256];
    int i=0, nline, n1=0, n2=0, n3=0, n4=0, n5=0, n6=0, n7=0, len;
    
    FILE *ftmp=NULL;
    
    
    for(i=1; i<argc-1; i++){
        if(!strcmp_case(argv[i],"-ipdb")){
            strcpy(pdbfile, argv[i+1]);
            n1=1;
            break;
        }
    }
    if(n1<=0) return 0;
    n1=0;
    
    ftmp = get_temp_file(pdbfile);
    while(fgets(str, sizeof str, ftmp)!= NULL){ // check PDB
        if(!strncmp(str, "SOURCE", 6)){
            n1=1;
        }else if(!strncmp(str, "KEYWDS", 6)){
            n2=1;
        }else if(!strncmp(str, "AUTHOR", 6)){
            n3=1;
        }else if(!strncmp(str, "JRNL  ", 6)){
            n4=1;
        }else if(!strncmp(str, "SEQRES", 6)){
            n5=1;
        }else if(!strncmp(str, "COMPND", 6)){
            n6=1;
        }else if(!strncmp(str, "TITLE", 6)){
            n7=1;
        }else if(!strncmp(str, "ATOM", 4) || !strncmp(str, "HETATM", 6)){
            break;
        }
    }
    if(ftmp)fclose(ftmp);
    if(n1+n2+n3+n4+n5+n6+n7<=3 ){
        return 0;
    }

    printf("Using maxit to convert PDB to mmcif!\n");
    sprintf(command ,"maxit-v8.01-O  -i %s  -o 1\" ",  pdbfile);
    system(command);

    
    sprintf(output ,"%s.cif", pdbfile);
    if(strrchr(output, '/')){
        strcpy(command, strrchr(output, '/')+1);
        strcpy(output, command);
    }
    

    lines=get_lines_from_file(output, &nline);
    if((ftmp = fopen(output, "w"))==NULL) return 0;
    if(nline<40)  return 0;
    n1=0;
    n3=0;
    for(i=0; i<nline; i++){
        n2=0;
        rid_of_front_space(lines[i]);
        n1++;
        len=strlen(lines[i])+1;
        
        t1=new char[len];
        t2=new char[len];
        t3=new char[len];
       
        n2=sscanf(lines[i], "%s%s%s", t1, t2,t3);
        
        if(n2==1){
            if(!strncmp(lines[i], "data_", 5) && n1<10) continue;
        }else if(n2==2){
            if(strlen(t2)<2 && (t2[0]=='?' || t2[0]=='.')){
                if(t1[0]=='_' && strchr(t1,'.')){
                    
                    strcpy(item, strchr(t1,'.')+1);
                    get_data_set_id(t1,"_", ".", category);

                    if(strlen(category)>2 && strlen(item)>1 && !strchr(item,'.')){
                        continue;
                    }
                }
            }
        }
        delete [] t1;
        delete [] t2;
        delete [] t3;
        fprintf(ftmp, "%s", lines[i]);
        n3++;
        
    }
    fclose(ftmp);
    if(nline>0) free_memory_2d(lines,nline);

    if(n3<40) return 0;
    
    lines=get_lines_from_file(output, &nline);
    if((ftmp = fopen(output, "w"))==NULL) return 0;
    
    ftmp = fopen(output, "w");
    n3=0;
    for(i=0; i<nline-1; i++){
        if(i>0 && (strstr(lines[i], ".id")|| strstr(lines[i], "_id")) &&
           lines[i-1][0]=='#' && lines[i+1][0]=='#') continue;
        fprintf(ftmp, "%s", lines[i]);
        n3++;
    }
    fclose(ftmp);
    if(nline>0) free_memory_2d(lines,nline);
    if(n3<10) return 0;
    strcpy(pdb2ciffile,output);
    
    return 1;
}

void merge_files(char *outfile, char *pdb_cif)
{
    char command[512];
    
    sprintf(command ,"/bin/csh -c \"/bin/cat %s >>  %s \" ",pdb_cif, outfile);
    system(command);

}


void fix_old_pdb_extract_error(int argc, char **argv)
{
    int i=0;
    char prog[80], inpfile[512], str[5120], fileout[80], fileout2[80], fileout3[512];
    char data_block[80];
    
    FILE *fp, *fo, *fp2;

    strcpy(fileout, "pdb_extract_error.tmp");
    strcpy(fileout2, "test.cif");
    
    
    for(i=1; i<argc-1; i++){
        if(!strcmp_case(argv[i],"-r")){
            strcpy(prog, argv[i+1]);
        }else if(!strcmp_case(argv[i],"-ipdb")){
            strcpy(inpfile, argv[i+1]);
        }
    }
    sprintf(fileout3, "%s-new", inpfile);
    
    if(strcmp_case(prog,"extract")) return;

    if((fp=fopen(inpfile, "r"))==NULL)
       open_file_error(inpfile, "fix_old_pdb_extract_error");
    
    if((fo=fopen(fileout, "w"))==NULL)
       open_file_error(fileout, "fix_old_pdb_extract_error");

    
    while (fgets(str, sizeof str, fp) != NULL) {
        if(!strncmp(str, "REMARK  ",8 ))
            fprintf(fo, "%s", str);
    }
    fprintf(fo, "END\n");
    fclose(fo);
    fclose(fp);

    if((fo=fopen(fileout2, "w"))==NULL)
       open_file_error(fileout2, "fix_old_pdb_extract_error");
    
    pdb_2_cif(fo,fileout);
    write_mmCIF(fo, argc, argv);
    fclose(fo);
    
    cifparse(fileout2,fileout2,250);

    if((fo=fopen(fileout3, "w"))==NULL)
       open_file_error(fileout3, "fix_old_pdb_extract_error");


    if((fp=fopen(fileout2, "r"))==NULL)
       open_file_error(fileout2, "fix_old_pdb_extract_error");
    
    if((fp2=fopen(inpfile, "r"))==NULL)
       open_file_error(inpfile, "fix_old_pdb_extract_error");
    
    while (fgets(str, sizeof str, fp2) != NULL) {
        rid_of_front_space(str);
        
        if(!strncmp(str,"data_",5)) {
            strcpy(data_block, str);
            break;
        }
    }
    
    rewind(fp2);
    
    fprintf(fo, "%s",data_block );
    while (fgets(str, sizeof str, fp) != NULL) {
        if(!strncmp(str,"_computing.",11) ||
           !strncmp(str,"data_UNNAMED-0",14) ||
           !strncmp(str,"_exptl_crystal.",15)) continue;
         fprintf(fo, "%s", str);
    }

    
    while (fgets(str, sizeof str, fp2) != NULL) {
         fprintf(fo, "%s", str);
    }

    fclose(fo);
    
    cifparse(fileout3,fileout3,80);
            
    exit(0);
}

void extraction_new(FILE *fout, int argc, char **argv)
// the way for extraction_new is different from extraction
{
    int i=0;
    char prog[80];
    
    
    for(i=1; i<argc-2; i++){
        
        if(!strcmp_case(argv[i],"-s") ){
            strcpy(prog, argv[i+1]);
            extract_scale(fout, argc, argv, i+2, prog);
            
        }else if (!strcmp_case(argv[i],"-sp")){
            strcpy(prog, argv[i+1]);
            extract_scale_phase(fout, argc, argv, i+2, prog);
        
        }else if (!strcmp_case(argv[i],"-i")){
            strcpy(prog, argv[i+1]);
            extract_index(fout, argc, argv, i+2, prog);  
        }
        
    }
}

int unix_options(const char **all_id, char *id, int n)
{
    int i=0;

    for(i=0; i<n; i++){
        if(!strcmp_case(all_id[i], id)){
            return 1;
        }
    }
    return 0;
}


void extract_index(FILE *fout, int argc, char **argv, int start, char *prog)
{
    int i=0;
    char infile[512];
    const char *id[8] = {"-i", "-p", "-e", "-d", "-m", "-r", "-s", "-sp"};
    
    for(i=start; i<argc-1; i++){
        if(unix_options(id, argv[i], 8)) break;
        if(!strcmp_case(argv[i],"-ILOG") ){
            strcpy(infile, argv[i+1]);
            if(!strcmp_case(prog, "HKL")|| !strcmp_case(prog,"scalepack")||
               !strcmp_case(prog, "HKL2000") || !strcmp_case(prog, "DENZO")){
                
                printf("HKL/Scalepack/DENZO output Log file: (%s)\n",infile);
                
                extract_HKL_log_index(infile);
                
            }else if (!strcmp_case(prog,"DTREK")){

                printf("D*TREK output Log file (%s)\n",infile);
                extract_DTREK_log_index(infile); 
                        
                        
            }else if(!strcmp_case(prog,"mosflm")){

                printf("MOSFLM output Log file (%s)\n",infile);
                extract_MOSFLM_log_index(infile);
            }
        }else if (!strcmp_case(argv[i],"-ICIF") ){
            strcpy(infile, argv[i+1]);
            write_cif(fout, infile, "");
        }
    }

}
 

void extraction(FILE *fout, int argc, char **argv, char *method,
               const char *option_id, const char *step_id)
// option_id == -R, -P, -D, -M:   step_id == REF, PHS, DM, MR
    
{
    int i=0, j=0;
    char prog[512];
    
    for(i=1; i<argc-2; i++){
        
        if(!strcmp_case(argv[i],option_id)){
            strcpy(prog, argv[i+1]);
           
            for(j=i+2; j<argc; j++){
                if(argv[j][0] == '-' && toupper(argv[j][1]) != 'I' ) break;
      
                if(!strcmp_case(argv[j],"-ILOG") ){
                    process_files(fout,&j,argc,argv,prog,"LOG",method,step_id);
                    
                }else if (!strcmp_case(argv[j],"-ICIF")){
                    process_files(fout,&j,argc,argv,prog, "CIF",method,step_id);
                    
                }else if (!strcmp_case(argv[j],"-IPDB")){
//                    if(!strcmp_case(option_id, "-R") && NPDB ==1) continue;
                    
                    process_files(fout,&j,argc,argv,prog, "PDB",method,step_id);
                    
                }
                
            }
            
        }
    }

}

void process_files(FILE *fout, int *j, int argc, char **argv,
                   char *prog, const char *format_in,  char *method, const char *id)
/* continue to take all the argument until meet - or end
 special treatment for SHARP.
*/    
{
    int k=0;
    char infile[512], str[512], tmp[512], format[30];
    FILE *fp=NULL, *fpp=NULL;
    

strcpy(format, format_in);
    if(!strcmp_case(prog, "SHARP") && !strcmp_case(format, "LOG")){
        if((fp=fopen("sharp_phs_files.tmp", "w"))==NULL){
            printf("Sorry disk is writen-protected! please give permision\n");
            exit(0);
        }
    }

    sprintf(tmp,"%s%s%s", prog, format,id);
    upperstr(tmp);
    
    for(k= (*j)+1; k<argc; k++){
        if(argv[k][0] == '-' || k>=argc) {
            *j=k-1;
            break;
        }
        strcpy(infile, argv[k]);
        
        if(!strcmp_case(tmp, "SHARPLOGPHS")){
            if((fpp = fopen(infile, "r"))==NULL){
                printf("I can not open file %s\n", infile);
                continue;
            }
            printf("SHARP phasing;  file_format=%s:  file_name=%s\n",
                   format, infile);
            
            while(fgets(str, sizeof str,fpp)!=NULL){
                fprintf(fp, "%s", str);
            }
            fclose(fpp);
        }
        
        if(strstr(id,"REF")){
            for_refine(fout, prog, infile, format, method);
        }else if(strstr(id,"PHS")){
            
            if(strcmp_case(tmp, "SHARPLOGPHS"))
                for_phasing(fout, prog, infile, format, method);
        }else if(strstr(id,"DM")){
            for_dm(fout, prog, infile, format, method);
            
        }else if(strstr(id,"MR")){
            for_mr(fout, prog, infile, format, method);
            
        }

        
    }
    
    if(!strcmp_case(tmp, "SHARPLOGPHS")){
        fclose(fp);
        for_phasing(fout, prog,(char *)  "sharp_phs_files.tmp", format, method);
    }
}

void for_mr(FILE *fout,char *progname,char *filename,char *format,char *method)
/* various program for phasing experiments */
{
    char prog[512];

    strcpy(prog, progname);
    upperstr(prog);
    
    if(strlen(filename)<=0){
        printf("File (%s) not exist (routine:for_mr)\n", filename);
        return;
    }
    
    if(!strcmp_case(prog, "CNS")){ 
        printf("MR using CNS;  file_format=%s:  file_name=%s\n", format, filename);
        CNS_mr(fout, filename, format, method);

    }else if(!strcmp_case(prog, "AMORE")){
        printf("MR using AMORE;  file_format=%s:  file_name=%s\n", format, filename);
        CCP4_amore(fout, filename, format, method);

    }else if(!strcmp_case(prog, "EPMR")){
        printf("MR using EPMR;  file_format=%s:  file_name=%s\n", format, filename);
        EPMR_mr(fout, filename, format, method);

    }else if(!strcmp_case(prog, "MOLREP")){
        printf("MR using MOLREP;  file_format=%s:  file_name=%s\n", format, filename);
        CCP4_molrep(fout, filename, format, method);

    }else if(!strcmp_case(prog, "PHASER")){
        printf("MR using PHASER;  file_format=%s:  file_name=%s\n", format, filename);
        CCP4_phaser_mr(fout, filename, format, method);

    }else if(!strcmp_case(prog, "BEAST")){
        printf("MR using BEAST;  file_format=%s:  file_name=%s\n", format, filename);
        CCP4_beast(fout, filename, format, method);
        
    }else if(!strcmp_case(prog, "COMO")){
        printf("MR using COMO;  file_format=%s:  file_name=%s\n", format, filename);
        COMO_mr(fout, filename, format, method);

    }else {
        printf("MR using %s;  file_format=%s:  file_name=%s\n", prog, format, filename);
        unknown_prog(fout, filename, format, method);        
    }
    
}

void for_phasing(FILE *fout, char *progname, char *filename, char *format,char *method)
/* various program for phasing experiments */
{
    char prog[512];

    strcpy(prog, progname);
    upperstr(prog);
    
    if(strlen(filename)<=0){
        printf("File (%s) not exist (routine:for_phasing)\n", filename);
        return;
    }
    
    if(!strcmp_case(prog, "CNS")){ /* for heavy atom  phasing */
        printf("CNS phasing;  file_format=%s:  file_name=%s\n", format, filename);
        CNS_phase_file_assign(fout, filename, format, method);

    }else if(!strcmp_case(prog, "MLPHARE")){
        printf("MLPHARE phasing;  file_format=%s:  file_name=%s\n", format, filename);
        CCP4_phase_file_assign(fout, filename, format, method);

    }else if(!strcmp_case(prog, "BP3")){
        printf("BP3 phasing;  file_format=%s:  file_name=%s\n", format, filename);
        BP3_phase(fout, filename, format, method);
        
    }else if(!strcmp_case(prog, "PHASER")){
        printf("PHASER phasing;  file_format=%s:  file_name=%s\n", format, filename);
        CCP4_phaser_ep(fout, filename, format, method);

    }else if(!strcmp_case(prog, "SOLVE")){
        printf("SOLVE phasing;  file_format=%s:  file_name=%s\n", format, filename);
        SOLVE_phase(fout, filename, format, method);
        
    }else if(!strcmp_case(prog, "SHARP")){
        if(strcmp_case(format, "LOG"))
            printf("SHARP phasing;  file_format=%s:  file_name=%s\n", format, filename);
        SHARP_phase(fout, filename, format, method);

    }else if(!strcmp_case(prog, "SHELXS") || !strcmp_case(prog, "SHELXD") ){
        printf("SHELX phasing;  file_format=%s:  file_name=%s\n", format, filename);
        SHELX_phase(fout, filename, format, method);

    }else if(!strcmp_case(prog, "SNB")){
        printf("SnB phasing;  file_format=%s:  file_name=%s\n", format, filename);
        SNB_phase(fout, filename, format, method);

    }else if(!strcmp_case(prog, "BNP")){
        printf("BnP phasing;  file_format=%s:  file_name=%s\n", format, filename);
        BNP_phase(fout, filename, format, method);

    }else if(!strcmp_case(prog, "PHASES")){
        printf("PHASES phasing;  file_format=%s:  file_name=%s\n", format, filename);
        BNP_phase(fout, filename, format, method);

    }else {
        printf("%s phasing;  file_format=%s:  file_name=%s\n", prog, format, filename);
        unknown_prog(fout, filename, format, method);        
    }
    
}

void for_dm(FILE *fout, char *progname, char *filename, char *format,char *method)
/* various program for density modification */
{
    char prog[512];

    strcpy(prog, progname);
    upperstr(prog);


    if(strlen(filename)<=0){
        printf("File (%s) not exist (routine:for_dm)\n", filename);
        return;
    }
    
    if(!strcmp_case(prog, "CNS")){ 
        printf("CNS density modification; file_format=%s:  file_name=%s\n", format, filename);
        CNS_phasing_DM(fout, filename,format, method);
        
    }else if(!strcmp_case(prog, "DM")){
        printf("DM density modification; file_format=%s:  file_name=%s\n", format, filename);
        CCP4_phasing_DM(fout, filename,format, method);
        
    }else if(!strcmp_case(prog, "SOLOMON")){
        printf("SOLOMON density modification; file_format=%s:  file_name=%s\n", format, filename);
        CCP4_phasing_SOLOMON(fout, filename,format, method);
        
    }else if(!strcmp_case(prog, "SHARP")){ /*the same as DM*/
        printf("SHARP density modification; file_format=%s:  file_name=%s\n", format, filename);
        SHARP_phasing_DM(fout, filename, format,method);
        
    }else if(!strcmp_case(prog, "RESOLVE")){
        printf("RESOLVE density modification; file_format=%s:  file_name=%s\n", format, filename);
        SOLVE_phasing_DM(fout, filename, format,method);

    }else {
        printf("%s density modification;  file_format=%s:  file_name=%s\n", prog, format, filename);
        unknown_prog(fout, filename, format, method);        
    }
    
}

void for_refine(FILE *fout, char *progname, char *filename, char *format, char *method)
/* various program for  final refinement*/
{
    char prog[80];
    int chain=1;

    strcpy(prog, progname);
    upperstr(prog);

    if(strlen(filename)<=0){
        printf("File (%s) not exist (routine:for_refine)\n", filename);
        return;
    }
    
    if(!strcmp_case(format, "PDB")){
        if(is_pdb(filename, &chain)<5){
            printf("Warning! The file (%s) does not have enough atoms for PDB deposition.\n",filename);
        }
    }
    
            
    if(!strcmp_case(prog, "CNS")){ /* final structure refinement*/
        printf("CNS refinement; file_format=%s:  file_name=%s\n", format, filename);
        if(!strcmp_case(format, "PDB")){
            pdb_2_cif(fout,  filename);

/*
// disable it for save. if any problem, use the tool to correct  
            infor=check_pdb(filename);
            sprintf(new_pdb, "%s_new", filename);
            if(strstr(infor," OCC ")){ // occ exist

                fix_alt_in_order(filename ,new_pdb);
                pdb_2_cif(fout, new_pdb );
            }else{
                pdb_2_cif(fout,  filename);
            }
            if(infor) delete [] infor;
*/            
        }else if(!strcmp_case(format, "CIF")) {
            CNS_final_struct_ref(fout, filename, format, method);
        }else if(!strcmp_case(format, "LOG")) {
            CNS_final_struct_log(fout, filename);
        }
        
    }else if(strstr_case(prog, "REFMAC")){
        printf("REFMAC5 refinement; file_format=%s:  file_name=%s\n", format, filename);
        CCP4_ref_refmac5(fout, filename,format, method);
        
    }else if(!strcmp_case(prog, "RESTRAIN")){
        printf("RESTRAIN refinement; file_format=%s:  file_name=%s\n", format, filename);
        if(!strcmp_case(format, "CIF")) { 
            CCP4_ref_restrain(fout, filename,format, method);
        }else if(!strcmp_case(format, "LOG")) {
//            CCP4_ref_restrain_log(fout, filename, method);
        }
        
        
    }else if(!strcmp_case(prog, "SHELXL") ||!strcmp_case(prog, "SHELX") ||
             !strcmp_case(prog, "SHELXH")){
        printf("SHELX refinement; file_format=%s:  file_name=%s\n", format, filename);
        SHELX_final_struct_ref(fout, filename, format, method);
        
    }else if(!strcmp_case(prog, "TNT")){
        printf("TNT refinement; file_format=%s:  file_name=%s\n", format, filename);
        TNT_final_struct_ref(fout, filename, format, method);

    }else if(!strcmp_case(prog, "PHENIX")){
        printf("PHENIX refinement; file_format=%s:  file_name=%s\n", format, filename);
        if(!strcmp_case(format, "PDB")){
            pdb_2_cif(fout, filename);
        }else{
            PHENIX_final_struct_log(fout, filename);
        }
        
/*
    }else if(!strcmp_case(prog, "WARP")){
        printf("ARP_wARP refinement; file_format=%s:  file_name=%s\n", format, filename);
        WARP_refine(fout, filename, format, method);
*/
    }else { 
        printf("%s refinement;  file_format=%s:  file_name=%s\n", prog, format, filename);
        unknown_prog(fout, filename, format, method);
        return;
    }    
}
    
void fix_alt_in_order(char *pdbfile , char *output)
// put the alt ID into AAAA BBBB pattern. in general for PDB format
{
    char **line,  **line_tmp, **comp, **atom,**seq, *chain, tmp[256];
    int nline=0,nline_tmp=0, i, j=0,  n,m,k, ns=0, **residx;
    int n1,n2, skip=0,alt1, alt2,id,  nalt=0, *skip_id, key;
    float *xx,*yy, *zz,*occ;
    const char *alt_id="BCBEFG";
    FILE *fout;

    fout=fopen(output, "w");
    
    line_tmp =get_lines_from_file( pdbfile, &nline_tmp);
    
    line=new char *[nline_tmp];
    comp=new char *[nline_tmp];
    atom=new char *[nline_tmp];
    seq=new char *[nline_tmp];
    chain=new char [nline_tmp];
    
    xx=new float [nline_tmp];
    yy=new float [nline_tmp];
    zz=new float [nline_tmp];
    occ=new float [nline_tmp];
    
    for(i=0; i<nline_tmp;i++) {
        if(!strncmp(line_tmp[i],"ATOM  ",6)|| !strncmp(line_tmp[i],"HETATM",6) )break;
        fprintf(fout,"%s", line_tmp[i]);
    }
    
    n=0;
    for(i=0; i<nline_tmp;i++) {
        m=strlen(line_tmp[i])+1;
        
        line[n]=new char [m];
        comp[n]=new char [4];
        atom[n]=new char [4];
        seq[n]=new char [4];
        
        if(strncmp(line_tmp[i],"ATOM  ",6) && strncmp(line_tmp[i],"HETATM",6) )continue;
        
        parse_pdbline(line_tmp[i]);
        
        strcpy(line[n],line_tmp[i]);
        strcpy(comp[n],p.resname);
        strcpy(atom[n],p.atomname);
        strcpy(seq[n],p.reseq);
        chain[n]=p.chain;
        
        occ[n]=p.occ;
        xx[n]=p.x;
        yy[n]=p.y;
        zz[n]=p.z;

        n++;
    }
    nline=n;
    
    if(nline_tmp) free_memory_2d(line_tmp,nline_tmp);
    residx=get_residx2( nline, line, seq, &ns);

    skip_id=new int[ns];
    skip=0;
    for(i=0; i<ns;i++){
        alt1=0;
        for(k=residx[i][0]; k<residx[i][1];k++){ // check occ
            if(occ[k]<0.999){
                alt1=1;
                break;
            }
        }
        id=0;
        if(skip>0){ //skip the residues already added to the file
            for(m=0; m<skip;m++){
                if(i==skip_id[m]){
                    id=1;
                    break;
                }
            }
        }
        if(id==1) continue;
        
        if(alt1==0){ // not alt
            for(k=residx[i][0]; k<residx[i][1];k++){
                strcpy(tmp, line[k]);
                fprintf(fout,"%s", tmp);
            }
            
        }else{ // alt exist
            n1=residx[i][0];
            
            key=look_for_alt_pair(i,ns, residx, atom, comp, seq, occ);
            for(k=residx[i][0]; k<residx[i][1];k++){
                strcpy(tmp, line[k]);
                if(occ[k]<0.99 && key>0) tmp[16]='A'; // partner exists
                tmp[21]=get_chainid(n1, ns, chain,residx);
                fprintf(fout,"%s", tmp);
            }
            nalt=0;
            for(j=i+1; j<ns;j++){ //check rest residue if alt, and add them.
                n2=residx[j][0];
                alt2=0;
                for(k=residx[j][0]; k<residx[j][1];k++){ // check occ
                    if(occ[k]<0.999){
                        alt2=1;
                        break;
                    }
                }
                if(alt2==0)
                    continue;
                else{ // check if the alt residue (overlap should be checked here);
                    if(!strcmp(comp[n1], comp[n2]) && !strcmp(seq[n1], seq[n2]) ){
                        if(!atom_atom_check(i,j, residx,atom,occ)) continue;
                        
                        for(k=residx[j][0]; k<residx[j][1];k++){
                            strcpy(tmp, line[k]);
                            if(occ[k]<0.99){
                                tmp[16]=alt_id[nalt];
                                tmp[21]=get_chainid(n1, ns, chain,residx);
                                fprintf(fout,"%s", tmp);
                            } 
                        }
                        skip_id[skip]=j;
                        skip++;
                        nalt++;
//                        printf("nskip=%d nalt=%d, j=%d %d\n", skip, nalt, j, ns);
                        
                    }
                }
            }
        }
    }
    if(nline) free_memory_2d(comp,nline);
    if(nline) free_memory_2d(atom,nline);
    if(nline) free_memory_2d(seq,nline);
    if(nline) free_memory_2d(line,nline);
    if(nline) delete [] chain;
    if(nline) delete [] xx;
    if(nline) delete [] yy;
    if(nline) delete [] zz;
    if(nline) delete [] occ;
    if(skip) delete []skip_id;
    
    fclose(fout);
    if(nalt>0) printf("The alt positions have been put into order!\n");
    
}

int look_for_alt_pair(int i,int ns,int **residx,char **atom,char **comp,
                      char **seq, float *occ)
// check if residue i has alt with the rest residues and return the residue number and nskip
{
    int key=0, k,j, n1,n2, alt2 ;
    
    
    n1=residx[i][0];
    for(j=i+1; j<ns;j++){ //check rest residue if alt, and add them.
        n2=residx[j][0];
        alt2=0;
        for(k=residx[j][0]; k<residx[j][1];k++){ // check occ
            if(occ[k]<0.999){
                alt2=1;
                break;
            }
        }
        if(alt2 == 1){ // check if the alt residue 
            if(!strcmp(comp[n1], comp[n2]) && !strcmp(seq[n1], seq[n2]) ){
                key=atom_atom_check(i,j, residx,atom,occ);
                
                if(key>0){
//                    printf("residue %d and %d are alt partner!\n",i, j);
                    break;
                }
            }
        }
    }
    return key;
 
}


int atom_atom_check(int i,int j, int **residx, char **atom, float *occ)
//check if the sum of occupancy of two atoms <= 1.00
{
    int k, m, natm=0, na=0;
    
    for(k=residx[i][0]; k<residx[i][1]; k++){
        for(m=residx[j][0]; m<residx[j][1];m++){
            if(!strcmp(atom[k], atom[m])){
                if(occ[k]<0.99 || occ[m]<0.99){
                    na++;
                    if(occ[k] + occ[m]<1.001){ //two atoms are alt.
                        natm++;
                    }
                }
            }
        }
    }
    if (na==natm && na>0)
        return 1;
    else
        return 0;
    
}

int ** get_residx2(int nline, char **line, char ** seq, int *nres)
{
    char  tmp[256], tmp1[256];
    int **residx,i,j=0, ns;
    
    residx = new int *[nline];
    for(i=0; i<nline;i++) residx[i]=new int [2];
    
    ns=0;
    for(i=0; i<nline; i++){
        strncpy(tmp,line[i]+17, 9);
        tmp[9]='\0';
        residx[ns][0]=i;
        for(j=i+1; j<nline; j++){
            strncpy(tmp1,line[j]+17, 9);
            tmp1[9]='\0';            
            
            if(strcmp(tmp, tmp1)){ // different residue
                residx[ns][1]=j;
                ns++;
                i=j-1;
                break;
            }
        }
        
    }
    if(ns>0){
        residx[ns][0]=residx[ns-1][1];
        residx[ns][1]=nline;
    }
    
    *nres=ns+1;
    return residx;
}



char get_chainid(int n1, int ns, char *chain, int **residx)
{
    char c, c1,c2;
    int i,nline;

    c= ' ';
    c1= ' ';
    c2= ' ';
    
    c=chain[n1];
    nline=residx[ns-1][1];
    
    if(c != ' ') return c;
    
    for (i=n1; i<=0; i--){
        if(chain[i] != ' ') {
            c1=chain[i];
            break;
        }
    }
    for (i=n1; i<nline; i++){
        if(chain[i] != ' ') {
            c2=chain[i];
            break;
        }
    }
    if(c1==c2 && c1!=' '){
        return c1;
    }else if(c1==c2 && c1 ==' '){
        printf("Warning! No chain ID in the pdbfile.\n");
        return c1;
    }else if( c1 ==' ' && c2!=' '){
        return c2;
    }else if( c2 ==' ' && c1!=' '){
        return c1;
    }if(c1!=c2 && c1!=' ' && c2!=' '){ //middle of two chains
        return c1;
        
    }else
        return c2;
    
    
}

void make_cif_item_standard(char *inpfile)
{
    char str[512], **all_items, category[100],item[100], dic[512];
    char category_dic[100],item_dic[100], *temp=NULL;
    int i, nitem=0, id=0, biol=0;
    FILE *ftmp, *fout;

    
    if (!strcmp_case(CCP4,"yes") ){
        if((temp = getenv("CCP4")) != NULL) {
            sprintf(dic,"%s/%s", temp,CIF_ITEMS);
        } else{
            printf("Warning! you have not set CCP4 environment!\n");
            return;
        }
        
    }else{
        if((temp = getenv("PDB_EXTRACT")) != NULL) {
            sprintf(dic,"%s/pdb-extract-data/mmcif_pdbx_2.items", temp);
        }else{
            printf("Warning! you have not set PDB_EXTRACT environment!\n");
            return;
        }
    }
    
    ftmp=get_temp_file(inpfile);
    fout=fopen(inpfile,"w");

    all_items = get_lines_from_file(dic,&nitem);
    
    while(fgets(str, sizeof str, ftmp)!= NULL){
        id=check_category(str, category, item);
        if(id>0 && strlen(category)>1 && strlen(item) >0 ){
            if(!strcmp_case(category, "_struct_biol"))biol=1;
            
            for(i=0; i<nitem; i++){
                id=check_category(all_items[i], category_dic, item_dic);
                if(!strcmp_case(category_dic, category) &&
                   !strcmp_case(item_dic,item)){
                    
                    strcat(category_dic, ".");
                    strcat(category_dic, item_dic);
                    strcat(category, ".");
                    strcat(category, item);
                    replace_first_str(str,category, category_dic, str);
                    break;
                }
            }
/*                
            if(i==nitem) {
                printf("Warning!  The item (%s.%s) is not in the mmCIF dictionary!\n",
                       category, item);
            }
*/            
                
        }
                                     
        fprintf(fout, "%s",str);    
    }
    if(biol==0){
        fprintf(fout, "\n#\n_struct_biol.id        1 \n");
        fprintf(fout, "_struct_biol.details     N/A \n");
    }
    
        
    if(fout) fclose(fout);
    if(ftmp) fclose(ftmp);
    if(nitem) free_memory_2d(all_items, nitem);
    


    
}


void rewrite_cif(char *inpfile)
{

    char str[512],  category[80],item[80], dic[512];
    char category_dic[80],item_dic[80],  *temp=NULL, **all_items=NULL;
    int id=0,nt=0, n=0, n1=0,n2=0,n3=0,i, nitem=0, len;
    FILE *fp, *fout, *fdic, *fdic_w;

    
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (routine:rewrite_cif)\n",inpfile);
        return;
    }
    
    strcpy(dic, "");
    if((temp = getenv("PDB_EXTRACT")) != NULL) {
        strcpy(dic, temp);
    } else{
        printf("Warning! you have not set PDB_EXTRACT environment!\n");
        return;
    }
    fdic_w = fopen("pdb_extract_1234.tmp", "w");

    open_dictionary(fdic_w, dic, "mmcif_pdbx_2.dic", &n1);
    open_dictionary(fdic_w, dic, "mmcif_rcsb_xray.dic", &n2);
    open_dictionary(fdic_w, dic, "mmcif_rcsb_nmr.dic", &n3);

    nt = n1+n2+n3+1;
    
    if(nt <5) {
    	delete_file("pdb_extract_1234.tmp");
        printf("There is no conversion!\n");
        
	return;
    }

    fdic = fopen("pdb_extract_1234.tmp", "r");
    
    all_items = new char *[nt];
    
    n=0;
    while(fgets(str, sizeof str, fdic)!= NULL){
        len= strlen(str);
        all_items[n] = new char[len + 1];
        strcpy(all_items[n], str);
        n++;
    }
    nitem = n;
     
    if(fdic) fclose(fdic);
    delete_file("pdb_extract_1234.tmp");
    
    fout = fopen("pdb_extr_tmp1234.cif", "w");
   
    while(fgets(str, sizeof str, fp)!= NULL){
        id=check_category(str, category, item);
        if(id>0 && strlen(category)>1 && strlen(item) >0 ){

            for(i=0; i<nitem; i++){
                id=check_category(all_items[i], category_dic, item_dic);
                if(!strcmp_case(category_dic, category) &&
                   !strcmp_case(item, item_dic)){
                    strcat(category_dic, ".");
                    strcat(category_dic, item_dic);
                    strcat(category, ".");
                    strcat(category, item);
                    replace_first_str(str,category, category_dic, str);
                    break;
                }
            }
            
            if(i==nitem) {
//                printf("Warning!  The item (%s.%s) is not in the mmCIF dictionary!\n", category, item);
            }
            
            
        }
                                     
        fprintf(fout, "%s",str);    
    }
    if(fout) fclose(fout);
    if(fp) fclose(fp);
    if(all_items) free_memory_2d(all_items, nitem);
    
    cifparse((char *) "pdb_extr_tmp1234.cif", inpfile,80);
}
void open_dictionary(FILE *fdic_w, char *dic, const char *file, int *n1)
{
    char dict[512], str[512], tmp[512];
    int n=0;
    FILE *fdic=NULL;

    strcpy(dict, "");
    strcat(dict,dic);
    strcat(dict,"/data/ascii/");
    strcat(dict,file);
    
    if((fdic = fopen(dict,"r"))==NULL){
	*n1 = 0;
        printf("Warning! Can not open the file (%s)\n",dict);
	return;
    }
   
    n=0;
    while(fgets(str, sizeof str, fdic)!= NULL){
        if(strstr(str, "save__") && strrchr(str, '.')){
            strcpy(tmp, strstr(str, "save__") + 5);
            fprintf(fdic_w, "%s", tmp);
            n++;
        } 
    }
    *n1=n;
    fclose(fdic);
}


void rewrite_cif_CCP4(char *inpfile)
{

    char str[512],  category[512],item[512], dic[512], dict[512];
    char category_dic[512],item_dic[512],  *temp=NULL, **all_items=NULL;
    int id=0, n=0, i;
    FILE *fp, *fout, *fdic;

    
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (routine:rewrite_cif_CCP4)\n",inpfile);
        return;
    }
    
    strcpy(dic, "");
    if((temp = getenv("CCP4")) != NULL) {
        strcpy(dic, temp);
    } else{
        printf("Warning! you have not set CCP4 environment!\n");
        fclose(fp);
        return;
    }
    
    strcpy(dict, "");
    strcat(dict,dic);
    strcat(dict,CIF_ITEMS);
    
    fdic = fopen(dict, "r");
    
    all_items = new char *[4000];  
    n=0;
    while(fgets(str, sizeof str, fdic)!= NULL){
        all_items[n] = new char[strlen(str) + 1];
        strcpy(all_items[n], str);
        n++;
    }
    if(fdic) fclose(fdic);

    
    fout = fopen("pdb_extr_tmp1234.cif", "w");
   
    while(fgets(str, sizeof str, fp)!= NULL){
        id=check_category(str, category, item);
        if(id>0 && strlen(category)>1 && strlen(item) >0 ){

            for(i=0; i<n; i++){
                id=check_category(all_items[i], category_dic, item_dic);
                if(!strcmp_case(category_dic, category) &&
                   !strcmp_case(item, item_dic)){
                    strcat(category_dic, ".");
                    strcat(category_dic, item_dic);
                    strcat(category, ".");
                    strcat(category, item);
                    replace_first_str(str,category, category_dic, str);
                    break;
                }
            }
        }
                                     
        fprintf(fout, "%s",str);    
    }
    if(fout) fclose(fout);
    if(fp) fclose(fp);
    if(all_items) free_memory_2d(all_items, n);
    
    cifparse((char *) "pdb_extr_tmp1234.cif", inpfile,80);
}




void read_entity_poly(FILE *fout, int argc, char **argv, char *method)
/*for reading ENTITY (write first)
 ntype=0 mmcif file; ntype=1,the text file (data_template.text)
*/
{
    char file1[512], **line;
    int  i, ntype=0,j, nline; 
    FILE *fp=NULL;

    
    for(i=1; i<argc-1; i++){  
        if(!strcmp_case(argv[i],"-IENT")){
            strcpy(file1, argv[i+1]);
            
            printf("\nData template file;  file_name=%s\n",file1);
            if ((fp=fopen(file1, "r"))==NULL){
                open_file_error(file1, "read_entity_poly");
                return;
            }
            
            ntype = type_of_data_template(file1);
    
            if(ntype ==0){
                write_cif(fout,  file1, "CIF");
                
            }else if(ntype ==1){
                parse_adit_text_to_mmcif(fout,  file1,1);
            }else if(ntype ==-1){
                exit(0);
            }
   
            fclose(fp);

            line=get_lines_from_file(file1,&nline);
            for(j=0; j<nline; j++){
                if(strstr(line[j], "_exptl.crystals_number")){
                    j=get_int_after_id(line[j], "_exptl.crystals_number");
                    if(j>0)exptl.crystals_number=j;
            
                    break;
                }
            }
            if(line)free_memory_2d(line,nline);

        }
    }   
}


int type_of_data_template(char *infile)
{
    int  n=0, mtext=0, mcif=0;
    char str[512], tmp[80],cate[80],item[80];
    FILE *fp=NULL;

    
    
    if ((fp=fopen(infile, "r"))==NULL){
        open_file_error(infile, "type_of_data_template");
    }
    
    while (fgets(str, sizeof str, fp) != NULL) {
        if(is_space_line(str)<=0) continue;
        rid_of_front_end_space(str);
        
        n=sscanf(str,"%s", tmp);
        if(n==1 && tmp[0]=='<' &&
           (pattern5(str,"<", "entity_id", "=", "\"", "")||
            pattern5(str,"<", "unit_cell_a", "=", "\"", "")||
            pattern5(str,"<", "contact_author_PI_id", "=", "\"", "")||
            pattern5(str,"<", "contact_author_id", "=", "\"", "")||
            pattern5(str,"<", "molecule_name", "=", "\"", "")||
            pattern5(str,"<", "structure_title", "=", "\"", "")) ){
            mtext++;
            if(mtext >= 3) break;
            
        }else if(tmp[0]=='_' && pattern5(tmp,"_", ".", "", "", "")){
            get_data_set_id(tmp,"_", ".", cate);
            strcpy(item, strstr(tmp,".")+1 );
            if(!strchr(item,'.') && !strchr(cate,'.') &&
               strlen(item)>1 && strlen(cate)>1){
                mcif++;
                if(mcif >=0 ) break;
            } 
        }   
    }
    fclose(fp);
    
    if(mtext>=3){
        return 1;
    }else if(mcif >=0 ){
        return 0;
    }else{
        printf("Sorry! The input file (%s) is neither 'data_template.text' no mmCIF file\n",infile);
        return -1;
        
    }
}
void write_block_method(FILE *fout,int argc, char **argv, char *method)
/* write data block first, extract the first one from refinement
   and delete all others, if exists.
*/
{
    char ind_prog[80],sol_prog[80], ref_prog[80], scl_prog[80];  
    char dm_prog[80], mr_prog[80],  method_mr[40] ;
    int i=0;
    
    fprintf(fout, "data_%s\n", DATA_BLOCK);
    
    strcpy(ref_prog, "");
    strcpy(sol_prog, "");
    strcpy(scl_prog, "");
    strcpy(ind_prog, "");
    strcpy(dm_prog, "");
    strcpy(mr_prog, "");
    strcpy(method, "");
    strcpy(method_mr, "");
    
    for(i=1; i<argc-1; i++){
        if(!strcmp_case(argv[i], "-r")) {
            strcat(ref_prog, argv[i+1]);
            strcat(ref_prog, "  ");
        }else if(!strcmp_case(argv[i], "-e") ) {
            strcat(method, argv[i+1]);
            strcat(method, "  ");
        }else if(!strcmp_case(argv[i], "-p") ) {
            strcat(sol_prog, argv[i+1]);
            strcat(sol_prog, "  ");
        }else if(!strcmp_case(argv[i], "-m")) {
            strcat(mr_prog, argv[i+1]);
            strcat(mr_prog, "  ");
            strcpy(method_mr, "MR");
            
        }else if(!strcmp_case(argv[i], "-d")) {
            strcat(dm_prog, argv[i+1]);
            strcat(dm_prog, "  ");
        }else if(!strcmp_case(argv[i], "-s")) {
            strcat(scl_prog, argv[i+1]);
            strcat(scl_prog, "  ");
        }else if(!strcmp_case(argv[i], "-i")) {
            strcat(ind_prog, argv[i+1]);
            strcat(ind_prog, "  ");
        }
    }
    
    if(strlen(sol_prog)>1 && strlen(mr_prog)>1){
        strcat(sol_prog, " ;   ");
        strcat(sol_prog, mr_prog);
    }else if (strlen(sol_prog)<1 && strlen(mr_prog)>1){
        strcpy(sol_prog, mr_prog);
    }
    
            
    rid_of_front_end_space(ref_prog);
    rid_of_front_end_space(sol_prog);
    rid_of_front_end_space(dm_prog);
    rid_of_front_end_space(ind_prog);
    rid_of_front_end_space(scl_prog);
    rid_of_front_end_space(method);
    rid_of_front_end_space(method_mr);
    
    if(strlen(ref_prog)) strcpy(computing.structure_refinement , ref_prog);
    if(strlen(sol_prog)) strcpy(computing.structure_solution , sol_prog);
    if(strlen(dm_prog))strcpy(computing.pdbx_density_modification , dm_prog);
    if(strlen(scl_prog))strcpy(computing.data_reduction  , scl_prog);
    if(strlen(ind_prog))strcpy(computing.data_collection , ind_prog);
    if(strlen(ind_prog))strcpy(computing.cell_refinement , ind_prog);
   

    if(strlen(method)<=0 && strlen(method_mr)<=0) return;
    
    if(strlen(method)>0 && strlen(method_mr)>0){
        fprintf(fout,"##\nloop_\n");
        fprintf(fout, "_phasing.method \n");
        fprintf(fout, "'%s' \n", method);
        fprintf(fout, "'%s' \n", method_mr);
        sprintf(refine.pdbx_method_to_determine_struct, "%s, %s", method,  method_mr);
               
    }else if(strlen(method)>0 && strlen(method_mr)<=0){
        fprintf(fout, "_phasing.method '%s' \n", method);
        sprintf(refine.pdbx_method_to_determine_struct, "%s", method);
        
    }else if(strlen(method_mr)>0 && strlen(method)<=0){
        sprintf(refine.pdbx_method_to_determine_struct, "MOLECULAR REPLACEMENT");
        fprintf(fout, "_phasing.method '%s' \n", method_mr);
    }
    
    fprintf(fout,"##\n");
}


void usage()
{
    printf("\n======================================================================\n");
    printf("Please type 'pdb_extract -h' for help \n");
    printf("======================================================================\n\n");
    exit(0);
}

int check_item(const char **str, char *item)
{
    int i, n=0;
    for(i=0; i<1000; i++){
        if(!strcmp_case(str[i],"END_STRING")) break;
        if(!strcmp_case(str[i],item)){
            n=1;
            break;
        }
    }
    return n;
}

        

void check_input_error(int argc, char **argv)
/* check various input errors and return some parameters */    
{
    char refine_prog[256];
    char *option = (char*)"-o -e -i -s -sp -r -p -d -m -iLOG -iCIF -iPDB -iENT -iDat -DATACUT";
    char *options = (char*)"-o -e -i -s -sp -r -p -d -m";
    const char *EXP[]={"MR","SAD","MAD","SIR","SIRAS","MIR","MIRAS","AB_INITIO","END_STRING"};
    const char *INDEX[]={"HKL","DENZO","DTREK","MOSFLM","END_STRING"};
    const char  *SCALE[]={"SCALA","HKL","SCALEPACK","DTREK","SAINT",
                          "3DSCALE","XSCALE", "X-GEN", "PROSCALE","END_STRING"};
    const char *PHASE[]={"CNS","XPLOR","MLPHARE","SOLVE","SHELX","SNB","BnP",
                         "SHARP","PHASER","PHASES","WARP","BP3", "END_STRING"};
    const char *MR[]={"AMORE","CNS","XPLOR","EPMR","MOLREP","BEAST","PHASER",
                      "COMO", "END_STRING"};
    const char *DM[]={"CNS","XPLOR","DM","RESOLVE","SOLOMON","SHELXE","SHARP","END_STRING"};
    const char *REFINE[]={"CNS","XPLOR","REFMAC5","REFMAC","SHELX","SHELXL","TNT",
                          "PROLSQ","NUCLSQ", "RESTRAIN","PHENIX","END_STRING"};
    
            
    char *temp=NULL;
    int i=0, last=0, c;
    FILE *fp;
    
    for(i=1; i<argc; i++){
        if(!strcmp_case(argv[i], "-h") || !strcmp_case(argv[i], "-help")){
            
            if(!strcmp_case(CCP4,"yes")){
                if((temp = getenv("CCP4")) != NULL) {
                    strcpy(refine_prog, temp);
                } 
                strcat(refine_prog,CCP4_2_DATA_HELP);
                if((fp = fopen(refine_prog,"r"))==NULL){
                    open_file_error(refine_prog, "check_input_error");
                }  
                while((c=getc(fp))!=EOF){
                    printf("%c", c);
                }
                exit(0);
            }else{
                if((temp = getenv("PDB_EXTRACT")) != NULL) {
                    strcpy(refine_prog, temp);

                }else{
                    printf("Error! you have not set PDB_EXTRACT environment!\n");
                    printf("Please look at the README file in the package.\n");
                    return;
                }


                strcat(refine_prog,EXTRACT_2_DATA_HELP);
                if((fp = fopen(refine_prog,"r"))==NULL){
                    open_file_error(refine_prog, "check_input_error");
                }  
                while((c=getc(fp))!=EOF){
                    printf("%c", c);
                }
                printf("\n");
            
                exit(0);
            }
            
        }
    }

    
    if(argc<3){ 
        printf("There are too few arguments!\n\n");
        usage();
    }

    last=argc-1;   
    if(!strcmp_case(argv[last],"-O")){
        printf("\nInput argument is wrong!!\n");
        printf("The option (%s) should be followed by an output file name!\n",
               argv[last]);
        usage();
    }

    if(!strcmp_case(argv[last],"-E")){
        printf("\nInput argument is wrong!!\n");
        printf("The option (%s) should be followed by one of the experimental methods!\n",
               argv[last]);
        printf("(MR|SAD|MAD|SIR|SIRAS|MIR|MIRAS|AB_INITIO)\n");
        usage();
    }
    
    if(!strcmp_case(argv[last],"-P") || !strcmp_case(argv[last],"-R") ||
       !strcmp_case(argv[last],"-D") || !strcmp_case(argv[last],"-M") ||
       !strcmp_case(argv[last],"-S") || !strcmp_case(argv[last],"-SP")||
       !strcmp_case(argv[last],"-I")){
        printf("\nInput argument is wrong!!\n");
        printf("The option (%s) should be followed by a software name!\n",
               argv[last]);
        usage();
    }

    if(!strcmp_case(argv[last],"-ILOG") || !strcmp_case(argv[last],"-IPDB") ||
       !strcmp_case(argv[last],"-ICIF") || !strcmp_case(argv[last],"-IENT") ) {
        printf("\nInput argument is wrong!!\n");
        printf("The option (%s) should be followed by a input data file name(s)!\n",
               argv[last]);
        usage();
    }
 
    for(i=1; i<argc-1; i++){
        if(argv[i][0] == '-' && !strstr_case(option, argv[i]) ){
            printf("\nInput was wrong!\n");
            printf("You provided wrong option [%s]\n", argv[i]);
            printf("Option should be one of [%s]\n", option);
            usage();
        }			
						 
        if(argv[i][0] == '-' && argv[i+1][0]== '-'){
            printf("\nEither argument (%s) or (%s) is wrong!!\n",
                   argv[i],argv[i+1]);
            printf("The data file names can not be started with - !\n\n");
            usage();
        }

        if(!strcmp_case(argv[i],"-E") ){   /* experiment method  */
            if(!check_item(EXP,argv[i+1])){
                printf("\nInput is Wrong! The option [-e] should be ");
                printf("followed by one of (MR|SAD|MAD|SIR|SIRAS|MIR|MIRAS|AB_INITIO)\n\n");
                usage();
            }


            if(i<argc-2 &&
               (!strcmp_case(argv[i+2],"-ilog")||!strcmp_case(argv[i+2],"-ipdb") ||
                !strcmp_case(argv[i+2],"-idat") ||!strcmp_case(argv[i+2],"-icif") ||
                argv[i+2][0]!='-')){
                
                printf("\nThe argument(%s) after (%s  %s) is wrong!\n",
                       argv[i+2],argv[i], argv[i+1] );
                
                printf("(%s  %s) should be followed by one of (%s) or nothing.\n\n",
                       argv[i], argv[i+1], options );
                usage();
            }
        
        }
        

        if (!strcmp_case(argv[i],"-I") ){
            if(!check_item(INDEX,argv[i+1]))  pdb_cif_file(i, argc, argv);
            
        }else if (!strcmp_case(argv[i],"-S") ||  !strcmp_case(argv[i],"-SP") ){
            if(!check_item(SCALE,argv[i+1]))  pdb_cif_file(i, argc, argv);
            
        }else if(!strcmp_case(argv[i],"-P") ){
            if(!check_item(PHASE,argv[i+1]))  pdb_cif_file(i, argc, argv);

        }else if (!strcmp_case(argv[i],"-M") ){
            if(!check_item(MR,argv[i+1]))  pdb_cif_file(i, argc, argv);
            
        }else if (!strcmp_case(argv[i],"-D") ){
            if(!check_item(DM,argv[i+1]))  pdb_cif_file(i, argc, argv);
                
        }else if (!strcmp_case(argv[i],"-R") ){
            if(!check_item(REFINE,argv[i+1]))  pdb_cif_file(i, argc, argv);
        
        }
        
    }
    
         
}

int pdb_cif_file(int i, int argc, char **argv)
{
    int j=0, n=0;
    char argv_tmp[512];
    
    for(j=i+1; j<argc-1; j++){
        strcpy(argv_tmp, argv[j]);
        upperstr(argv_tmp);
        
        if(!strcmp_case(argv_tmp,"-ILOG"))
            n=1;
        if(!strcmp_case(argv_tmp,"-O") || !strcmp_case(argv_tmp,"-R")||
           !strcmp_case(argv_tmp,"-P") || !strcmp_case(argv_tmp,"-D")||
           !strcmp_case(argv_tmp,"-E") || !strcmp_case(argv_tmp,"-M")||
           !strcmp_case(argv_tmp,"-I") || !strcmp_case(argv_tmp,"-S")||
           !strcmp_case(argv_tmp,"-SP") || j>=argc-1)
            break;
    }
    if(n>0){
        printf("Warning! The program (%s) is not supported for LOG file extraction \n", argv[i+1]);
    }
    return n;
}


void cifparse(char *iFile, char  *oFile, int width)
{
  string diags;
  CifFile* fobjR = NULL;
  CifParser* cifParserR = NULL;
  
  fobjR = new CifFile(false, StringCompare::eCASE_SENSITIVE, width);

  cifParserR = new CifParser(fobjR, fobjR->GetVerbose());

  cifParserR->Parse(iFile, diags);

  delete(cifParserR);

//  if (diags) printf(" Diagnostics [ %d  %s] \n", strlen(diags), diags );
  fobjR->Write(oFile, true);
  fobjR->Close();
  if (fobjR) delete fobjR;
  
}

void unknown_prog(FILE *fout, char *inpfile, char *id, char *method)
/* at least to extract information from PDB or CIF files*/
{
    FILE *fp;
    
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (routine:unknown_prog)\n",inpfile);
        return;
    }
    
    if(!strcmp_case(id, "PDB")){
        pdb_2_cif(fout, inpfile);
    }else if (!strcmp_case(id, "CIF")){
        write_cif(fout,  inpfile, method);
    }
    
    fclose(fp);
}
    

void heavy_coord_pdb(FILE *fout, char *inpfile, char *method)
/* extract the heavy atom coordinates, occupancy, Biso */
{
    FILE *fp;
    
    int n=0,j=0, nline=0;
    char **x, **y, **z, **biso, **occ, **AtomName,str[512], meth[512];

    if(!strcmp_case(method,"MIR"))return; //since no der.id
    

    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (routine:heavy_coord_pdb)\n",inpfile);
        return;
    }

    
    n=0;
    while (fgets(str, sizeof str, fp) != NULL) {
        if ((!strncmp_case(str, "ATOM", 4)|| !strncmp_case(str, "HETA", 4)) ) {
            n++;
            break;
        }
    }
    
    if(n<=0) {
        printf("The input file (%s) is not a PDB file,\n", inpfile);
        printf("or it has no (ATOM or HETA) at beginning of each row\n\n");
        return;
    }
    
    nline=num_of_line(inpfile);
    x = set_memory_2d(nline,10);
    y = set_memory_2d(nline,10);
    z = set_memory_2d(nline,10);
    biso = set_memory_2d(nline,10);   
    occ = set_memory_2d(nline,10);
    AtomName = set_memory_2d(nline,10);
    
    rewind(fp);
    n=0;
    
    while (fgets(str, sizeof str, fp) != NULL) {
        upperstr(str);
        if (strlen(str) >= 66 &&
            ( !strncmp_case(str, "ATOM", 4) || !strncmp_case(str, "HETA", 4)) ) {
            
            strncpy(AtomName[n], str + 12, 4);
            AtomName[n][4] = '\0';

            strncpy(x[n], str + 30, 8);
            x[n][8] = '\0';
            strncpy(y[n], str + 38, 8);
            y[n][8] = '\0';
            strncpy(z[n], str + 46, 8);
            z[n][8] = '\0';
            strncpy(occ[n], str + 54, 6);
            occ[n][6] = '\0';
            strncpy(biso[n], str + 60, 6);
            biso[n][6] = '\0';
            
            rid_of_space(AtomName[n]);
            rid_of_space(x[n]);
            rid_of_space(y[n]);
            rid_of_space(z[n]);
            rid_of_space(occ[n]);
            rid_of_space(biso[n]);
            
            if(strlen(AtomName[n])<=0) strcpy(AtomName[n], ".");
            if(strlen(x[n])<=0) strcpy(x[n], ".");
            if(strlen(y[n])<=0) strcpy(y[n], ".");
            if(strlen(z[n])<=0) strcpy(z[n], ".");
            if(strlen(occ[n])<=0) strcpy(occ[n], ".");
            if(strlen(biso[n])<=0) strcpy(biso[n], ".");

            n++;
        }
    }
    fclose(fp);
    
    if(n>0){
        fprintf(fout,"\n\n#++++++  heavy atom coordinates+++++++++++\n" );
        if(!strcmp_case(method, "MAD")){
            strcpy(meth,"MAD_set");
            fprintf(fout,"loop_\n");
            fprintf(fout,"_pdbx_phasing_%s_site.id\n",meth);
            fprintf(fout,"_pdbx_phasing_%s_site.atom_type_symbol\n",meth);
            fprintf(fout,"_pdbx_phasing_%s_site.Cartn_x\n",meth);
            fprintf(fout,"_pdbx_phasing_%s_site.Cartn_y\n",meth);
            fprintf(fout,"_pdbx_phasing_%s_site.Cartn_z\n",meth);
            fprintf(fout,"_pdbx_phasing_%s_site.occupancy\n",meth);
            fprintf(fout,"_pdbx_phasing_%s_site.B_iso\n",meth);
             
        }else{
            strcpy(meth,"MIR_der");
            fprintf(fout,"loop_\n");
            fprintf(fout,"_phasing_%s_site.id\n",meth);
            fprintf(fout,"_phasing_%s_site.atom_type_symbol\n",meth);
            fprintf(fout,"_phasing_%s_site.Cartn_x\n",meth);
            fprintf(fout,"_phasing_%s_site.Cartn_y\n",meth);
            fprintf(fout,"_phasing_%s_site.Cartn_z\n",meth);
            fprintf(fout,"_phasing_%s_site.occupancy\n",meth);
            fprintf(fout,"_phasing_%s_site.B_iso\n",meth);             
        }
        
        for(j=0; j<n; j++){
            fprintf(fout, "%d '%s' %s  %s  %s  %s  %s\n", j+1, AtomName[j],
                    x[j], y[j], z[j], occ[j], biso[j]);
        }
        
    }
    free_memory_2d(x,nline);
    free_memory_2d(y,nline);
    free_memory_2d(z,nline);
    free_memory_2d(biso,nline);
    free_memory_2d(occ,nline);
    free_memory_2d(AtomName,nline);
    
}

int check_block(char *str)
 // delete the [, {, or (
{
    int m=0, len=0, i=0;
    char str1[512], tmp1[512];
    
    
    m=sscanf(str, "%s %s", str1, tmp1);
    len = strlen(str1);
            
    if((m==1 || (m==2 && tmp1[0]=='#')) &&
       !strncmp_case(str1, "data_", 5) && len>5 ){
        for(i=0; i<len; i++){
            if(i< len-2 && (str[i]=='[' || str[i]=='(' || str[i]=='{' 
                            ||str[i]=='}' ||str[i]==')' ||str[i]==']'))
                str[i]='_';
            if(i>= len-2 && (str[i]=='}' ||str[i]==')' ||str[i]==']')) str[i]=' ';
        }
        
        return 1;
    }else return 0;
}

void write_cif_or_pdb(FILE *fout,  char *inpfile, char *format, char *method)
/* Note: if CIF, write everythings; if PDB, write heavy atom cood.*/
{
    FILE *fp;
    
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s(routine:write_cif_or_pdb)\n",
               inpfile);
        return;
    }
    
    if(!strcmp_case(format, "CIF")) { /* take everthing */
        write_cif(fout, inpfile, method);
    }
    if(!strcmp_case(format, "PDB")) { /*take as heavy atom XYZ */
        heavy_coord_pdb(fout, inpfile, method);
    }
    
    fclose(fp);
}



char ** get_cif_category(char *inpfile, int *nitem)
{
    char  str[512],  category[512], item[512];
    char **items=NULL, **cate=NULL, **cate_tmp=NULL;
    int n=0, i,  m=0, yes=0;
    FILE *fp;

    
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (routine:get_cif_category)\n",inpfile);
        return (NULL);
    }
    
    while(fgets(str, sizeof str, fp) != NULL){
        check_category(str, category, item);
        if(strlen(category)>0 && strlen(item)>0)
            n++;
    }
    items = new char *[n];
    cate_tmp = new char *[n];

    n=0;
    rewind(fp);    
    while(fgets(str, sizeof str, fp) != NULL){
        check_category(str, category, item);
        if(strlen(category)>0 && strlen(item)>0){
            
            cate_tmp[n] = new char[strlen(category)+1];
            strcpy(cate_tmp[n],category);

            items[n] = new char[strlen(str)+1];
            sprintf(items[n], "%s.%s",  category, item);
            
            n++;
        }
    }
    cif.items = items;
    cif.nitem = n;
    
/*select the unique category */
    
    cate = new char *[n];
    cate[0] = new char [strlen(cate_tmp[0])+1];
    strcpy(cate[0], cate_tmp[0]);
    
    m=1;
    for(i=1; i<n; i++){ 
        yes=item_compare(cate, m, cate_tmp[i]);
        if(yes>0){
            cate[m] = new char [strlen(cate_tmp[i])+1];
            strcpy(cate[m], cate_tmp[i]);
//            printf("what is cate %d %s\n", m, cate[m]);
            m++;
        }else
            continue;
    }
    *nitem=m;

    cif.category = cate;
    cif.ncat = m;

    delete [] cate_tmp;
    delete [] items;
    
    return (cate);
    
}

int item_compare(char **cate, int m, char *items)
{
    int i, n=1;
    
    for(i=m-1; i>=0; i--){
        if(!strcmp_case(cate[i], items)){
            n=0;
            break;
        }
    }
    return n;
}


void extract_seq (int argc, char **argv)
// This is only for the CCP4i interface    
{
    int i, n=0;
    char outfile[512],command[512];

    strcpy(outfile, "extract_tmp");
    
    
    for(i=0; i<argc-1; i++){
        if( (!strcmp_case(argv[i],"-PDB") || !strcmp_case(argv[i],"-CIF") ||
             !strcmp_case(argv[i],"-EXT")) && argc<6 ){
            n=1;
           
        }else if(!strcmp_case(argv[i],"-O")&& argc<6){
            strcpy(outfile,argv[i+1]);
        }
    }
    if(n==0) return;

    for(i=0; i<argc-1; i++){
        if( !strcmp_case(argv[i],"-PDB")){
            strcpy(command,"");
            strcat(command, "extract -pdb ");
            strcat(command, argv[i+1]);
            system(command);

            change_file_name("data_template.text", outfile);            
            delete_file("cgi_value");
            delete_file("entity-poly.mmcif");             
            exit (0);
            
        }else if(!strcmp_case(argv[i],"-CIF")){
            strcpy(command,"");
            strcat(command, "extract -cif ");
            strcat(command, argv[i+1]);
            system(command);

            change_file_name("data_template.text", outfile);            
            
            delete_file("cgi_value");
            delete_file("entity-poly.mmcif");
            exit (0);
        }else if (!strcmp_case(argv[i],"-EXT")){
            strcpy(command,"");
            strcat(command, "extract -cif ");
            strcat(command, argv[i+1]);
            system(command);
            exit (0);
        }
      
     }
}

void reorder_shell(int argc, char **argv, char *inpfile)
{
    string blockId;
    char  **line=NULL, str[512], *shell[NBIN], **id1=NULL,**id2=NULL, **pdb=NULL;
    string diags; 
    long nn=0,nid1=0,nid2=0, i, j,k,m ,npdb=0 ;
    int nline;
    
    
    FILE  *fout;

     
    line = get_lines_from_file(inpfile, &nline);
    
    CifParser* cifParserR = NULL;

    CifFile * fobjR = NULL;
    fobjR = new CifFile(true);

    cifParserR = new CifParser(fobjR, fobjR->GetVerbose());

    cifParserR->Parse(inpfile, diags);

    delete(cifParserR);


    if (!diags.empty()) fprintf(stderr, "Diags for file %s: %s\n",inpfile,diags.c_str());

    blockId = fobjR->GetFirstBlockName();
    id1 = get_attribute_values(fobjR, blockId.c_str(), "refine_ls_shell","d_res_high", &nid1);
    id2 = get_attribute_values(fobjR, blockId.c_str(), "reflns_shell","d_res_high", &nid2);
    pdb =get_attribute_values(fobjR, blockId.c_str(), "atom_site", "Cartn_x", &npdb);
    
    nn=nline;
    fout=fopen(inpfile, "w");
    
    fprintf(fout,"%s", line[0]);
    fprintf(fout,"%s", line[1]);
    fprintf(fout,"%s", line[2]);
    
    for(i=4; i<nn; i++){
        fprintf(fout,"%s", line[i-1]);
        
        if((!strncmp(line[i-4],"_refine_ls_shell.", 17) &&
            !strncmp(line[i-3],"_refine_ls_shell.", 17) &&
            !strncmp(line[i-2],"_refine_ls_shell.", 17) &&
            !strncmp(line[i-1],"_refine_ls_shell.", 17) &&
            
            sscanf(line[i], "%s%s%s%s", str, str, str, str)==4)) {
                
            if(nid1>0 && atof(id1[0]) < atof(id1[nid1-1])) continue;
            
            k=0;
            for(j=i; j<nn-1; j++){
                
                shell[k]=new char[strlen(line[j])+1];
                strcpy(shell[k], line[j]);
                k++;
                 
                if((sscanf(line[j+1], "%s%s%s%s", str, str, str, str )!=4 && k>0)||
                   (j+1==nn-1 && k>0) ){
                    i=j+1;
                    for(m=k-1; m>=0; m--){
                        fprintf(fout,"%s", shell[m]);
                    }
                    
                    break;
                }
            }
            
        }else if((!strncmp(line[i-4],"_reflns_shell.", 14) &&
                  !strncmp(line[i-3],"_reflns_shell.", 14) &&
                  !strncmp(line[i-2],"_reflns_shell.", 14) &&
                  !strncmp(line[i-1],"_reflns_shell.", 14) &&
            sscanf(line[i], "%s%s%s%s", str, str, str, str)==4)) {
            if(nid2>0 && atof(id2[0]) < atof(id2[nid2-1])) continue;
            k=0;
            for(j=i; j<nn-1; j++){
                
                shell[k]=new char[strlen(line[j])+1];
                strcpy(shell[k], line[j]);
                k++;
                 
                if((sscanf(line[j+1], "%s%s%s%s", str, str, str, str )!=4 && k>0)||
                   (j+1==nn-1 && k>0) ){
                    i=j+1;
                    for(m=k-1; m>=0; m--){
                        fprintf(fout,"%s", shell[m]);
                    }
                    
                    break;
                }
            }
        }
        
            
    }
    if(nline)free_memory_2d(line, nline);
    fclose(fout);

    if(id1) free_memory_2d(id1, nid1);
    if(id2) free_memory_2d(id2, nid2);
    if(pdb) free_memory_2d(pdb, npdb);
    
    for(i=0; i<argc; i++){
        if(!strcmp_case(argv[i], "-r")){
            if(npdb<10){
                printf("\nWarning! There is no atom coordinates in your file!\n");
            }
        }
    }
}
    
void  test_cif(char *inpfile)
// this file is only for testing mmCIF
{
    string blockId;
    string diags;
    int i, colNo, rowNo, irow;

    CifFile * fobjR = NULL;

    CifParser* cifParserR = NULL;
     
    fobjR = new CifFile(true);

    cifParserR = new CifParser(fobjR, fobjR->GetVerbose());

    cifParserR->Parse(inpfile, diags);

    delete(cifParserR);

    if (!diags.empty()) fprintf(stderr, "Diags for file %s: %s\n",inpfile,diags.c_str());
    
    blockId = fobjR->GetFirstBlockName();
    
    Block& block = fobjR->GetBlock(blockId);
    vector<string> tableNames;
    block.GetTableNames(tableNames);

    for (unsigned int ii=0; ii<tableNames.size(); ii++)
        cout<<tableNames[ii]<<endl;


///////////////////////
    ISTable *Table = block.GetTablePtr("reflns");
    

//    if (is_empty_table(Table)) return;

    colNo = Table->GetNumColumns();
    rowNo = Table->GetNumRows();

    const vector<string>& ColumnNames = Table->GetColumnNames();

    for (irow = 0; irow < rowNo; irow++) {
        for (i = 0; i < colNo; i++) {
            const string& aString = (*Table)(irow, ColumnNames[i]);
            if (aString == "" || aString == "?" || aString == ".") continue;
            printf("items=%s\n", ColumnNames[i].c_str());
        }
    }
/*    
TblFileObj * fob= new TblFileObj("./TESTFILE1", WRITE_MODE);   
    s = new SSTable(cat_name[0]);
FillTestTable(s, 1, 1, "ABCDEFGHIJKLMNOPQRSTUVWXYZ012345689");
fob->WriteTable(s,blockId,cat_name[0]);

    cat_name = fobjR->GetTableNames(blockId, num);
    for (int ii=0; ii<num; ii++)
        cout<<cat_name[ii]<<endl;
*/    
}

void check_version()
{
    const char *URL="http://sw-tools.rcsb.org/apps/PDB_EXTRACT/source.html";
    char command[256] , ofile[256], **line;
    int nline, i;
    float version, max=0,local_version;
    
    
    
    strcpy(ofile, "extract_version.html");
    sprintf(command ,"/bin/csh -c \"wget  -o wget_TMP.log -O  %s  %s\" ", ofile, URL);
    system(command);

    line=get_lines_from_file(ofile, &nline);
    for(i=0; i<nline; i++){
        if(pattern5(line[i],"href", "pdb-extract-v", "-prod-src.tar.gz", "", "")){
            version=get_float(line[i], "extract-v", "-prod-src");
            if(version>max) max=version;
        }
    }
    
    local_version=atof( PDB_EXTRACT_VERSION);
    printf("The latest version on our WEB 'http://sw-tools.rcsb.org/apps/PDB_EXTRACT/' is  %.3f\n",max);
    if(max>local_version){
        printf("Note: your version (v%.3f) is lower than the latest version (v%.3f).\n",
               local_version,max);
        printf("      Please check http://sw-tools.rcsb.org/apps/PDB_EXTRACT/\n");
    }
    if(nline>0) free_memory_2d(line, nline);
    delete_file(ofile);
    delete_file("wget_TMP.log");
    
}
