/*
FILE:     scale.C
*/
/*
VERSION:  3.004
*/
/*
DATE:     9/11/2007
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2007 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/* a program to gather all the reflection data and convert it to
   cif format.   March, 2002
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "rcsb_math.h"
#include "structure.h"
#include "util.h"
#include "harv.h"

const float DEG2RAD= 0.017453292;
#define NSET 20   // number of data set for phasing


extern REFLNS reflns;
extern REFLNS_SHELL reflns_shell;
extern EXPTL_CRYSTAL exptl_crystal;
extern CELL cell ;
extern SYMMETRY symmetry;
REFLNS reflns_phs[NSET];
REFLNS_SHELL reflns_shell_phs[NSET];

char DATACUT[20];


float get_resolution(float h,float k, float l, float *rcell);
void calc_recip_cell(float *cell, float *rcell);
void I_over_sigmaI(char *inpfile);
void extract_XSCALE_log(char *inpfile);
void extract_XGEN_log(char *inpfile);
void extract_PROSCALE_log(char *inpfile);
void write_diffrn_shell(FILE *fout, REFLNS_SHELL *log,  int i);
void write_diffrn(FILE *fout, REFLNS *log,  int i);


void extract_scale(FILE *fout, int argc, char **argv, int start, char *prog)
{
    int i=0, key=0;
    char infile[512];
    const char *id = "-i -p -e -d -m -r -s -sp";

    for(i=0; i<argc-1; i++){
        if(!strcmp_case(argv[i],"-DATACUT") ){
            strcpy(DATACUT,  argv[i+1]);
        }
    }
    
    for(i=start; i<argc-1; i++){
        if(strstr_case(id, argv[i])) break;
        if(!strcmp_case(argv[i],"-ILOG") ){
            strcpy(infile, argv[i+1]);
            
            if(!strcmp_case(prog, "HKL")|| !strcmp_case(prog,"SCALEPACK")||
               !strcmp_case(prog, "HKL2000")){
                
                printf("HKL/Scalepack output Log file: (%s)\n",infile);
                
                extract_HKL_log(infile);
                key=1;
                
                
            }else if (!strcmp_case(prog,"DTREK")){

                printf("D*TREK output Log file (%s)\n",infile);
                extract_DTREK_log(infile); 
                        
            }else if(!strcmp_case(prog,"SAINT")){

                printf("SAINT output Log file (%s)\n",infile);
                extract_SAINT_log(infile);
                        
            }else if(!strcmp_case(prog,"X-GEN")){

                printf("X-GEN output Log file (%s)\n",infile);
                extract_XGEN_log(infile);
                        
            }else if(!strcmp_case(prog,"SCALA")){

                printf("SCALA output Log file (%s)\n",infile);
                extract_SCALA_log(infile);
                        
            }else if(!strcmp_case(prog,"3DSCALE")){

                printf("3DSCALE output Log file (%s)\n",infile);
                
                extract_3DSCALE_log(infile);

            }else if(!strcmp_case(prog,"XSCALE")){

                printf("XSCALE output Log file (%s)\n",infile);
                extract_XSCALE_log(infile); //one data set for refinement
                printf("\nNote:The default data cut for Xscale is -3.0.\n");
                printf("     If you used other data cut, please add one more option (e.g. -datacut 0.0)\n\n");
                
            }else if(!strcmp_case(prog,"PROSCALE")){

                printf("PROSCALE output Log file (%s)\n",infile);
                extract_PROSCALE_log(infile); 

            }else{
                write_data_message(prog, infile);
            }
            
        }else if(!strcmp_case(argv[i],"-IDAT") ){
            
            strcpy(infile, argv[i+1]);
            if(!strcmp_case(prog, "HKL")|| !strcmp_case(prog,"SCALEPACK")||
               !strcmp_case(prog, "HKL2000")){
                
                printf("HKL/Scalepack output data file: (%s)\n",infile);
                if(key==0){
                    printf("Input was wrong! You should give the right order\n");
                    printf("pdb_extract -s HKL -ilog  log_file -idat data_file\n");
                    exit(0);
                }
                I_over_sigmaI(infile); //add I/SigmaI and with shell.
            } 
            
        }else if (!strcmp_case(argv[i],"-ICIF") ){
            strcpy(infile, argv[i+1]);
            write_cif(fout, infile, "");
        }
        
    }
    write_reflns_shell(fout);
    write_reflns(fout);
}


void extract_scale_phase(FILE *fout, int argc, char **argv, int start, char *prog)
// extract LOG files from many diffraction data set. (option -sp)
{
    char infile[512];
    int i=0, ns=0;
    

    ns=0;
    if(!strcmp_case(argv[start],"-ILOG") ){
        
        for(i=start+1; i<argc; i++){
            strcpy(infile, argv[i]);
            
            if(argv[i][0] =='-') break;
            
            if(!strcmp_case(prog, "HKL")|| !strcmp_case(prog,"SCALEPACK")||
               !strcmp_case(prog, "HKL2000")){
/*                        
                if(!strcmp_case(argv[i], "-idat")){
                    I_over_sigmaI(argv[i+1]); 
                    i = i+1;
                    continue;
                }
*/                
                printf("HKL/Scalepack output Log file: (%s)\n",infile);
                extract_HKL_log(infile);
                
            }else if(!strcmp_case(prog,"DTREK")){
                printf("D*TREK output Log file (%s)\n",infile);
                extract_DTREK_log(infile);
                
                
            }else if(!strcmp_case(prog,"SCALA")){
                printf("SCALA output Log file (%s)\n",infile);
                extract_SCALA_log(infile);
                
            }else if(!strcmp_case(prog,"3DSCALE")){
                printf("3DSCALE output Log file (%s)\n",infile);
                extract_3DSCALE_log(infile);

                
            }else if(!strcmp_case(prog,"XSCALE")){
                printf("XSCALE output Log file (%s)\n",infile);
                extract_XSCALE_log(infile);
                
            }else if(!strcmp_case(prog,"PROSCALE")){
                printf("PROSCALE output Log file (%s)\n",infile);
                extract_PROSCALE_log(infile);
                
            }
            if(reflns_shell.nbin>0){
                reflns_phs[ns]=reflns;
                reflns_shell_phs[ns]=reflns_shell;
                if(ns++>20) return;
            }
            
        }
    }

    if(ns==0){
        printf("Warning! no information has been extracted from phasing sets!\n");
        return;
    }
    
    for(i=0; i<ns; i++){
        write_diffrn_shell(fout,reflns_shell_phs,i);
    }
    for(i=0; i<ns; i++){
        write_diffrn(fout, reflns_phs, i);
    }

}

void write_diffrn(FILE *fout, REFLNS *log,  int i )
{
    if(i==0 ){
        fprintf(fout, "\nloop_\n");
        fprintf(fout, "_diffrn_reflns.diffrn_id\n");
        fprintf(fout, "_diffrn_reflns.d_resolution_high  \n");
        fprintf(fout, "_diffrn_reflns.d_resolution_low  \n");
        fprintf(fout, "_diffrn_reflns.Rmerge_F_obs  \n");
        fprintf(fout, "_diffrn_reflns.number_obs  \n");
        fprintf(fout, "_diffrn_reflns.pdbx_Rmerge_I_obs  \n");
        fprintf(fout, "_diffrn_reflns.pdbx_Rsym_value  \n");
        fprintf(fout, "_diffrn_reflns.pdbx_chi_squared  \n");
        fprintf(fout, "_diffrn_reflns.pdbx_netI_over_av_sigmaI  \n");
        fprintf(fout, "_diffrn_reflns.pdbx_redundancy  \n");
        fprintf(fout, "_diffrn_reflns.pdbx_scaling_rejects  \n");
        fprintf(fout, "_diffrn_reflns.percent_possible_obs  \n");
        fprintf(fout, "_diffrn_reflns.pdbx_Rmeas_mean \n");
        fprintf(fout, "_diffrn_reflns.pdbx_Rmerge_F_obs \n");
        fprintf(fout, "_diffrn_reflns.pdbx_number_measured_all \n");
        fprintf(fout, "_diffrn_reflns.pdbx_resolution_low_scale \n");
        fprintf(fout, "_diffrn_reflns.pdbx_resolution_high_scale \n");
        fprintf(fout, "_diffrn_reflns.pdbx_number_centric \n");
        fprintf(fout, "_diffrn_reflns.pdbx_number_anomalous \n");
        fprintf(fout, "_diffrn_reflns.pdbx_Rmerge_I_anomalous \n");
        fprintf(fout, "_diffrn_reflns.pdbx_netI_over_av_sigmaI_anomalous \n");
        fprintf(fout, "_diffrn_reflns.pdbx_PCV_mean \n");
        fprintf(fout, "_diffrn_reflns.pdbx_meanI_over_sd \n");
        fprintf(fout, "_diffrn_reflns.pdbx_average_I_obs \n");
        fprintf(fout, "_diffrn_reflns.pdbx_average_sigmaI_obs \n");

        fprintf(fout, "_diffrn_reflns.R_free_details   \n");
        fprintf(fout, "_diffrn_reflns.details   \n");
        fprintf(fout, "_diffrn_reflns.observed_criterion   \n");
        fprintf(fout, "_diffrn_reflns.B_iso_Wilson_estimate \n");
        fprintf(fout, "_diffrn_reflns.Rmerge_F_all  \n");

        fprintf(fout, "_diffrn_reflns.limit_h_max  \n");
        fprintf(fout, "_diffrn_reflns.limit_h_min  \n");
        fprintf(fout, "_diffrn_reflns.limit_k_max  \n");
        fprintf(fout, "_diffrn_reflns.limit_k_min  \n");
        fprintf(fout, "_diffrn_reflns.limit_l_max  \n");
        fprintf(fout, "_diffrn_reflns.limit_l_min  \n");
        fprintf(fout, "_diffrn_reflns.number_all   \n");
        fprintf(fout, "_diffrn_reflns.observed_criterion_F_max  \n");
        fprintf(fout, "_diffrn_reflns.observed_criterion_F_min  \n");
        fprintf(fout, "_diffrn_reflns.observed_criterion_I_max  \n");
        fprintf(fout, "_diffrn_reflns.observed_criterion_I_min  \n");
        fprintf(fout, "_diffrn_reflns.observed_criterion_sigma_F  \n");
        fprintf(fout, "_diffrn_reflns.observed_criterion_sigma_I  \n");
        fprintf(fout, "_diffrn_reflns.pdbx_d_res_high_opt  \n");
        fprintf(fout, "_diffrn_reflns.pdbx_d_res_low_opt \n");
        
    }
    fprintf(fout, " %d ",i+1);
    
    (log[i].d_resolution_high>0)?
        fprintf(fout, " %.3f ", log[i].d_resolution_high) : fprintf(fout," ? ");
    
    (log[i].d_resolution_low>0) ? 
        fprintf(fout, " %.3f ", log[i].d_resolution_low) : fprintf(fout," ? ");
    
    (log[i].Rmerge_F_obs>0) ? 
        fprintf(fout, " %.3f ", log[i].Rmerge_F_obs) : fprintf(fout," ? ");
    
    (log[i].number_obs>0) ? 
        fprintf(fout, "  %d ", log[i].number_obs) : fprintf(fout," ? ");
    
    (log[i].pdbx_Rmerge_I_obs>0) ? 
        fprintf(fout, " %.3f ", log[i].pdbx_Rmerge_I_obs) : fprintf(fout," ? ");
    
    (log[i].pdbx_Rsym_value>0) ? 
        fprintf(fout, " %.3f ", log[i].pdbx_Rsym_value) : fprintf(fout," ? ");
    
    (log[i].pdbx_chi_squared>0) ? 
        fprintf(fout, " %.2f ", log[i].pdbx_chi_squared) : fprintf(fout," ? ");
    
    
    (log[i].pdbx_netI_over_av_sigmaI>0) ? 
        fprintf(fout, "  %.2f ", log[i].pdbx_netI_over_av_sigmaI) : fprintf(fout," ? ");
    
    (log[i].pdbx_redundancy>0) ? 
        fprintf(fout, " %.2f ", log[i].pdbx_redundancy) : fprintf(fout," ? ");
    
    (log[i].pdbx_scaling_rejects>0) ? 
        fprintf(fout, "  %d ", log[i].pdbx_scaling_rejects) : fprintf(fout," ? ");
    
    (log[i].percent_possible_obs>0) ? 
        fprintf(fout, " %.2f ", log[i].percent_possible_obs) : fprintf(fout," ? ");

    (log[i].pdbx_Rmeas_mean>0) ? 
        fprintf(fout, " %.3f ", log[i].pdbx_Rmeas_mean) : fprintf(fout," ? ");

    (log[i].pdbx_Rmerge_F_obs>0) ? 
        fprintf(fout, " %.3f ", log[i].pdbx_Rmerge_F_obs) : fprintf(fout," ? ");

    (log[i].pdbx_number_measured_all>0) ? 
        fprintf(fout, " %d ", log[i].pdbx_number_measured_all) : fprintf(fout," ? ");
    

    (log[i].pdbx_resolution_low_scale>0) ? 
        fprintf(fout, " %.3f ", log[i].pdbx_resolution_low_scale) : fprintf(fout," ? ");
    
    (log[i].pdbx_resolution_high_scale>0) ? 
        fprintf(fout, " %.3f ", log[i].pdbx_resolution_high_scale) : fprintf(fout," ? ");

    (log[i].pdbx_number_centric>0) ? 
        fprintf(fout, " %d ", log[i].pdbx_number_centric) : fprintf(fout," ? ");
    
    (log[i].pdbx_number_anomalous>0) ? 
        fprintf(fout, " %d ", log[i].pdbx_number_anomalous) : fprintf(fout," ? ");

    (log[i].pdbx_Rmerge_I_anomalous>0) ? 
        fprintf(fout, " %.3f ", log[i].pdbx_Rmerge_I_anomalous) : fprintf(fout," ? ");
    
    (log[i].pdbx_netI_over_av_sigmaI_anomalous>0) ? 
        fprintf(fout, " %.3f ", log[i].pdbx_netI_over_av_sigmaI_anomalous) : fprintf(fout," ? ");

    (log[i].pdbx_PCV_mean>0) ? 
        fprintf(fout, " %.3f ", log[i].pdbx_PCV_mean) : fprintf(fout," ? ");
    
    (log[i].pdbx_meanI_over_sd>0) ? 
        fprintf(fout, " %.3f ", log[i].pdbx_meanI_over_sd) : fprintf(fout," ? ");
    
    (log[i].pdbx_average_I_obs>0) ? 
        fprintf(fout, " %.3f ", log[i].pdbx_average_I_obs) : fprintf(fout," ? ");

    (log[i].pdbx_average_sigmaI_obs>0)? 
        fprintf(fout, " %.3f ", log[i].pdbx_average_sigmaI_obs) : fprintf(fout," ? ");
    
    (log[i].R_free_details[0]!='?')? 
        fprintf(fout, " '%s'  ", log[i].R_free_details) : fprintf(fout," ? ");
    (log[i].details[0]!='?')? 
        fprintf(fout, " '%s'  ", log[i].details) : fprintf(fout," ? ");
    (log[i].observed_criterion[0]!='?')? 
        fprintf(fout, " '%s'  ", log[i].observed_criterion) : fprintf(fout," ? ");
    
    (log[i].B_iso_Wilson_estimate>0) ? 
        fprintf(fout, " %.2f ", log[i].B_iso_Wilson_estimate) : fprintf(fout," ? ");
    
    (log[i].Rmerge_F_all>0) ? 
        fprintf(fout, " %.3f ", log[i].Rmerge_F_all) : fprintf(fout," ? ");
    (log[i].limit_h_max>INI) ?
        fprintf(fout, " %d ",log[i].limit_h_max) : fprintf(fout," ? ");
    
    (log[i].limit_h_min>INI) ?
        fprintf(fout, " %d ",log[i].limit_h_min) : fprintf(fout," ? ");

    (log[i].limit_k_max>INI) ?
        fprintf(fout, " %d ",log[i].limit_k_max) : fprintf(fout," ? ");
    
    (log[i].limit_k_min>INI) ?
        fprintf(fout, " %d ",log[i].limit_k_min) : fprintf(fout," ? ");

    (log[i].limit_l_max>INI) ?
        fprintf(fout, " %d ",log[i].limit_l_max) : fprintf(fout," ? ");
    
    (log[i].limit_l_min>INI) ?
        fprintf(fout, " %d ",log[i].limit_l_min) : fprintf(fout," ? ");

    (log[i].number_all>0) ? 
        fprintf(fout, " %d  ", log[i].number_all) : fprintf(fout," ? ");
    
    (log[i].observed_criterion_F_max>INI) ?
        fprintf(fout, " %.2f ",log[i].observed_criterion_F_max ) : fprintf(fout," ? ");

    (log[i].observed_criterion_F_min>INI) ?
        fprintf(fout, " %.2f ",log[i].observed_criterion_F_min ) : fprintf(fout," ? ");

    (log[i].observed_criterion_I_max>INI) ?
        fprintf(fout, " %.2f ",log[i].observed_criterion_I_max ) : fprintf(fout," ? ");

    (log[i].observed_criterion_I_min>INI) ?
        fprintf(fout, " %.2f ",log[i].observed_criterion_I_min ) : fprintf(fout," ? ");

    (log[i].observed_criterion_sigma_F>INI) ?
        fprintf(fout, " %.2f ",log[i].observed_criterion_sigma_F) : fprintf(fout," ? ");

    (log[i].observed_criterion_sigma_I>INI) ?
        fprintf(fout, " %.2f ",log[i].observed_criterion_sigma_I) : fprintf(fout," ? ");

    (log[i].pdbx_d_res_high_opt>0) ? 
        fprintf(fout, " %.2f ", log[i].pdbx_d_res_high_opt) : fprintf(fout," ? ");
    
    (log[i].pdbx_d_res_low_opt>0) ? 
        fprintf(fout, " %.2f ", log[i].pdbx_d_res_low_opt) : fprintf(fout," ? ");

    fprintf(fout, " \n");
    
}


void write_diffrn_shell(FILE *fout, REFLNS_SHELL *log,  int i)
//Note: value reflns_shell.number_unique_all will be extracted (complimise ADIT)
{
    int m;
    
    if(i==0 && log[i].nbin>0){
        
    fprintf(fout, "\n# statistics from LOG files foir phasig\n");
    fprintf(fout, "\nloop_\n");
    
    fprintf(fout, "_pdbx_diffrn_reflns_shell.diffrn_id \n");

    fprintf(fout, "_pdbx_diffrn_reflns_shell.d_res_high\n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.d_res_low\n");

    fprintf(fout, "_pdbx_diffrn_reflns_shell.number_measured_obs\n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.number_measured_all\n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.number_unique_obs \n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.rejects\n");

    fprintf(fout, "_pdbx_diffrn_reflns_shell.Rmerge_I_obs\n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.meanI_over_sigI_obs \n");
    
    fprintf(fout, "_pdbx_diffrn_reflns_shell.Rsym_value \n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.chi_squared\n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.redundancy\n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.percent_possible_obs\n");

    fprintf(fout, "_pdbx_diffrn_reflns_shell.Rmeas_mean \n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.meanI_over_sd \n");
    
    fprintf(fout, "_pdbx_diffrn_reflns_shell.number_centric \n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.number_anomalous \n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.Rmerge_I_anomalous \n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.meanI_over_sigI_anomalous \n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.PCV_mean \n");
    
        
    fprintf(fout, "_pdbx_diffrn_reflns_shell.number_possible\n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.number_unique_all\n");
   
    fprintf(fout, "_pdbx_diffrn_reflns_shell.Rmerge_F_all\n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.Rmerge_F_obs\n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.Rmerge_I_all\n");
    
    fprintf(fout, "_pdbx_diffrn_reflns_shell.meanI_over_sigI_all\n");
    fprintf(fout, "_pdbx_diffrn_reflns_shell.percent_possible_all\n");
    
    }
    
        
    for(m=0; m<log[i].nbin; m++){
        fprintf(fout," %d ", i+1);
        
        (log[i].d_res_high[m]>0) ?
            fprintf(fout," %.2f ", log[i].d_res_high[m]) : fprintf(fout," ? ");
        
        (log[i].d_res_low[m]>0) ?
            fprintf(fout," %.2f ", log[i].d_res_low[m]) : fprintf(fout," ? ");


        (log[i].number_measured_obs[m]>0) ?
            fprintf(fout," %d ", log[i].number_measured_obs[m]): fprintf(fout," ? ");

        (log[i].number_measured_all[m]>0) ?
            fprintf(fout," %d ", log[i].number_measured_all[m]): fprintf(fout," ? ");
        
        (log[i].number_unique_obs[m]>0) ?
            fprintf(fout," %d ",log[i].number_unique_obs[m]): fprintf(fout," ? ");

        (log[i].pdbx_rejects[m]>0) ?
            fprintf(fout," %d ", log[i].pdbx_rejects[m]): fprintf(fout," ? ");


        (log[i].Rmerge_I_obs[m]>0) ?
            fprintf(fout," %.3f ",log[i].Rmerge_I_obs[m]): fprintf(fout," ? ");



        (log[i].meanI_over_sigI_obs[m]>0) ?
            fprintf(fout," %.1f ", log[i].meanI_over_sigI_obs[m]): fprintf(fout," ? ");
        
        (log[i].pdbx_Rsym_value[m]>0) ?
            fprintf(fout," %.3f \n",log[i].pdbx_Rsym_value[m]):fprintf(fout," ? ");
        (log[i].pdbx_chi_squared[m]>0) ?
            fprintf(fout," %.3f ", log[i].pdbx_chi_squared[m]): fprintf(fout," ? ");
        (log[i].pdbx_redundancy[m]>0) ?
            fprintf(fout," %.2f ", log[i].pdbx_redundancy[m]): fprintf(fout," ? ");
        
        (log[i].percent_possible_obs[m]>0) ?
            fprintf(fout," %.2f ", log[i].percent_possible_obs[m]): fprintf(fout," ? ");


        (log[i].pdbx_Rmeas_mean[m]>0) ?
            fprintf(fout," %.3f ", log[i].pdbx_Rmeas_mean[m]): fprintf(fout," ? ");

        (log[i].pdbx_meanI_over_sd[m]>0) ?
            fprintf(fout," %.1f ", log[i].pdbx_meanI_over_sd[m]): fprintf(fout," ? ");


        
        (log[i].pdbx_number_centric[m]>0) ?
            fprintf(fout," %d ", log[i].pdbx_number_centric[m]): fprintf(fout," ? ");

        (log[i].pdbx_number_anomalous[m]>0) ?
            fprintf(fout," %d ",log[i].pdbx_number_anomalous[m] ): fprintf(fout," ? ");

        (log[i].pdbx_Rmerge_I_anomalous[m]>0) ?
            fprintf(fout," %.2f ",log[i].pdbx_Rmerge_I_anomalous[m] ): fprintf(fout," ? ");

        (log[i].pdbx_meanI_over_sigI_anomalous[m]>0) ?
            fprintf(fout," %.1f ",log[i].pdbx_meanI_over_sigI_anomalous[m] ): fprintf(fout," ? ");

        (log[i].pdbx_PCV_mean[m]>0) ?
            fprintf(fout," %.3f ",log[i].pdbx_PCV_mean[m] ): fprintf(fout," ? ");

        

        
        (log[i].number_possible[m]>0) ?
            fprintf(fout," %d ",log[i].number_possible[m]): fprintf(fout," ? ");
        
        (log[i].number_unique_all[m]>0) ?
            fprintf(fout," %d ", log[i].number_unique_all[m]): fprintf(fout," ? ");


        
        (log[i].Rmerge_F_all[m]>0) ?
            fprintf(fout," %.3f ",log[i].Rmerge_F_all[m]): fprintf(fout," ? ");
        
        (log[i].Rmerge_F_obs[m]>0) ?
            fprintf(fout," %.3f ",log[i].Rmerge_F_obs[m]): fprintf(fout," ? ");
        
        (log[i].Rmerge_I_all[m]>0) ?
            fprintf(fout," %.3f ",log[i].Rmerge_I_all[m]): fprintf(fout," ? ");

        (log[i].meanI_over_sigI_all[m]>0) ?
            fprintf(fout," %.1f ", log[i].meanI_over_sigI_all[m]): fprintf(fout," ? ");
        

        (log[i].percent_possible_all[m]>0) ?
            fprintf(fout," %.2f ", log[i].percent_possible_all[m]): fprintf(fout," ? ");


        fprintf(fout," \n");
        
    }
}


void extract_HKL_log( char *inpfile )
// Extracting statistics from LOG files of HKL or SCALEPACK 
{
    char  tmp[512], **line;
    int i, j,  k=0, n=0,n1, nline, nbin=0;
    float a1, a2, a3, a4, a5,a6,a7;

    reflns_shell.nbin=0;
    line=get_lines_from_file(inpfile, &nline);
    
    for(i=0; i<nline-1; i++){
        if(strstr_space(line[i], "Space group")){
            if(pattern5(line[i],"Space group", "number", "number", "","")){
                strcpy(tmp, get_substr(line[i],"group", "number"));
                if(strlen(tmp)>0) strcpy(symmetry.space_group_name_H_M, tmp);
                strcpy(tmp, "");
                strcpy(tmp, get_substr(line[i],"number", "number"));
                if(strlen(tmp)>0)symmetry.Int_Tables_number = atoi(tmp);
            }
            
        }else if(strstr_space(line[i], "Unit cell volume")){
            if(i>1){
                k=sscanf(line[i-1], "%*s%f%f%f%f%f%f %*s%*s%*s %f",
                         &a1, &a2, &a3, &a4, &a5, &a6, &a7);
                if( k==7 ){
                    cell.length_a = a1;
                    cell.length_b = a2;
                    cell.length_c = a3;
                    cell.angle_alpha = a4;
                    cell.angle_beta = a5;
                    cell.angle_gamma = a6;
                    exptl_crystal.pdbx_mosaicity  = a7;
                }
            }
            
        }else if(strstr_space(line[i], "All films")){
            k=sscanf(line[i]+10,"%d %*s %f %f %f", &n1, &a1, &a2,  &a3);
            
            if(k==4){
                reflns.pdbx_number_measured_all=n1;
                reflns.pdbx_netI_over_av_sigmaI=a1;
                reflns.pdbx_chi_squared=a2;
                reflns.pdbx_Rmeas_mean=a3;
                
            }

  
        }else if(strstr_case(line[i], "Summary of observation redundancies by shells:") &&
                 strstr_case(line[i+1], "No. of reflections") ){
            
            n=0;
            for(j=i+2; j<nline; j++){ //skip up to limit
                if(strstr(line[j], "limit"))  continue;
                
                if(n>=NBIN){
                    n=0;
                    break;
                }
                if(strstr_space(line[j], "All hkl")){
                    reflns.number_obs = get_int_by_length(line[j], 73, 79);
                    i=j;
                    break;
                }
                
                reflns_shell.d_res_low[n] =  get_float_by_length(line[j], 0, 6) ;
                reflns_shell.d_res_high[n] =  get_float_by_length(line[j], 7, 12) ;
                reflns_shell.number_unique_all[n] = get_int_by_length(line[j], 73, 79);
                n++;
            }
            nbin=n;
            
  
        }else if(strstr_case(line[i], "I/Sigma in resolution shells:") &&
                 strstr_case(line[i+1], "No. of reflections") ){
            
            n=0;
            for(j=i+2; j<nline; j++){ //skip up to limit
                if(strstr(line[j], "limit"))  continue;
                
                if(n>=NBIN){
                    n=0;
                    break;
                }
                if(strstr_space(line[j], "All hkl")){
                    reflns.number_obs = get_int_by_length(line[j], 61, 68);
                    i=j;
                    break;
                }
                
                reflns_shell.d_res_low[n] =  get_float_by_length(line[j], 0, 6) ;
                reflns_shell.d_res_high[n] =  get_float_by_length(line[j], 7, 12) ;
                reflns_shell.number_unique_all[n] = get_int_by_length(line[j], 61, 68);
                n++;
            }
            nbin=n;

        }else if(strstr_space(line[i], "Shell       Average Redundancy Per Shell")){
            if( strstr_space(line[i+1], "Lower Upper")){
            
                n=0;
                for(j=i+2; j<nline; j++){ //skip up to limit
                    if(strstr(line[j], "limit"))  continue;
                    if(n>=NBIN){
                        n=0;
                        break;
                    }
                    if(strstr_space(line[j], "All hkl")){
                        reflns.pdbx_redundancy = get_float_by_length(line[j], 12, 29);
                        i=j;
                        break;
                    }
                    k=sscanf(line[j], "%f%f%f",&a1, &a2, &a3);
                    if(k==3){
                        reflns_shell.d_res_low[n] =  a1;
                        reflns_shell.d_res_high[n] =  a2 ;
                        reflns_shell.pdbx_redundancy[n] =  a3 ;
                        n++;
                    }
                }
                nbin=n;
            }
            
        }else if(strstr_space(line[i], "Summary of observation redundancies:")){

            if( strstr_space(line[i+1], "% of reflections with given No")){
                n=0;
                for(j=i+2; j<nline; j++){ 
                    if(strstr(line[j], "limit"))  continue;
                    if(n>=NBIN){
                        n=0;
                        break;
                    }
                    if(strstr_space(line[j], "All hkl")){
                        reflns.percent_possible_obs = get_float_by_length(line[j], 73, 79);
                        i=j;
                        break;
                    }
                    reflns_shell.percent_possible_all[n] = get_float_by_length(line[j], 73, 79);
                    n++;
                }
                nbin=n;
            }
            
        }else if(strstr_space(line[i], "Shell Lower Upper Average")){  
            if(strstr_space(line[i+1], "limit    Angstrom")){
                n=0;
                for(j=i+2; j<nline; j++){ 
                    if(strstr(line[j], "limit"))  continue;
                    if(n>=NBIN){
                        n=0;
                        break;
                    }
                    if(strstr_space(line[j], "All reflections")){
                        k=sscanf(line[j] +18, "%f%f %*s %f%f",&a1, &a2, &a3, &a4);
                        if(k==4){
                            reflns.pdbx_average_I_obs = a1;
                            reflns.pdbx_average_sigmaI_obs = a2;
                            reflns.pdbx_chi_squared = a3;
                            reflns.pdbx_Rmerge_I_obs = a4;
                        }
                    
                        i=j;
                        break;
                    }
                    k=sscanf(line[j], "%f%f%f%f  %*s %f%f",&a1, &a2, &a3, &a4, &a5, &a6);
                    if(k==6){
                        reflns_shell.d_res_low[n] =  a1;
                        reflns_shell.d_res_high[n] =  a2 ;
                        reflns_shell.pdbx_average_I_obs[n] =  a3 ;
                        reflns_shell.pdbx_average_sigmaI_obs[n] =  a4 ;
                        reflns_shell.pdbx_chi_squared[n] =  a5 ;
                        reflns_shell.Rmerge_I_obs[n] =  a6 ;
                        n++;
                    }  
                }
                nbin=n;
            }
        }
    }
    if(reflns_shell.d_res_low[0]>0){
        reflns.d_resolution_low=reflns_shell.d_res_low[0];
        reflns.pdbx_resolution_low_scale=reflns_shell.d_res_low[0];
    }
    
    if(reflns_shell.d_res_high[nbin-1]>0){
        reflns.d_resolution_high=reflns_shell.d_res_high[nbin-1];
        reflns.pdbx_resolution_high_scale=reflns_shell.d_res_high[nbin-1];
    }
    
                                       
    if(nbin >0){
        reflns_shell.nbin=nbin;
    }else{
        reflns_shell.nbin=0;
        printf("Warning! Nothing extracted from (%s)!\n", inpfile);
    }
    if(nline>0)free_memory_2d(line, nline);
    
    
}


void extract_DTREK_log(char *inpfile )
// Extracting statistics from LOG files of D*trek 
{
    char tmp[512], **lines=NULL;
    long i=0,m1=0, j, m2=0, k=0,   n1, n2,n3;
    int nline;
    float a1, a2, a3, a4, a5;
    
    lines=get_lines_from_file(inpfile, &nline );
    reflns_shell.nbin=0;
    for(i=1; i<nline-3; i++){
        if (strstr_space(lines[i], "Unit cell lengths:")){
            strcpy(tmp, strstr_case(lines[i], "lengths:")+8);
            if(sscanf(tmp, "%f%f%f", &a1, &a2, &a3)==3){
                cell.length_a = a1;
                cell.length_b = a2;
                cell.length_c = a3;
            }
            
        }else if(strstr_space(lines[i], "Unit cell  angles:")){
            strcpy(tmp, strstr_case(lines[i], "angles:")+7);
            if(sscanf(tmp, "%f%f%f", &a1, &a2, &a3)==3){
                cell.angle_alpha = a1;
                cell.angle_beta = a2;
                cell.angle_gamma = a3;
            }
            
        }else if(strstr_space(lines[i], "Mosaicity:")){
            strcpy(tmp, strstr_case(lines[i], "Mosaicity:")+10);
            if(sscanf(tmp, "%f", &a1)==1){
                exptl_crystal.pdbx_mosaicity= a1;
            }
            
        }else if(strstr_space(lines[i], "Spacegroup number:")){
            strcpy(tmp, strstr_case(lines[i], "number:")+7);
            if(sscanf(tmp, "%ld", &n1)==1){
                symmetry.Int_Tables_number = n1;
            }
            if(i<nline-2 && strstr_space(lines[i+1], " name:")){
                get_data_set_id(lines[i+1], "name:", "\n", symmetry.space_group_name_H_M);
            }
            
        }else if(strstr_space(lines[i], "All batches") && !strstr(lines[i],"---") ){
            k=sscanf(lines[i]+14, "%*s %ld %ld %*s %*s %f %f  %*s %f",
                     &n1, &n2, &a1, &a2,  &a3);
            if(k==5){
                reflns.pdbx_number_measured_all=n1;
                reflns.pdbx_scaling_rejects=n2;
                reflns.pdbx_netI_over_av_sigmaI=a1;
                reflns.pdbx_chi_squared=a2;
                reflns.pdbx_Rmeas_mean=a3;
            }
            
            
        }else if(strstr_space(lines[i], "range      unique     obs   rejs   mults  single unique   mult  shell  cumul") ){
// Completeness vs Resolution
            m1=0;

            for(j=i+2; j<nline-3; j++){
                k=sscanf(lines[j], "%f%*s%f %*s %ld %ld %*s%*s %ld %f%f",
                         &a1,&a2,&n1,&n2,&n3, &a3, &a4);
                
                if(k==7){
                    reflns_shell.d_res_low[m1]=a1;
                    reflns_shell.d_res_high[m1]=a2;
                    reflns_shell.number_measured_all[m1]=n1;
                    reflns_shell.pdbx_rejects[m1]=n2;
                    reflns_shell.number_unique_all[m1]=n3;
                    reflns_shell.pdbx_redundancy[m1]=a3;
                    reflns_shell.percent_possible_all[m1]=a4;
                    m1++;
                }
                
                if(strstr(lines[j], "--------------")){
                    k=sscanf(lines[j+1], "%f%*s%f %*s %ld %ld %*s%*s %ld %f%f",
                         &a1,&a2,&n1,&n2,&n3, &a3, &a4);
                    if(k==7){
                        reflns.d_resolution_low = a1;
                        reflns.d_resolution_high = a2;
                        reflns.pdbx_number_measured_all = n1;
                        reflns.pdbx_scaling_rejects = n2;
                        reflns.number_obs = n3;
                        reflns.pdbx_redundancy = a3;
                        reflns.percent_possible_obs = a4;
                    }
                    i=j;
                    break;
                }
            }
            
        }else if(strstr_space(lines[i], "range      counts     obs   rejs   ovlps   mults <sig>>") ){
//Rmerge vs Resolution
//d*TREK version 7.0SSI -- Feb 21 2001            

            m2=0;

            for(j=i+2; j<nline-3; j++){
                if(sscanf(lines[j], "%f%*s%f %*s%*s%*s%*s%*s %f%f%f",
                          &a1,&a2, &a3, &a4, &a5)==5){
                    
                    reflns_shell.d_res_low[m2]=a1;
                    reflns_shell.d_res_high[m2]=a2;
                    
                    reflns_shell.meanI_over_sigI_obs[m2]=a3;
                    reflns_shell.pdbx_chi_squared[m2]=a4;
                    reflns_shell.Rmerge_I_obs[m2]=a5;

                    m2++;
                }else if(strstr(lines[j], "--------------")){
                    if(sscanf(lines[j+1], "%f%*s%f %*s%*s%*s%*s%*s %f%f%f",
                          &a1,&a2, &a3, &a4, &a5)==5){
                        reflns.d_resolution_low=a1;
                        reflns.d_resolution_high=a2;
                        reflns.pdbx_netI_over_av_sigmaI=a3;
                        reflns.pdbx_chi_squared=a4;
                        reflns.pdbx_Rmerge_I_obs=a5;
                        
                  
                    }
                    i=j;
                    break;
                }
            }
        }else if(strstr_space(lines[i], "range      counts   rejs   mults   unavg    avg  ChiSq  Eadd*  shell  cumul") ){
//Rmerge vs Resolution
//  d*TREK version 9.1LDz -- Nov 12 2003;  9.1L -- Jan  3 2004          
            m2=0;

            for(j=i+2; j<nline-3; j++){
                if(sscanf(lines[j], "%f %*s %f %*s%*s%*s%*s %f %f %*s %f",
                          &a1,&a2, &a3, &a4, &a5)==5){
                    
                    reflns_shell.d_res_low[m2]=a1;
                    reflns_shell.d_res_high[m2]=a2;
                    reflns_shell.meanI_over_sigI_obs[m2]=a3;
                    reflns_shell.pdbx_chi_squared[m2]=a4;
                    reflns_shell.Rmerge_I_obs[m2]=a5;
                    m2++;
                }else if(strstr(lines[j], "--------------")){
                    if(sscanf(lines[j+1], "%f %*s %f %*s%*s%*s%*s %f %f %*s %f",
                          &a1,&a2, &a3, &a4, &a5)==5){
                       
                        reflns.d_resolution_low=a1;
                        reflns.d_resolution_high=a2;
                        reflns.pdbx_netI_over_av_sigmaI=a3;
                        reflns.pdbx_chi_squared=a4;
                        reflns.pdbx_Rmerge_I_obs=a5;
                    }
                    i=j;
                    break;
                }
            }
                
        }else if(strstr_space(lines[i], "Summary of data collection statistics") ){
            
           for(j=i+2; j<nline-3; j++){
                if(strstr_space(lines[j], "Spacegroup")){
                   get_data_set_id(lines[j], "Spacegroup", "\n",
                                   symmetry.space_group_name_H_M);
                   
                }else if(strstr_space(lines[j], "Resolution range")){
                   if(sscanf(lines[j]+30, "%f%*s%f", &a1, &a2) ==2){
                        reflns.d_resolution_low=a1;
                        reflns.d_resolution_high=a2;
                   }
                   
                }else if(strstr_space(lines[j], "Number of unique reflections")){         
                   strcpy(lines[j], strstr_case(lines[j], "reflections")+11); 
                   if(sscanf(lines[j]+30, "%ld", &n1) ==1) reflns.number_obs=n1;
                   
                }else if(strstr_space(lines[j], "Average redundancy")){
                    if(sscanf(lines[j]+30, "%f", &a1) ==1) reflns.pdbx_redundancy = a1;
                    
                }else if(strstr_space(lines[j], "% completeness")){   
                    if(sscanf(lines[j]+30, "%f", &a1) ==1)  reflns.percent_possible_obs = a1;
                    
                }else if(strstr_space(lines[j], "Rmerge ")){
                    if(sscanf(lines[j]+30, "%f", &a1) ==1) reflns.pdbx_Rmerge_I_obs = a1;
                    
                }else if(strstr_space(lines[j], "Reduced ChiSquared ")){
                    if( sscanf(lines[j]+30, "%f", &a1) ==1) reflns.pdbx_chi_squared = a1;
                    
                }else if(strstr_space(lines[j], "Output <I/sigI>")){
                    if(sscanf(lines[j]+30, "%f", &a1) ==1) reflns.pdbx_netI_over_av_sigmaI = a1;
                    
                }else if(strstr(lines[j], "--------------")){
                    i=j;
                    break;
                }
            }
           
        }
                
    }
    reflns.pdbx_resolution_high_scale=reflns.d_resolution_high;
    reflns.pdbx_resolution_low_scale=reflns.d_resolution_low;
    
    if(m1!=0 && m2!=0 ){
        reflns_shell.nbin = m1;
    }else{
        reflns_shell.nbin=0;
        printf("Warning! Nothing extracted from (%s)!\n", inpfile);
    }
        
    if(lines) free_memory_2d(lines, nline);
    
}


void extract_XGEN_log(char *inpfile )
// Extracting statistics from LOG files of X-GEN
{
    char  **line;
    int nline, i,j, n;

    line=get_lines_from_file(inpfile, &nline);

    for(i=0; i<nline; i++){
        if(strstr(line[i],"Totals:") &&
           strstr(line[i+1],"Summary of Observation Redundancies by Shells:")){
            reflns.B_iso_Wilson_estimate=get_float_by_length(line[i],65,72);
        }
        
        if(strstr(line[i],"Summary of Reflection Intensities and R-factors by Shells:")){
            n=0;
            for(j=i+1; j<nline; j++){
                if(strstr(line[j],"Average ") )continue;
                if(strstr_case(line[j],"Y/sigma(Y) in Given Range") )continue;
                if(strstr_case(line[j],"Limit,  Inten-") )continue;
                if(strstr_case(line[j],"Angst.    sity") )continue;
                if(strstr(line[j],"Totals:")){
                    if(n>0)reflns.d_resolution_high=reflns_shell.d_res_high[n-1];
                    reflns.pdbx_average_I_obs = get_float_by_length(line[j], 8,15);
                    reflns.pdbx_netI_over_av_sigmaI=get_float_by_length(line[j], 16,24);
                    reflns.number_obs=get_int_by_length(line[j], 64,70);
                    reflns.number_all=get_int_by_length(line[j], 71,77);
                    reflns.pdbx_Rmerge_I_obs =get_float_by_length(line[j],95,101)*0.01;
                    reflns.Rmerge_F_obs=get_float_by_length(line[j],111,118)*0.01;
                    
                    i=j;
                    
                    break;
                }

                reflns_shell.d_res_high[n] = get_float_by_length(line[j],0,6);

                if(n==0) reflns_shell.d_res_low[0]=-99999;
                if(n>0) reflns_shell.d_res_low[n] = reflns_shell.d_res_high[n-1];
                
                reflns_shell.pdbx_average_I_obs[n] = get_float_by_length(line[j], 8,15) ;
                reflns_shell.meanI_over_sigI_obs[n] =get_float_by_length(line[j], 16,24) ;
                reflns_shell.number_unique_all[n] =get_int_by_length(line[j], 64,70) ;
                reflns_shell.number_measured_all[n] =get_int_by_length(line[j], 71,77) ;
                
                reflns_shell.Rmerge_I_obs[n] = get_float_by_length(line[j], 95,101)*0.01;
                reflns_shell.Rmerge_F_obs[n] = get_float_by_length(line[j],111,118)*0.01;
                n++;
                if(n>NBIN-2){
                    reflns_shell.nbin=0;
                    return;
                }
                
            }
            if(n>0){
                reflns_shell.nbin=n;
                break;
            }
            
        }
    }
    if(nline) free_memory_2d(line,nline);
    
    
    
}

void extract_SAINT_log(char *inpfile )
// Extracting statistics from LOG files of SAINT
{
    char str[512], tmp[512];
    long k=0, n=0, i1,i2;
    float a1, a2, a3, a4, a5;
    FILE *fp;
    
    if((fp=fopen(inpfile, "r"))==NULL)
       open_file_error(inpfile, "extract_log_SAINT");
    
    while (fgets(str, sizeof str, fp) != NULL) {
        k=0;
        if (strstr_space(str, "Overall    #  Pairs   Uniq   Merg %<2s   <I> <#Sig>   <Bg>  Rsym ")){
            while (fgets(str, sizeof str, fp) != NULL){
                rid_of_front_space(str);
                if(strlen(str)<20) continue;  
                k=sscanf(str,"%*s %ld %*s %ld  %*s%*s  %f%f %*s %f",
                         &i1, &i2, &a1, &a2, &a3);
                if( k==5 ){
                    reflns.pdbx_number_measured_all = i1;
                    reflns.number_obs = i2;
                    reflns.pdbx_netI_over_av_sigmaI = a1/a2;
                    reflns.pdbx_Rsym_value=a3;
               
                }else{
                    break;
                }
            }
            
        }
        if(k==5)break;
    }
    
    rewind(fp);
    while (fgets(str, sizeof str, fp) != NULL) {
        if (strstr_space(str, "Angstrms   #Obs Theory %Compl Redund   Rsym Pairs %Pairs")){
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                rid_of_front_space(str);
                if(n>=NBIN){
                    n=0;
                    break;
                }
                if(strlen(str)<20) continue;
                
                k=sscanf(str,"%s %f%ld%*s %f%f%f%*s%*s%f",
                         tmp, &a1, &i1, &a2, &a3, &a4, &a5);
                
                if( k==7 && !strcmp_case(tmp,"to")){
                    reflns.d_resolution_high=a1;
                    reflns_shell.d_res_high[n]=a1;
                    
                    if(n==0) reflns_shell.d_res_low[0]=-99999;
                    if(n>0) reflns_shell.d_res_low[n] = reflns_shell.d_res_high[n-1];
                    reflns.percent_possible_obs=a2;
                    reflns.pdbx_redundancy=a3;
                    reflns.pdbx_Rsym_value=a4;
                    reflns_shell.pdbx_Rsym_value[n]=a5;
                    n++;
                }else {
                    break;
                }
            }
        }


        
    }
    reflns.pdbx_resolution_high_scale=reflns.d_resolution_high;
    reflns.pdbx_resolution_low_scale=reflns.d_resolution_low;
    
    if(n>0 ){
        reflns_shell.nbin=n;
    }else{
        reflns_shell.nbin=0;
        printf("Warning! Nothing extracted from (%s)!\n", inpfile);
    }
    
}


void extract_SCALA_log(char *inpfile )
/* Extracting statistics from LOG files of SCALA
   Things extracted are :I/sigmaI, completeness, Nrefl, redundancy,Rsym,
   any with resolution shells.
 */  
{
    char  tmp[512], **line;
    int i,j=0, k=0, n=0, n1=0, n2=0,n3=0,  nset1=0, nset2=0, nline;
    float a0,a1, a2, a3, a4, a5, a6;

    line=get_lines_from_file(inpfile, &nline);
    

    for(i=0; i<nline-1; i++){
        if (strstr_space(line[i], " * Cell Dimensions :")){
            k=sscanf(line[i+1],"%f%f%f%f%f%f", &a1, &a2, &a3, &a4, &a5, &a6);
            
            if( k==6 ){
                cell.length_a = a1;
                cell.length_b = a2;
                cell.length_c = a3;
                cell.angle_alpha = a4;
                cell.angle_beta = a5;
                cell.angle_gamma = a6;
            }
            
        }else if(strstr_space(line[i], "*  Resolution Range :")){
            if(pattern5(line[i+1]," ( ", " - ", "A", ")", "")){
                k=sscanf(line[i+1],"%*s %*s %*s %f %*s %f", &a1, &a2);

                if( k==2 ){
                    reflns.d_resolution_low = a1;
                    reflns.d_resolution_high = a2;
                }
            }
            
        }else if(pattern5(line[i],"Space group =", "'", "'", "(number", ")") ){
            strcpy(tmp, get_substr(line[i],"Space group =", "(number"));
            char2space(tmp, '\'');
            if(strlen(tmp)>0) strcpy(symmetry.space_group_name_H_M, tmp);
            strcpy(tmp, "");
            strcpy(tmp, get_substr(line[i],"number", ")"));
            if(strlen(tmp)>0)symmetry.Int_Tables_number = atoi(tmp);
            
        }else if(strstr_space(line[i], " N 1/d^2 Dmin(A) Rfac  Rfull   Rcum  Ranom  Nanom    Av_I   SIGMA I/sigma") ||
// version before CCP4 5.0
                 strstr_space(line[i], " N 1/d^2 Dmin(A) Rmrg  Rfull   Rcum  Ranom  Nanom    Av_I   SIGMA I/sigma") ){
// version after CCP4 5.0
            n=0;
            for(j=i; j<nline-1; j++){
                rid_of_front_end_space(line[j]);
                if(n>=NBIN){
                    n=0;
                    break;
                }
                
                if(!strncmp(line[j], "Overall:", 8) && strstr_space(line[j+1],"SIGMA I/sigma")){
                    
                    k=sscanf(line[j]+9,"%f %*s %*s %f %d %f %f %f %*s %f ",
                             &a1, &a2, &n1, &a3, &a4, &a5, &a6);

                    if(k==7){
                        reflns.pdbx_Rmerge_I_obs = a1 ;
                        reflns.pdbx_Rmerge_I_anomalous = a2 ;
                        reflns.pdbx_number_anomalous = n1 ;
                        reflns.pdbx_average_I_obs = a3 ;
                        reflns.pdbx_average_sigmaI_obs = a4 ;
                        reflns.pdbx_netI_over_av_sigmaI= a5 ;
                        reflns.pdbx_meanI_over_sd =  a6;
                    }
                    i=j+1;
                    break;
                }
                if(strlen(line[j])<20  )continue;

                k=sscanf(line[j],"%*s %*s %f %f %*s %*s %f %d %f %f %f %*s %f ",
                        &a0, &a1, &a2, &n1, &a3, &a4, &a5, &a6);
                
                if(k==8){
                    if(n==0)reflns_shell.d_res_low[0]=reflns.d_resolution_low;
                    if(n>0) reflns_shell.d_res_low[n] = reflns_shell.d_res_high[n-1];
                    reflns_shell.d_res_high[n] = a0 ;
                    reflns_shell.Rmerge_I_obs[n] = a1 ;
                    reflns_shell.pdbx_Rmerge_I_anomalous[n] = a2 ;
                    reflns_shell.pdbx_number_anomalous[n] = n1 ;
                    reflns_shell.pdbx_average_I_obs[n] = a3 ;
                    reflns_shell.pdbx_average_sigmaI_obs[n] = a4 ;
                    reflns_shell.meanI_over_sigI_obs[n]= a5 ;
                    reflns_shell.pdbx_meanI_over_sd[n] =  a6;

                    n++;
                }
                nset1=n;
            }
            
        }else if(strstr_space(line[i],"N 1/resol^2 Dmin    Nmeas    Nref  Ncent   %poss Cm%poss Mlplcty") &&
                 strstr_space(line[i],"Mlplcty AnomCmpl AnomFrc  Rmeas  Rmeas0  (Rsym)    PCV     PCV0")){
// version before CCP4 5.0                 
            n=0;
            for(j=i; j<nline-1; j++){
                if(strlen(line[j])<20  )continue;
                rid_of_front_end_space(line[j]);
                if(n>=NBIN){
                    n=0;
                    break;
                }
               
                if(!strncmp(line[j], "Overall", 7) && strstr_space(line[j+1],"Nmeas    Nref  Ncent")){
                    k=sscanf(line[j]+8,"%d%d%d %f %*s %f %*s%*s%*s  %f %f %*s %f ",
                              &n1, &n2, &n3,&a1, &a2, &a3, &a4, &a5);
                    
                    if(k==8){
                        reflns.pdbx_number_measured_all=n1;
                        reflns.number_obs=n2;
                        reflns.pdbx_number_centric=n3;
                        reflns.percent_possible_obs=a1;
                        reflns.pdbx_redundancy=a2;
                        reflns.pdbx_Rmeas_mean=a3;
                        reflns.pdbx_Rsym_value=a4;
                        reflns.pdbx_PCV_mean=a5;
                    }
                    i=j+1;
                    break;
                }
                
                k=sscanf(line[j],"%*s %*s %f %d%d%d %f %*s %f %*s%*s%*s %f %f %*s %f",
                         &a0,&n1, &n2, &n3,&a1, &a2, &a3, &a4, &a5);

                if(k==9){
                    if(n==0) reflns_shell.d_res_low[0] = reflns.d_resolution_low;
                    if(n>0) reflns_shell.d_res_low[n] = reflns_shell.d_res_high[n-1];
                
                    reflns_shell.d_res_high[n] = a0 ;
                    reflns_shell.number_measured_all[n] = n1 ;
                    reflns_shell.number_unique_all[n] = n2;
                    reflns_shell.pdbx_number_centric[n] = n3;
                    reflns_shell.percent_possible_all[n] = a1;
                    reflns_shell.pdbx_redundancy[n] =a2 ;
                    reflns_shell.pdbx_Rmeas_mean[n] = a3;
                    reflns_shell.pdbx_Rsym_value[n] = a4;
                    reflns_shell.pdbx_PCV_mean[n] = a5;

                    n++;
                }
            }
            nset2=n;  
        }else if(strstr_space(line[i],"N 1/resol^2 Dmin    Nmeas    Nref  Ncent  %poss C%poss") &&
// version after CCP4 5.0
                 pattern5(line[i],"C%poss", "Mlplct", "AnoCmp", "AnoFrc", "AnoMlt ")){ 

            n=0;
            for(j=i; j<nline-1; j++){
                if(strlen(line[j])<20  )continue;
                rid_of_front_end_space(line[j]);
                if(n>=NBIN){
                    n=0;
                    break;
                }
                if(!strncmp(line[j], "Overall", 7) && strstr_space(line[j+1],"Nmeas    Nref  Ncent")){
                    
                    k=sscanf(line[j]+8,"%d%d%d %f %*s %f %*s %*s %*s %*s  %f %f  ",
                              &n1, &n2, &n3,&a1, &a2, &a3, &a4);
                    
                    if(k==7){
                        reflns.pdbx_number_measured_all=n1;
                        reflns.number_obs=n2;
                        reflns.pdbx_number_centric=n3;
                        reflns.percent_possible_obs=a1;
                        reflns.pdbx_redundancy=a2;
                        reflns.pdbx_Rmeas_mean=a3;
                        reflns.pdbx_Rsym_value=a4;
                    //    reflns.pdbx_PCV_mean=a5;
                    }
                    i=j+1;
                    break;
                }
                
                k=sscanf(line[j],"%*s %*s %f %d%d%d %f %*s %f %*s%*s%*s%*s %f %f %*s",
                         &a0,&n1, &n2, &n3,&a1, &a2, &a3, &a4);

                if(k==8){
                    if(n==0) reflns_shell.d_res_low[0] = reflns.d_resolution_low;
                    if(n>0) reflns_shell.d_res_low[n] = reflns_shell.d_res_high[n-1];
                
                    reflns_shell.d_res_high[n] = a0 ;
                    reflns_shell.number_measured_all[n] = n1 ;
                    reflns_shell.number_unique_all[n] = n2;
                    reflns_shell.pdbx_number_centric[n] = n3;
                    reflns_shell.percent_possible_all[n] = a1;
                    reflns_shell.pdbx_redundancy[n] =a2 ;
                    reflns_shell.pdbx_Rmeas_mean[n] = a3;
                    reflns_shell.pdbx_Rsym_value[n] = a4;
                 //   reflns_shell.pdbx_PCV_mean[n] = a5;

                    n++;
                }
            }
            nset2=n;  
        }else if(strstr_space(line[i],"Summary data for Project: ")){
            for(j=i; j<nline-1; j++){
                rid_of_front_end_space(line[j]);
                if(strstr(line[j], "==============")) break;
                
                if(strstr_space(line[j], "Low resolution limit")){
                    reflns.pdbx_resolution_low_scale = get_float_after_id(line[j], "limit");
                    
                }else if(strstr_space(line[j], "High resolution limit")){
                    reflns.pdbx_resolution_high_scale = get_float_after_id(line[j], "limit");
                    
                }else if(!strncmp(line[j],"Rmerge ", 7)){
                    reflns.pdbx_Rmerge_I_obs = get_float_after_id(line[j], "Rmerge");
                
                }else if(strstr_space(line[j],"Rmeas (all I+ & I-)")){
                    reflns.pdbx_Rmeas_mean = get_float_after_id(line[j], ")");
                
                }else if(strstr_space(line[j],"Total number of observations")){
                    reflns.pdbx_number_measured_all = get_int_after_id(line[j], "observations");
                
                }else if(strstr_space(line[j],"Total number unique")){
                    reflns.number_obs = get_int_after_id(line[j], "unique");
                
                 }else if(strstr_space(line[j],"Mean(I)/sd(I)")){
                    reflns.pdbx_meanI_over_sd = get_float_after_id(line[j], "sd(I)");
                
                }else if(!strncmp(line[j],"Completeness", 12)){
                    reflns.percent_possible_obs = get_float_after_id(line[j], "Completeness");
                    
                }else if(!strncmp(line[j],"Multiplicity", 12)){
                    reflns.pdbx_redundancy = get_float_after_id(line[j], "Multiplicity");
                    
                }
            }
        }
        
                 
    }

    if(nset1 >0 && nset2 >0 && nset1== nset2){
        reflns_shell.nbin=nset1;
    }else{
        reflns_shell.nbin=0;
        printf("Warning! Only partial data was extracted from (%s)!\n", inpfile);
    }
    
}

void extract_3DSCALE_log(char *inpfile )
// Extracting statistics from LOG files of 3DSCALE
{
    char str[512], tmp[512];
    int k=0, n=0, i1,i2, i3,i4;
    float a1, a2, a3, a4, a5, a6, a7, a8;
    FILE *fp;
    
    if((fp=fopen(inpfile, "r"))==NULL)
       open_file_error(inpfile, "extract_log_3DSCALE");
    
    while (fgets(str, sizeof str, fp) != NULL) {
        k=0;
        if (pattern5(str, "Unit cell",": ","","","") ){
            strcpy(tmp, strstr(str,":")+1);
            k=sscanf(tmp,"%f%f%f%f%f%f", &a1, &a2, &a3, &a4, &a5, &a6);
            if(k==6){

                cell.length_a = a1;
                cell.length_b = a2;
                cell.length_c = a3;
                cell.angle_alpha = a4;
                cell.angle_beta = a5;
                cell.angle_gamma = a6;
            }
        }else if(pattern5(str, "Space Group", ": ","","","") ){
            
            strcpy(tmp, strstr(str,":")+1);
            k=sscanf(tmp,"%d%s", &n, str);
            if(k==2){
                symmetry.Int_Tables_number = n;
                strcpy(symmetry.space_group_name_H_M, strstr(tmp, str));
                rid_of_front_end_space(symmetry.space_group_name_H_M);
            }
        }else if(pattern5(str, " Overall Resolution Cutoff ", ": ","","","") ){
            strcpy(tmp, strstr(str,":")+1);
            k=sscanf(tmp,"%f%f", &a1, &a2);
            if(k==2){
                reflns.d_resolution_low= a1;
                reflns.d_resolution_high= a2;
            }
        }else if(strstr_space(str, " rejected as outliers") ){
            
            k=sscanf(str,"%d %d", &i1, &i2);
            if(k==2){
                reflns.pdbx_scaling_rejects=i2;
            }
        }else if(pattern5(str, " Observed  ", " Unique  "," Observed "," Unique ","") ){
            while (fgets(str, sizeof str, fp) != NULL)
                if(is_space_line(str)>20) break;
            k=sscanf(str,"%d %d %d %d", &i1, &i2, &i3, &i4);
            if(k==4){
                reflns.pdbx_number_measured_all = i3;
                reflns.number_obs = i4;
            }
        }else if(strstr_space(str,"Shell nRefObs nRefExp Compl% Redund  Rsym---Shell Rfree nRfree")
                 && strstr_space(str,"<i/sigi>--Shell <I/sigI>--Shell <Chi^2>    N(+)    N(-)")){
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                rid_of_front_space(str);
                k=sscanf(str,"%s %f %*s%*s %f%f%f%f %*s%*s%*s%*s %f%f%f",
                          tmp,&a1, &a2, &a3, &a4, &a5, &a6, &a7, &a8);
                if(n>1 && k!=9 && strcmp_case(tmp,"to")) break;
                if( k==9 && !strcmp_case(tmp,"to")){
                    
                    reflns_shell.d_res_high[n]=a1;
                    if(n>0) reflns_shell.d_res_low[n] = reflns_shell.d_res_high[n-1];
                    reflns.percent_possible_obs=a2;
                    reflns.pdbx_redundancy=a3;
                    reflns.pdbx_Rsym_value=a4;
                    reflns_shell.pdbx_Rsym_value[n]=a5;
                    reflns.pdbx_netI_over_av_sigmaI=a6;
                    reflns_shell.meanI_over_sigI_obs[n]=a7;
                    reflns.pdbx_chi_squared=a8;
                    n++;
                }
            }
            
        }else if(strstr_space(str,"Shell nRefObs nRefExp nRefCen Compl% Redund  Rsym---Shell Rfree nRfree")
                 && strstr_space(str,"<i/sigi>--Shell <I/sigI>--Shell <Chi^2> <AnoI/SigI>")){
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                rid_of_front_space(str);
                k=sscanf(str,"%s %f %*s%*s%*s %f%f%f%f %*s%*s%*s%*s %f%f%f",
                          tmp,&a1, &a2, &a3, &a4, &a5, &a6, &a7, &a8);
                if(n>1 && k!=9 && strcmp_case(tmp,"to")) break;
                if( k==9 && !strcmp_case(tmp,"to")){
                    reflns_shell.d_res_high[n]=a1;
                    if(n>0) reflns_shell.d_res_low[n] = reflns_shell.d_res_high[n-1];
                    reflns.percent_possible_obs=a2;
                    reflns.pdbx_redundancy=a3;
                    reflns.pdbx_Rsym_value=a4;
                    reflns_shell.pdbx_Rsym_value[n]=a5;
                    reflns.pdbx_netI_over_av_sigmaI=a6;
                    reflns_shell.meanI_over_sigI_obs[n]=a7;
                    reflns.pdbx_chi_squared=a8;
                    n++;
                }
            }
            
        }
       
         
    }
    reflns_shell.d_res_low[0]=reflns.d_resolution_low;
    
    reflns.pdbx_resolution_high_scale=reflns.d_resolution_high;
    reflns.pdbx_resolution_low_scale=reflns.d_resolution_low;
    
    if(n>0 ){
        reflns_shell.nbin=n;
    }else{
        reflns_shell.nbin=0;
        printf("Warning! Nothing extracted from (%s)!\n", inpfile);
    }
    
}


void extract_XSCALE_log(char *inpfile)
// Extracting statistics from LOG files of 3DSCALE
{
    char **line, tmp[256], comp[20], rmea[20], rmg_f[20], rmg[20], cut[20];
    int k=0, n=0, i,j, nf, nf_u,nf_p, nline;
    float a1, a2, a3, a4, a5, a6;
    

    strcpy(cut, "-3.0");
    if(strlen(DATACUT)>1) strcpy(cut,DATACUT);
    

    line=get_lines_from_file(inpfile, &nline);
    
    for(i=0; i<nline; i++){
        if (pattern5(line[i], "UNIT_CELL_CONSTANTS=",".",".",".",".") ){
            strcpy(tmp, strstr(line[i],"=")+1);
            k=sscanf(tmp,"%f%f%f%f%f%f", &a1, &a2, &a3, &a4, &a5, &a6);
            if(k==6){

                cell.length_a = a1;
                cell.length_b = a2;
                cell.length_c = a3;
                cell.angle_alpha = a4;
                cell.angle_beta = a5;
                cell.angle_gamma = a6;
            }
        }else if(pattern5(line[i], "SPACE_GROUP_NUMBER=", "","","","") ){
            strcpy(tmp, strstr(line[i],"=")+1);
            k=sscanf(tmp,"%d", &n);
            if(k==1){
                symmetry.Int_Tables_number = n;
            }
//        }else if(strstr_space(line[i], "SUBSET OF INTENSITY DATA WITH SIGNAL/NOISE >=  -3.0 AS FUNCTION OF RESOLUTION") ){
        }else if(pattern5(line[i], "SUBSET OF INTENSITY DATA WITH SIGNAL/NOISE >=",
                          cut, "AS FUNCTION OF RESOLUTION", "", "") ){
            n=0;
            for(j=i+3; j<nline-1; j++){
                
                k=sscanf(line[j],"%f %d %d %d %s %s %*s %*s %f %s %s ",
                          &a1, &nf, &nf_u,&nf_p, comp, rmg, &a2, rmea, rmg_f);
//                if(k!=9) continue;
                
                if(nf==0 && comp[0]=='-' && rmg[0]=='-') continue;
                
                if(pattern5(line[j],"total ", ".", "%", "%", "%")){
                    
//                printf("line=%s", line[j]);
                    
                    k=sscanf(line[j],"%*s %d %d %d %s %s %*s %*s %f %s %s ",
                              &nf, &nf_u, &nf_p, comp, rmg, &a2, rmea, rmg_f);
                    if(k==8){
                        reflns.observed_criterion_sigma_I = -3.0;
                        
                        
                        reflns.d_resolution_high=reflns_shell.d_res_high[n-1];
                        reflns.d_resolution_low = -999999;
                        reflns.pdbx_number_measured_all=nf;
                        reflns.number_obs=nf_u;
                            //reflns.number_possible=nf_p;
                        char2space(comp, '%');
                        reflns.percent_possible_obs=atof(comp);
                    
                        char2space(rmg, '%');
                        reflns.pdbx_Rmerge_I_obs=0.01*atof(rmg);
                    
                        reflns.pdbx_netI_over_av_sigmaI=a2;
                    
                        char2space(rmea, '%');
                        reflns.pdbx_Rmeas_mean=0.01*atof(rmea);

                        char2space(rmg_f, '%');
                        reflns.Rmerge_F_obs=0.01*atof(rmg_f);
                    }
                    break;
                    
                }else if( k==9){
                    reflns_shell.d_res_high[n]=a1;
                    if(n>0) reflns_shell.d_res_low[n] = reflns_shell.d_res_high[n-1];
                    reflns_shell.number_measured_obs[n]=nf;
                    reflns_shell.number_unique_obs[n]=nf_u;
                    reflns_shell.number_possible[n]=nf_p;
                    
                    char2space(comp, '%');
                    reflns_shell.percent_possible_all[n]=atof(comp);

                    char2space(rmg, '%');
                    reflns_shell.Rmerge_I_obs[n]=0.01*atof(rmg);
                    
                    reflns_shell.meanI_over_sigI_obs[n]=a2;

                    char2space(rmea, '%');
                    reflns_shell.pdbx_Rmeas_mean[n]=0.01*atof(rmea);
                    

                    char2space(rmg_f, '%');
                    reflns_shell.Rmerge_F_obs[n]=0.01*atof(rmg_f);
                    n++;
                }
            }
        }else if(pattern5(line[i], "WILSON LINE (using all data)", "A=", "B=", "CORRELATION=", "")){
            reflns.B_iso_Wilson_estimate = get_float_after_id(line[i], "B=");
            
        }
    }
    reflns.pdbx_resolution_high_scale=reflns.d_resolution_high;
    reflns.pdbx_resolution_low_scale=reflns.d_resolution_low;
    
    if(n>0){
        reflns_shell.nbin =n;
    }else{
        reflns_shell.nbin=0;
        printf("Warning! Nothing extracted from (%s)!\n", inpfile);
    }
    if(nline>0) free_memory_2d(line, nline);
    
}


void extract_PROSCALE_log(char *inpfile)
// Extracting statistics from LOG files of PROSCALE
{
    char tmp[512], **lines;
    int i,ii,k=0,j=0, n=0, nline=0;
    int n1,n2,n3,n4; 
    float a1, a2, a3, a4, a5, a6, b[20];

    lines=get_lines_from_file(inpfile, &nline);

    for(i=0; i<nline; i++){
        if(strstr_space(lines[i], "Space Group:")){
            n=get_int_after_id(lines[i]," Group:");
            if(n>0) symmetry.Int_Tables_number = n;
            get_string_with_length(lines[i],18, 35, tmp);
            rid_of_front_end_space(tmp);
            if(strlen(tmp)>0) strcpy(symmetry.space_group_name_H_M, tmp);
            
        }else if(strstr_space(lines[i], "<<< Unit cell >>>:")){
            strcpy(tmp, strstr(lines[i],">>>:")+5);
            k=sscanf(tmp,"%f%f%f%f%f%f", &a1, &a2, &a3, &a4, &a5, &a6);
            if(k==6){
                cell.length_a = a1;
                cell.length_b = a2;
                cell.length_c = a3;
                cell.angle_alpha = a4;
                cell.angle_beta = a5;
                cell.angle_gamma = a6;
            }
            
        }else if(strstr_space(lines[i], "<<< Overall Resolution Cutoff >>>:")){
            strcpy(tmp, strstr(lines[i],">>>:")+5);
            k=sscanf(tmp,"%f%f", &a1, &a2);
            if(k==2){
                reflns.d_resolution_high = a2;
                reflns.d_resolution_low = a1;
            }
            
        }else if(strstr_space(lines[i], "<<< Overall I/SigI Cutoff >>>:")){
            strcpy(tmp, strstr(lines[i],">>>:")+5);
            k=sscanf(tmp,"%f%f", &a1, &a2);
            if(k==2){
                reflns.observed_criterion_I_min = a1;
                reflns.observed_criterion_I_max = a2;
            }
            
        }else if(strstr_space(lines[i],"Observed      Unique    Observed      Unique ")){
            if(i<nline-2 && strstr_space(lines[i+1],"total reflections")){
                if(sscanf(lines[i+1],"%d%d%d%d", &n1, &n2, &n3, &n4)==4){
                    reflns.pdbx_number_measured_all  = n3;
                    reflns.number_obs  = n4;
                }
            }
            
        }else if(strstr_space(lines[i],"    rejected as outliers")){
            n1 = get_int_by_length(lines[i], 4, 14);
            n2 = get_int_by_length(lines[i], 28, 37);
            if(n1>=0 && n2>=0){
                reflns.pdbx_scaling_rejects = n2;
            }
        }else if(strstr_space(lines[i],"Res.Shell nRefObs nRefExp Compl% Redund    Rsym---Shell")){
            n=0;
            for(j=i; j<nline;j++){
                k=sscanf(lines[j], "%s%f %*s%*s %f%f%f%f %*s%*s %f%f%f%f%f",
                         tmp, &b[0],&b[1],&b[2],&b[3],&b[4],&b[5],&b[6],&b[7],&b[8],&b[9]);
                
                
                if( k==11 && !strcmp_case(tmp, "to") ){
                    
                    reflns_shell.d_res_high[n]=b[0];
                    reflns.percent_possible_obs = b[1];
                    reflns.pdbx_redundancy = b[2];
                    reflns.pdbx_Rsym_value =  b[3];
                    reflns_shell.pdbx_Rsym_value[n] =  b[4];
                    reflns.pdbx_netI_over_av_sigmaI = b[5];
                    reflns_shell.meanI_over_sigI_obs[n] = b[6];
                    reflns.pdbx_chi_squared  = b[7];
                    reflns.pdbx_netI_over_av_sigmaI_anomalous  = b[8];
                    reflns_shell.pdbx_meanI_over_sigI_anomalous[n]  = b[9];

                    n++;
                }
                if(n>1 && k !=11){
                    reflns_shell.d_res_low[0]=reflns.d_resolution_low;
                    for(ii=0; ii<n-1; ii++){
                        reflns_shell.d_res_low[ii+1] = reflns_shell.d_res_high[ii];
                    }
                    i=j;
                    
                    break;
                }
            }
            
        }
    }
    reflns.pdbx_resolution_high_scale=reflns.d_resolution_high;
    reflns.pdbx_resolution_low_scale=reflns.d_resolution_low;
    
    if(n>0 ){
        reflns_shell.nbin=n;
    }else{
        reflns_shell.nbin=0;
        printf("Warning! Nothing extracted from (%s)!\n", inpfile);
    }
    
}

void I_over_sigmaI(char *inpfile)
{
    char  str[100];
    int  m, h, k, l, hh=0, kk=0, ll=0, nrefl=0, len, nshell[NBIN];
    float i=1, si=1, ii=1, sii=1, i_si=1,sum_i_si=0, I_sigmaI_av[NBIN];
    float cel[6],rcell[6],ah, ak, al, resolution;
    FILE *fp=NULL;

    
    if((fp=fopen(inpfile, "r")) == NULL)
        open_file_error(inpfile, "I_over_sigmaI");
        
    for(m=0; m<6; m++) {
        cel[m]=INI;
    }
    
    if(reflns_shell.nbin<=0) return;
    printf("Number of bins=%d\n", reflns_shell.nbin);
    
    for(m=0; m<reflns_shell.nbin; m++){
        I_sigmaI_av[m] = 0;
        nshell[m]  =   0;
    }
    
    while (fgets(str, sizeof str, fp) !=NULL){
        if(strlen(str)>61 && pattern5(str,".",".",".",".",".")){
            sscanf(str, "%f%f%f%f%f%f",
                   &cel[0], &cel[1], &cel[2],
                   &cel[3], &cel[4], &cel[5]);
            break;
        }  
    }
    if((cel[0]<=0 || cel[1]<=0) && cell.length_a>0){
        cel[0] = cell.length_a;
        cel[1] = cell.length_b;
        cel[2] = cell.length_c;
        cel[3] = cell.angle_alpha;
        cel[4] = cell.angle_beta;
        cel[5] = cell.angle_gamma;
    }
    
    if(cel[0]<=0 || cel[1]<=0 || cel[5]<=0) return;
    calc_recip_cell(cel, rcell);

    
    while (fgets(str, sizeof str, fp) !=NULL){
        rid_of_end_space(str);
        len=strlen(str);

        h = get_int_by_length(str, 0, 3);
        k = get_int_by_length(str, 4, 7);
        l = get_int_by_length(str, 8, 11);

        if(len==28 || len==29 ){
            i = get_float_by_length(str, 12, 19);
            si= get_float_by_length(str, 20, 27);
            
        }else if(len==35 || len==36){
            i = get_float_by_length(str, 19, 26);
            si= get_float_by_length(str, 27, 34);
            
        }else if(len==44 || len==45){
            
            i = get_float_by_length(str, 12, 19);
            si= get_float_by_length(str, 20, 27);

            hh =  -h;
            kk =  -k;
            ll =  -l;
            
            ii = get_float_by_length(str, 28, 35);
            sii= get_float_by_length(str, 36, 43);
            
        }else if(len==53 || len==54){
            i = get_float_by_length(str, 37, 44);
            si= get_float_by_length(str, 45, 52);
        }


        ah= float (h);
        ak= float (k);
        al= float (l);
        
        resolution = get_resolution(ah, ak, al, rcell);
        
        if (h!=0 || k!=0 || l!=0){
            if(si>0.0001) {
                i_si = i/si;
                sum_i_si = sum_i_si + i_si;
            }
            nrefl++;
        }
        if(hh!=0 || kk!=0 || ll!=0){
            if(sii>0.0001) {
                i_si = i/si;
                sum_i_si = sum_i_si + ii/sii;
            }
            nrefl++;
        }
        
        if(reflns_shell.nbin>0){
            for(m=0; m<reflns_shell.nbin; m++){
                if(resolution >=reflns_shell.d_res_high[m] &&
                   resolution <reflns_shell.d_res_low[m]){
                    I_sigmaI_av[m]  =  I_sigmaI_av[m] +  i_si;
                    nshell[m]++;
                    

                }
            }
        }
        
    }
    
    if(nrefl >0 && reflns_shell.nbin>0){
        for(m=0; m< reflns_shell.nbin; m++){
            reflns_shell.meanI_over_sigI_obs[m] = I_sigmaI_av[m]/nshell[m] ;
            
        }
    }
    if(nrefl >0)reflns.pdbx_netI_over_av_sigmaI = sum_i_si/float(nrefl);
 
}


float get_resolution(float h, float k, float l, float *rcell)
{

    float aa1, aa2, aa3, a2, b2, c2, resol=0, dist_sq;
    
    
    aa1 =  2 * rcell[0] * rcell[1] * cos(DEG2RAD*rcell[5]);
    aa2 =  2 * rcell[0] * rcell[2] * cos(DEG2RAD*rcell[4]);
    aa3 =  2 * rcell[1] * rcell[2] * cos(DEG2RAD*rcell[3]);

    a2 =  rcell[0]*rcell[0];
    b2 =  rcell[1]*rcell[1];
    c2 =  rcell[2]*rcell[2];

    dist_sq = h*h*a2 + k*k*b2 + l*l*c2 + h*k*aa1 + h*l*aa2 + k*l*aa3;
    if(dist_sq>0.0000001)
        resol = sqrt(1.0/dist_sq);

    return resol;
    
}
    
void calc_recip_cell(float *cell, float *rcell)
{
    float cosa,cosb, cosc,sina,sinb,sinc, cosast,cosbst,coscst,v;
    
    
    cosa = cos(DEG2RAD*cell[3]);
    cosb = cos(DEG2RAD*cell[4]);
    cosc = cos(DEG2RAD*cell[5]);
    sina = sin(DEG2RAD*cell[3]);
    sinb = sin(DEG2RAD*cell[4]);
    sinc = sin(DEG2RAD*cell[5]);
    
    v = cell[0]* cell[1] *cell[2]*
        sqrt(1. - cosa*cosa - cosb*cosb - cosc*cosc + 2.*cosa*cosb*cosc );
    
    rcell[0] =  cell[1] * cell[2]* sina / v;
    rcell[1] =  cell[0] * cell[2]* sinb / v;
    rcell[2] =  cell[0] * cell[1]* sinc / v;
    
    cosast   =  (cosb*cosc-cosa) / (sinb*sinc);
    cosbst   =  (cosa*cosc-cosb) / (sina*sinc);
    coscst   =  (cosa*cosb-cosc) / (sina*sinb);
    
    rcell[3] =  acos(cosast)/DEG2RAD;
    rcell[4] =  acos(cosbst)/DEG2RAD;
    rcell[5] =  acos(coscst)/DEG2RAD;
    
}

