/*
FILE:     sf-initial.C
*/
/*
VERSION:  3.004
*/
/*
DATE:     9/11/2007
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2007 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/* a program to gather all the reflection data and convert it to
   cif format.   March, 2002
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "rcsb_math.h"
#include <sys/types.h>
#include "sf.h"
#include "util.h"
extern CRYST cryst;


void write_cns(FILE *fout,  char *file_name,
               int ncryst, int nwave, int scale, int format);    
void print_cns(FILE *fout, char *line,
               int ncryst, int nwave,int scale, int format) ;

    
/***************** structure factors from beam line  ****************/
void write_refl_initial(FILE *fout, int argc, char **argv)
{
    char infile[MAXL], prog[80], I_F_type[10],blockid[80];
    int ncryst=1, nwave=1, scale=1, nset=0, i=0, k, n=0,format=0;
    

    for(i=1; i<argc-1; i++){
        if(!strcmp_case(argv[i], "-DP") ) strcpy(prog, argv[i+1]);
        if(!strcmp_case(argv[i], "-DT") ) strcpy(I_F_type, argv[i+1]);
    }

    if(!strcmp_case(prog,"HKL") || !strcmp_case(prog,"HKL2000") ||
       !strcmp_case(prog,"SCALEPACK")) strcpy(prog,"HKL");
    
    
    for(i=1; i<argc-3; i++){     // for all the reflections    
        if(!strcmp_case(argv[i],"-C") && !strcmp_case(argv[i+2],"-W")){
            
            ncryst=atoi(argv[i+1]);
            nwave=atoi(argv[i+3]);
            nset++;
            
            for(k=i+3; k<argc-1; k++){
                if(!strcmp_case(argv[k], "-C")
                   || !strcmp_case(argv[k], "-rt")
                   || !strcmp_case(argv[k], "-rp")

                   ) {
                    i=k-1;					
                    break;
                }
                
                if(!strcmp_case(argv[k],"-idat") || !strcmp_case(argv[k],"-icif")){
                    strcpy(infile, argv[k+1]);
                    
                    n=cif_or_mmcif(infile);
                    if(n==0){ //non cif or mmcif
                        if(nset==1){
                            format=data_format(infile, prog);
                            strcpy(blockid,"phasing_set");
                            write_sf_header(fout,prog, blockid,format);
                            
                            if(!strcmp_case(prog, "other")){
                                if(!strcmp_case(I_F_type,"F")){
                                    sf_header(fout, 0, 1, 0, 0);
                                }else if(!strcmp_case(I_F_type,"I")){
                                    sf_header(fout, 0, 0, 1, 0);
                                }
                            }
                        }
                        write_data(fout, ncryst, nwave,scale, infile, prog,I_F_type, format);
                    }else if(n==2){
                        printf("Input data file name = %s : (format mmCIF)\n", infile);
                        sprintf(blockid,"phasing_set_%d", nset);
                        write_sf_mmcif(fout,infile, blockid);
                    }
                }
            }
        }
    
    }

    fprintf(fout, "# END OF REFLECTIONS\n");
/*    
    if(strcmp_case(I_F_type, "I")){
        printf("/Note: The given data type (%s) is not intensity!\n", I_F_type);
        printf("It is recommended to deposit original scaled data.\n");
    }
*/
}

void write_data(FILE *fout, int ncryst, int nwave, int scale, 
                char *filename, char *prog, char *I_F_type, int format)
/* write initial data from here */
{
    
    if(!strcmp_case(prog, "HKL")){
        printf("HKL/SCALEPACK data file = %s\n",filename);
        write_hkl(fout, filename, ncryst, nwave, scale, format);
        
    }else if (!strcmp_case(prog, "3DSCALE")){
        printf("3DSCALE data file = %s\n",filename);
        write_hkl(fout, filename, ncryst, nwave, scale, format);
        
    }else if(!strcmp_case(prog, "DTREK")){
        printf("D*TREK data file = %s\n",filename);
        write_dtrek(fout, filename, ncryst, nwave, scale, format);
        
    }else if(!strcmp_case(prog, "XSCALE")){
        printf("XSCALE data file = %s\n",filename);
        write_xscale(fout, filename, ncryst, nwave, scale, format);
        
/* a program for MAR CCD detector*/
    }else if(!strcmp_case(prog, "SAINT") || !strcmp_case(prog, "XPREP")){   
        
        printf("SAINT data file = %s\n",filename);
        write_saint(fout, filename, ncryst, nwave, scale, 1);
        
    }else if(!strcmp_case(prog, "CNS") || !strcmp_case(prog, "X-PLOR")){   
        
        printf("CNS data file = %s\n",filename);
        write_cns(fout, filename, ncryst, nwave, scale, format);
        
    }else if(!strcmp_case(prog, "other") ){
        printf("OTHER data file = %s\n",filename);
        write_other(fout, filename, ncryst, nwave, scale);
    }
    
}

int data_format(char *filename, char *prog)
/* get various format from the program used */
{
    char **line, tmp[256];
    int len=0, n=0, f1=0, f2=0, f3=0, f4=0,i, i1, nline,  format=0;
    float a1,a2,a3,a4,a5,a6;

    line=get_lines_from_file(filename, &nline);

/* get the right format for HKL2000/scalepack
    
1, NO ANOMALOUS flag ----- h, k, l, I, sigma(I)  (3I4, 2F8.1) length=28
2, WITH ANOMALOUS flag --- h, k, l, I+, sigma(I+), I-, sigma(I-) ;
   (3I4, 4F8.1) length=44
3, NO MERGE  --- h, k, l, asymmetric unit #, I, sigma(I) ; (4I4,2F8.1)  
   ANOMALOUS flag has no effect.  length=32
4, NO MERGE original index --- original hkl, unique hkl, batch (film)
   number, a flag (0 = centric, 1 = I+, 2 = I-), another flag (0 =
   hkl reflecting above the spindle, 1 = hkl reflecting below the spindle), 
   the asymmetric unit of the reflection, I (scaled, Lorentz and Polarization
   corrected), and the sigma of I. The format is (6i4, i6, 2i2, i3, 2f8.1).
   (RAW data!!)  length=53

*/
    if(nline<100){
        printf("Warning! The file contains too few reflection.\n");
        printf("No conversion was performed!\n");
        return 0;
    }
    

    if(!strcmp_case(prog, "HKL")){
        for(i=0; i<nline; i++){
            len=strlen(line[i]);
            if(len>61){
                n=sscanf(line[i], "%f%f%f%f%f%f", &a1,&a2,&a3,&a4,&a5,&a6 );
                if(n==6){
                    cryst.a=a1;
                    cryst.b=a2;
                    cryst.c=a3;
                    cryst.alpha=a4;
                    cryst.beta=a5;
                    cryst.gamma=a6;
                    get_string(line[i], 60, 70, cryst.sym);
                    break;
                }
            }
        }
        
        
        
        for(i=20; i<nline; i++){
            rid_of_end_space(line[i]);
            len=strlen(line[i]);
            if(len<29) {
                f1++;
            }else if(len ==44 || len ==45){
                f2++;
            }else if(len ==35 || len ==36){
                f3++;
            }else if(len ==53 || len ==54){
                f4++;
            }
        }
        if(nline>100){
            if(f1>50 && f2<50){ //format=1
                format=1;
            }else if (f2>50){ //format=2
                format=2;
            }else if (f3>50){ //format=3
                format=3;
            }else if (f4>50){ //format=4
                format=4;
            }
        }
        
    }else if(!strcmp_case(prog, "dtrek")){
        
 /* there are several output free format for dtrek  (free format)
1, NO ANOMALOUS flag ----- h, k, l, I, sigma(I)
2, NO ANOMALOUS flag, no head.
3, WITH ANOMALOUS flag --- h, k, l, I, sigma(I), I+, sigma(I+), I-, sigma(I-) ;
4, WITH ANOMALOUS flag,  1 but no head.
 */

        for(i=0; i<100; i++){
            if(pattern5(line[i], "CRYSTAL_SPACEGROUP=", ";", "", "","")){
                cryst.nsym=get_int_after_id(line[i], "=");
            }else if(pattern5(line[i], "CRYSTAL_UNIT_CELL=", ";", "", "","")){
                get_data_set_id(line[i], "CELL=", ";",tmp);
                
                n=sscanf(tmp, "%f%f%f%f%f%f", &a1,&a2,&a3,&a4,&a5,&a6 );
                if(n==6){
                    cryst.a=a1;
                    cryst.b=a2;
                    cryst.c=a3;
                    cryst.alpha=a4;
                    cryst.beta=a5;
                    cryst.gamma=a6;
                    break;
                }
            }
        }
        

        f1=0;
        f2=0;
        for(i=40; i<nline; i++){
            n=sscanf(line[i], "%d %d %d %f %f %f %f %f %f",
                     &i1,&i1,&i1, &a1,&a1,&a1,&a1,&a1,&a1);
            if(n==5) f1++;
            if(n==9) f2++;
            if(f1>100 || f2>100) break;
            
        }
        if(f1>100 && f2==0){
            format=1;
        }else if(f2>100 && f1==0){
            format=2;
        }
        
    }else if(!strcmp_case(prog, "xscale")){
/* Free format: 
1, NO ANOMALOUS flag ----- h, k, l, I, sigma(I)
2, WITH ANOMALOUS flag --- h, k, l, I, sigma(I), I+, sigma(I+), I-, sigma(I-) ;
*/        

        for(i=0; i<100; i++){
            if(pattern5(line[i], "!SPACE_GROUP_NUMBER=", "", "", "","")){
                cryst.nsym=get_int_after_id(line[i], "=");
            }else if(pattern5(line[i], "!UNIT_CELL_CONSTANTS= ", "", "", "","")){
                get_data_set_id(line[i], "=", "\n",tmp);
                
                n=sscanf(tmp, "%f%f%f%f%f%f", &a1,&a2,&a3,&a4,&a5,&a6 );
                if(n==6){
                    cryst.a=a1;
                    cryst.b=a2;
                    cryst.c=a3;
                    cryst.alpha=a4;
                    cryst.beta=a5;
                    cryst.gamma=a6;
                    break;
                }
            }
        }

        f1=0;
        f2=0;
        for(i=40; i<nline; i++){
            n=sscanf(line[i], "%d %d %d %f %f %f %f  %f %f ",
                     &i1,&i1,&i1, &a1,&a1,&a1,&a1,&a1,&a1);
            if(n==5 || n==9) f1++;
            if(n==7) f2++;
            if(f1>50 || f2>50) break;
        }
        
        if(f1>50 && f2==0){
            format=1;
        }else if(f2>50 && f1==0){
            format=2;
        }
        

    }else if(!strcmp_case(prog, "saint")){

/* For saint only use the raw data (integrated and scaled) format */
        f1=0;
        for(i=40; i<nline; i++){
            n=sscanf(line[i], "%d %d %d %f %f %f %f %f %f %f %f",
                     &i1,&i1,&i1, &a1,&a1,&a1,&a1,&a1,&a1,&a1,&a1);
            if(f1>=10 && strlen(line[i])>200){
                if(f1++>=100) break;
            }
        }
        if(f1>100 ){
            format=1;
        }


    }else if(!strcmp_case(prog, "cns") || !strcmp_case(prog, "x-plor")){

        f1=0;
        for(i=40; i<100; i++){
            if(strstr_case(line[i], "FOBS=")){
                format=1;
                break;
            }else if(strstr_case(line[i], "IOBS=")){
                format=2;
                break;
            }
        }
    }

    
    if(nline>0)free_memory_2d(line, nline);
    
    return format;
}
    
///////////////////////////////////////////////

void write_hkl(FILE *fout, char *filename,
               int crystal, int wave, int scale, int format)
    
{
    char str[100], h[10], k[10], l[10], i[10], si[10], im[10], sim[10];
    int  k1=0, k2=0, k3=0, k4=0, len=0, n=0;
    FILE  *finp;
    
    if((finp = fopen(filename, "r"))==NULL) {
        open_file_error(filename, "write_hkl");
    }
    
    while (fgets(str, sizeof str, finp) != NULL) {
        rid_of_end_space(str);
        len=strlen(str);
        if(sscanf(str, "%d%d%d", &n, &n, &n) != 3) continue;
        if(!strchr(str, '.'))continue;
        
        if(len > 27 && len <62 ){
            get_string(str, 0, 3, h);
            get_string(str, 4, 7, k);
            get_string(str, 8, 11, l);
        }
        strcpy(i,"?");
        strcpy(si,"?");
        strcpy(im,"?");
        strcpy(sim,"?");
        
        if(format==1 || format==3 || format==4){ //no anomalous

            if(len==28 || len==29 ){
                k1=1;
                get_string(str, 12, 19, i);
                get_string(str, 20, 27, si);
                fprintf(fout,"%d %d %d %4s %4s %4s %8s %6s\n",
                        crystal,wave,scale, h,k,l, i, si);
           
            }else if(len==35 || len==36){
                k3=1;
                get_string(str, 19, 26, i);
                get_string(str, 27, 34, si);
                fprintf(fout,"%d %d %d %4s %4s %4s %8s %6s\n",
                        crystal,wave,scale, h,k,l, i, si);
               
            }else if(len==53 || len==54){
                k4=1;
                get_string(str, 37, 44, i);
                get_string(str, 45, 52, si);
                fprintf(fout,"%d %d %d %4s %4s %4s %8s %6s\n",
                        crystal,wave,scale, h,k,l, i, si);
            }
                
            
        }else if(format==2){ // with anomalous
            k2=1;
            get_string(str, 12, 19, i);
            get_string(str, 20, 27, si);
            
            get_string(str, 28, 35, im);
            get_string(str, 36, 43, sim);
            
            fprintf(fout,"%d %d %d %4s %4s %4s %8s %6s %8s %6s\n",
                    crystal,wave,scale, h,k,l, i, si, im, sim);
        }
    }
    
    if((format==1 || format==3 || format==4) && (k1==0 && k3==0 && k4==0 )){
        fprintf(fout, " ? ? ?  ? ? ?  ? ? \n");  
        printf("Warning! The HKL/SCALEPACK format is wrong!\n");
        printf("Please check the supported version by pdb_extract!\n");
    }else if (format==2 && k2==0){
        fprintf(fout, " ? ? ?  ? ? ?  ? ? ? ? \n");  
        printf("Warning! The HKL/SCALEPACK format is wrong!\n");
        printf("Please check the supported version by pdb_extract!\n");
    }
    
    fclose(finp);
    
}


void write_dtrek(FILE *fout, char *filename,
               int crystal, int wave, int scale, int format)

/* write reflections from d*trek */
{
    char str[MAXL];
    int h=0, k=0,k1=0,k2=0, l=0, m;
    float i, sigmai, plus_i, plus_s, minus_i, minus_s;
    FILE *finp;

    if((finp = fopen(filename, "r"))==NULL) {        
        printf("Can not open the file:  %s\n",filename);
        exit(0);
    }

    while (fgets(str, sizeof str, finp) != NULL) {
        i=0; sigmai=0; plus_i=0; plus_s=0; minus_i=0; minus_s=0;
        m=sscanf(str, " %d%d%d %f%f %f%f %f%f",&h, &k, &l, &i,
                 &sigmai, &plus_i, &plus_s, &minus_i, &minus_s);
        if(format==1 && m==5){
            k1=1;
            fprintf(fout,"%d %d %d %4d %4d %4d %9.2f %7.2f \n",
                    crystal, wave,scale, h, k, l, i, sigmai);
            
        }else if (format==2 && m==9){
            k2=1;
            fprintf(fout,"%d %d %d %4d %4d %4d %9.2f %7.2f %9.2f %7.2f %9.2f %7.2f\n",
                    crystal, wave,scale, h, k, l, i, sigmai, plus_i, plus_s, minus_i, minus_s);
        }
    }
    if(format==1  && k1==0){
        fprintf(fout, " ? ? ?  ? ? ?  ? ? \n");  
        printf("Warning! The d*TREK format is wrong!\n");
        printf("Please check the supported version by pdb_extract!\n");
    }else if (format==2 && k2==0){
        fprintf(fout, " ? ? ?  ? ? ?  ? ? ? ? ? ? \n");  
        printf("Warning! The d*TREK  format is wrong!\n");
        printf("Please check the supported version by pdb_extract!\n");
    }
}

void write_xscale(FILE *fout, char *filename,
              int crystal, int wave,int scale, int format)

/* write reflections from xscale*/
{
    char str[MAXL];
    int h=0, k=0,k1=0,k2=0, l=0, m;
    float i, sigmai, plus_i, plus_s, minus_i, minus_s;
    FILE *finp;

    if((finp = fopen(filename, "r"))==NULL) {        
        printf("Can not open the file:  %s\n",filename);
        exit(0);
    }

    while (fgets(str, sizeof str, finp) != NULL) {
        i=0; sigmai=0; plus_i=0; plus_s=0;
        m=sscanf(str, " %d%d%d %f%f %f%f %f%f",&h, &k, &l, &i,
                 &sigmai, &plus_i, &plus_s, &minus_i, &minus_s);
        
        if(format==1 &&( m==5 || m==9)){
            k1=1;
            fprintf(fout,"%d %d %d %4d %4d %4d %9.2f %7.2f \n",
                    crystal, wave,scale, h, k, l, i, sigmai);
            
        }else if(format==2 && m==7){
            k2=1;
            fprintf(fout,"%d %d %d %4d %4d %4d %9.2f %7.2f %9.2f %7.2f \n",
                    crystal, wave,scale, h, k, l, i, sigmai, plus_i, plus_s);
        }
    }
    if(format==1  && k1==0){
        fprintf(fout, " ? ? ?  ? ? ?  ? ? \n");  
        printf("Warning! The XSCALE format is wrong!\n");
        printf("Please check the supported version by pdb_extract!\n");
    }else if (format==2 && k2==0){
        fprintf(fout, " ? ? ?  ? ? ?  ? ? ? ? \n");  
        printf("Warning! The XSCALE  format is wrong!\n");
        printf("Please check the supported version by pdb_extract!\n");
    }
}

void write_saint(FILE *fout, char *filename,
               int crystal, int wave, int scale, int format)
/* write reflections from SAINT */
{
    char str[MAXL], substr[40];
    int h=0, k=0,k1=0, l=0;
    float f=0, sf=0;
    FILE *finp;

    if((finp = fopen(filename, "r"))==NULL) {        
        printf("Can not open the file:  %s\n",filename);
        exit(0);
    }

    while (fgets(str, sizeof str, finp) != NULL) {
        if(strlen(str)>200){
            k1=1;
            get_string(str, 0, 4, substr);
            h=atoi(substr);
            
            get_string(str, 4, 8, substr);
            k=atoi(substr);
            
            get_string(str, 8, 12, substr);
            l=atoi(substr);
            
            get_string(str, 12, 20, substr);
            f=atof(substr);
            
            get_string(str, 20, 28, substr);
            sf=atof(substr);
            
            fprintf(fout,"%d %d %d %4d %4d %4d %9.2f %7.2f\n",
                    crystal, wave, scale, h, k, l, f, sf);
        }
    }
    fclose(finp);
    
    if((format==1  && k1==0) || format==0){
        fprintf(fout, " ? ? ?  ? ? ?  ? ? \n");  
        printf("Warning! The SAINT format is wrong!\n");
        printf("Please check the supported version by pdb_extract!\n");
    }
    
}


void write_other(FILE *fout, char *filename, int ncryst, int nwave, int scale)
{
    char  str[MAXL];
    int H, K, L;
    float  F, sF;
    long n=0;
    FILE *fp;
    
    if((fp = fopen(filename, "r"))==NULL) {
        open_file_error(filename, "write_other");
    }

    while (fgets(str, sizeof str, fp) != NULL) {
        if(sscanf(str, " %d %d %d %f %f", &H, &K, &L, &F, &sF)==5){
            n++;
            fprintf(fout,"%d %d %d %4d %4d %4d %9.2f %7.2f \n",
                    ncryst, nwave, scale, H, K, L, F, sF);
        }
    }
    if(n<100){
        printf("Warning! There may be problems for conversion from OTHER to mmcif.\n");
        fprintf(fout,"1 1 1 ? ? ?  ? ?  \n");
    }
    fclose(fp);
}


void write_cns(FILE *fout,  char *file_name,
               int ncryst, int nwave, int scale, int format)
/* write the  reflection data for refinement by CNS */
{
    char str[256],line[512];
    int  nlen=0, len;
    FILE *finp;
    
    if((finp = fopen(file_name, "r"))==NULL) {
        open_file_error(file_name, "cns_reflection");
    }
    
    while (fgets(str, sizeof str, finp) != NULL) { 
        if(strstr_case(str,"INDE")){
            strcpy(line, str);
            
            while (fgets(str, sizeof str, finp) != NULL){
                if(!strstr_case(str,"INDE")){
                    len=strlen(line);
                    if(len>=nlen-80) break;
                    strcat(line, str);  /* align  */
                    
                }else {
                    print_cns(fout, line, ncryst, nwave,scale, format);
                    strcpy(line, str);
                }
            }
            print_cns(fout, line, ncryst, nwave,scale, format);            
            
        }
    }
    fclose(finp);
    
}

    
void print_cns(FILE *fout, char *line,
               int ncryst, int nwave,int scale, int format)           
{
    int H=0,K=0,L=0;
    float a=0, sa=0;

    if(sscanf(line,"%*s%d%d%d",&H,&K,&L)!=3) return;
    fprintf(fout,"%d %d %d %3d %3d %3d  ",ncryst,nwave,scale, H,K,L);
    
    if(format==1) { // F
        
        if(strstr_case(line, "FOBS=")) a = get_float(line, "FOBS=", "\n");
        if(strstr_case(line, "SIGMA=")) sa = get_float(line, "SIGMA=", "\n");
    }else if (format==2) { // I
    
        if(strstr_case(line, "IOBS=")) a = get_float(line, "IOBS=", "\n");
        if(strstr_case(line, "SIGI=")) sa = get_float(line, "SIGI=", "\n");
    }
    fprintf(fout,"%9.3f %7.3f \n", a, sa) ;
    
    
}


